/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/ethernet/ethernet_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_arp_api_fromjson_h
#define included_arp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_proxy_arp_t_fromjson (void *mp, int *len, cJSON *o, vl_api_proxy_arp_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "low");
    if (!item) return 0;
    // start field low
    mp = vl_api_ip4_address_t_fromjson(mp, len, item, &a->low);
    if (!mp) return 0;
    // end field low
    item = cJSON_GetObjectItem(o, "hi");
    if (!item) return 0;
    // start field hi
    mp = vl_api_ip4_address_t_fromjson(mp, len, item, &a->hi);
    if (!mp) return 0;
    // end field hi
    return mp;
}
static inline vl_api_proxy_arp_add_del_t *vl_api_proxy_arp_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_add_del_t);
    vl_api_proxy_arp_add_del_t *a = malloc(l);
    // processing proxy_arp_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing proxy_arp_add_del: vl_api_proxy_arp_t proxy
    item = cJSON_GetObjectItem(o, "proxy");
    if (!item) return 0;
    // start field proxy
    a = vl_api_proxy_arp_t_fromjson(a, &l, item, &a->proxy);
    if (!a) return 0;
    // end field proxy


    *len = l;
    return a;
}
static inline vl_api_proxy_arp_add_del_reply_t *vl_api_proxy_arp_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_add_del_reply_t);
    vl_api_proxy_arp_add_del_reply_t *a = malloc(l);
    // processing proxy_arp_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_proxy_arp_dump_t *vl_api_proxy_arp_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_dump_t);
    vl_api_proxy_arp_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_proxy_arp_details_t *vl_api_proxy_arp_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_details_t);
    vl_api_proxy_arp_details_t *a = malloc(l);
    // processing proxy_arp_details: vl_api_proxy_arp_t proxy
    item = cJSON_GetObjectItem(o, "proxy");
    if (!item) return 0;
    // start field proxy
    a = vl_api_proxy_arp_t_fromjson(a, &l, item, &a->proxy);
    if (!a) return 0;
    // end field proxy


    *len = l;
    return a;
}
static inline vl_api_proxy_arp_intfc_enable_disable_t *vl_api_proxy_arp_intfc_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_intfc_enable_disable_t);
    vl_api_proxy_arp_intfc_enable_disable_t *a = malloc(l);
    // processing proxy_arp_intfc_enable_disable: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing proxy_arp_intfc_enable_disable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_proxy_arp_intfc_enable_disable_reply_t *vl_api_proxy_arp_intfc_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_intfc_enable_disable_reply_t);
    vl_api_proxy_arp_intfc_enable_disable_reply_t *a = malloc(l);
    // processing proxy_arp_intfc_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_proxy_arp_intfc_dump_t *vl_api_proxy_arp_intfc_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_intfc_dump_t);
    vl_api_proxy_arp_intfc_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_proxy_arp_intfc_details_t *vl_api_proxy_arp_intfc_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_proxy_arp_intfc_details_t);
    vl_api_proxy_arp_intfc_details_t *a = malloc(l);
    // processing proxy_arp_intfc_details: u32 sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    vl_api_u32_fromjson(item, &a->sw_if_index);
    // end field sw_if_index


    *len = l;
    return a;
}
#endif
