/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_classify_api_fromjson_h
#define included_classify_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_classify_action_t_fromjson (void *mp, int *len, cJSON *o, vl_api_classify_action_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "CLASSIFY_API_ACTION_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "CLASSIFY_API_ACTION_SET_IP4_FIB_INDEX") == 0) {*a = 1; return mp;}
    if (strcmp(p, "CLASSIFY_API_ACTION_SET_IP6_FIB_INDEX") == 0) {*a = 2; return mp;}
    if (strcmp(p, "CLASSIFY_API_ACTION_SET_METADATA") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_policer_classify_table_t_fromjson (void *mp, int *len, cJSON *o, vl_api_policer_classify_table_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "POLICER_CLASSIFY_API_TABLE_IP4") == 0) {*a = 1; return mp;}
    if (strcmp(p, "POLICER_CLASSIFY_API_TABLE_IP6") == 0) {*a = 2; return mp;}
    if (strcmp(p, "POLICER_CLASSIFY_API_TABLE_L2") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_flow_classify_table_t_fromjson (void *mp, int *len, cJSON *o, vl_api_flow_classify_table_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "FLOW_CLASSIFY_API_TABLE_IP4") == 0) {*a = 1; return mp;}
    if (strcmp(p, "FLOW_CLASSIFY_API_TABLE_IP6") == 0) {*a = 2; return mp;}
   return 0;
}
static inline vl_api_classify_add_del_table_t *vl_api_classify_add_del_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_add_del_table_t);
    vl_api_classify_add_del_table_t *a = malloc(l);
    // processing classify_add_del_table: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing classify_add_del_table: bool del_chain
    item = cJSON_GetObjectItem(o, "del_chain");
    if (!item) return 0;
    // start field del_chain
    vl_api_bool_fromjson(item, &a->del_chain);
    // end field del_chain

    // processing classify_add_del_table: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index

    // processing classify_add_del_table: u32 nbuckets
    item = cJSON_GetObjectItem(o, "nbuckets");
    if (!item) return 0;
    // start field nbuckets
    vl_api_u32_fromjson(item, &a->nbuckets);
    // end field nbuckets

    // processing classify_add_del_table: u32 memory_size
    item = cJSON_GetObjectItem(o, "memory_size");
    if (!item) return 0;
    // start field memory_size
    vl_api_u32_fromjson(item, &a->memory_size);
    // end field memory_size

    // processing classify_add_del_table: u32 skip_n_vectors
    item = cJSON_GetObjectItem(o, "skip_n_vectors");
    if (!item) return 0;
    // start field skip_n_vectors
    vl_api_u32_fromjson(item, &a->skip_n_vectors);
    // end field skip_n_vectors

    // processing classify_add_del_table: u32 match_n_vectors
    item = cJSON_GetObjectItem(o, "match_n_vectors");
    if (!item) return 0;
    // start field match_n_vectors
    vl_api_u32_fromjson(item, &a->match_n_vectors);
    // end field match_n_vectors

    // processing classify_add_del_table: u32 next_table_index
    item = cJSON_GetObjectItem(o, "next_table_index");
    if (!item) return 0;
    // start field next_table_index
    vl_api_u32_fromjson(item, &a->next_table_index);
    // end field next_table_index

    // processing classify_add_del_table: u32 miss_next_index
    item = cJSON_GetObjectItem(o, "miss_next_index");
    if (!item) return 0;
    // start field miss_next_index
    vl_api_u32_fromjson(item, &a->miss_next_index);
    // end field miss_next_index

    // processing classify_add_del_table: u8 current_data_flag
    item = cJSON_GetObjectItem(o, "current_data_flag");
    if (!item) return 0;
    // start field current_data_flag
    vl_api_u8_fromjson(item, &a->current_data_flag);
    // end field current_data_flag

    // processing classify_add_del_table: i16 current_data_offset
    item = cJSON_GetObjectItem(o, "current_data_offset");
    if (!item) return 0;
    // start field current_data_offset
    vl_api_i16_fromjson(item, &a->current_data_offset);
    // end field current_data_offset

    // processing classify_add_del_table: u8 mask
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    s = u8string_fromjson(o, "mask");
    if (!s) return 0;
    a->mask_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_classify_add_del_table_reply_t *vl_api_classify_add_del_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_add_del_table_reply_t);
    vl_api_classify_add_del_table_reply_t *a = malloc(l);
    // processing classify_add_del_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_add_del_table_reply: u32 new_table_index
    item = cJSON_GetObjectItem(o, "new_table_index");
    if (!item) return 0;
    // start field new_table_index
    vl_api_u32_fromjson(item, &a->new_table_index);
    // end field new_table_index

    // processing classify_add_del_table_reply: u32 skip_n_vectors
    item = cJSON_GetObjectItem(o, "skip_n_vectors");
    if (!item) return 0;
    // start field skip_n_vectors
    vl_api_u32_fromjson(item, &a->skip_n_vectors);
    // end field skip_n_vectors

    // processing classify_add_del_table_reply: u32 match_n_vectors
    item = cJSON_GetObjectItem(o, "match_n_vectors");
    if (!item) return 0;
    // start field match_n_vectors
    vl_api_u32_fromjson(item, &a->match_n_vectors);
    // end field match_n_vectors


    *len = l;
    return a;
}
static inline vl_api_classify_add_del_session_t *vl_api_classify_add_del_session_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_add_del_session_t);
    vl_api_classify_add_del_session_t *a = malloc(l);
    // processing classify_add_del_session: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing classify_add_del_session: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index

    // processing classify_add_del_session: u32 hit_next_index
    item = cJSON_GetObjectItem(o, "hit_next_index");
    if (!item) return 0;
    // start field hit_next_index
    vl_api_u32_fromjson(item, &a->hit_next_index);
    // end field hit_next_index

    // processing classify_add_del_session: u32 opaque_index
    item = cJSON_GetObjectItem(o, "opaque_index");
    if (!item) return 0;
    // start field opaque_index
    vl_api_u32_fromjson(item, &a->opaque_index);
    // end field opaque_index

    // processing classify_add_del_session: i32 advance
    item = cJSON_GetObjectItem(o, "advance");
    if (!item) return 0;
    // start field advance
    vl_api_i32_fromjson(item, &a->advance);
    // end field advance

    // processing classify_add_del_session: vl_api_classify_action_t action
    item = cJSON_GetObjectItem(o, "action");
    if (!item) return 0;
    // start field action
    a = vl_api_classify_action_t_fromjson(a, &l, item, &a->action);
    if (!a) return 0;
    // end field action

    // processing classify_add_del_session: u32 metadata
    item = cJSON_GetObjectItem(o, "metadata");
    if (!item) return 0;
    // start field metadata
    vl_api_u32_fromjson(item, &a->metadata);
    // end field metadata

    // processing classify_add_del_session: u8 match
    item = cJSON_GetObjectItem(o, "match");
    if (!item) return 0;
    s = u8string_fromjson(o, "match");
    if (!s) return 0;
    a->match_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_classify_add_del_session_reply_t *vl_api_classify_add_del_session_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_add_del_session_reply_t);
    vl_api_classify_add_del_session_reply_t *a = malloc(l);
    // processing classify_add_del_session_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_policer_classify_set_interface_t *vl_api_policer_classify_set_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_classify_set_interface_t);
    vl_api_policer_classify_set_interface_t *a = malloc(l);
    // processing policer_classify_set_interface: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing policer_classify_set_interface: u32 ip4_table_index
    item = cJSON_GetObjectItem(o, "ip4_table_index");
    if (!item) return 0;
    // start field ip4_table_index
    vl_api_u32_fromjson(item, &a->ip4_table_index);
    // end field ip4_table_index

    // processing policer_classify_set_interface: u32 ip6_table_index
    item = cJSON_GetObjectItem(o, "ip6_table_index");
    if (!item) return 0;
    // start field ip6_table_index
    vl_api_u32_fromjson(item, &a->ip6_table_index);
    // end field ip6_table_index

    // processing policer_classify_set_interface: u32 l2_table_index
    item = cJSON_GetObjectItem(o, "l2_table_index");
    if (!item) return 0;
    // start field l2_table_index
    vl_api_u32_fromjson(item, &a->l2_table_index);
    // end field l2_table_index

    // processing policer_classify_set_interface: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_policer_classify_set_interface_reply_t *vl_api_policer_classify_set_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_classify_set_interface_reply_t);
    vl_api_policer_classify_set_interface_reply_t *a = malloc(l);
    // processing policer_classify_set_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_policer_classify_dump_t *vl_api_policer_classify_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_classify_dump_t);
    vl_api_policer_classify_dump_t *a = malloc(l);
    // processing policer_classify_dump: vl_api_policer_classify_table_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_policer_classify_table_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type

    // processing policer_classify_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_policer_classify_details_t *vl_api_policer_classify_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_classify_details_t);
    vl_api_policer_classify_details_t *a = malloc(l);
    // processing policer_classify_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing policer_classify_details: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_table_ids_t *vl_api_classify_table_ids_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_ids_t);
    vl_api_classify_table_ids_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_classify_table_ids_reply_t *vl_api_classify_table_ids_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_ids_reply_t);
    vl_api_classify_table_ids_reply_t *a = malloc(l);
    // processing classify_table_ids_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_table_ids_reply: u32 ids
    item = cJSON_GetObjectItem(o, "ids");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "ids");
        int size = cJSON_GetArraySize(array);
        a->count = size;
        a = realloc(a, l + sizeof(u32) * size);
        u32 *d = (void *)a + l;
        l += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }


    *len = l;
    return a;
}
static inline vl_api_classify_table_by_interface_t *vl_api_classify_table_by_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_by_interface_t);
    vl_api_classify_table_by_interface_t *a = malloc(l);
    // processing classify_table_by_interface: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_classify_table_by_interface_reply_t *vl_api_classify_table_by_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_by_interface_reply_t);
    vl_api_classify_table_by_interface_reply_t *a = malloc(l);
    // processing classify_table_by_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_table_by_interface_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing classify_table_by_interface_reply: u32 l2_table_id
    item = cJSON_GetObjectItem(o, "l2_table_id");
    if (!item) return 0;
    // start field l2_table_id
    vl_api_u32_fromjson(item, &a->l2_table_id);
    // end field l2_table_id

    // processing classify_table_by_interface_reply: u32 ip4_table_id
    item = cJSON_GetObjectItem(o, "ip4_table_id");
    if (!item) return 0;
    // start field ip4_table_id
    vl_api_u32_fromjson(item, &a->ip4_table_id);
    // end field ip4_table_id

    // processing classify_table_by_interface_reply: u32 ip6_table_id
    item = cJSON_GetObjectItem(o, "ip6_table_id");
    if (!item) return 0;
    // start field ip6_table_id
    vl_api_u32_fromjson(item, &a->ip6_table_id);
    // end field ip6_table_id


    *len = l;
    return a;
}
static inline vl_api_classify_table_info_t *vl_api_classify_table_info_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_info_t);
    vl_api_classify_table_info_t *a = malloc(l);
    // processing classify_table_info: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id


    *len = l;
    return a;
}
static inline vl_api_classify_table_info_reply_t *vl_api_classify_table_info_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_table_info_reply_t);
    vl_api_classify_table_info_reply_t *a = malloc(l);
    // processing classify_table_info_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_table_info_reply: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing classify_table_info_reply: u32 nbuckets
    item = cJSON_GetObjectItem(o, "nbuckets");
    if (!item) return 0;
    // start field nbuckets
    vl_api_u32_fromjson(item, &a->nbuckets);
    // end field nbuckets

    // processing classify_table_info_reply: u32 match_n_vectors
    item = cJSON_GetObjectItem(o, "match_n_vectors");
    if (!item) return 0;
    // start field match_n_vectors
    vl_api_u32_fromjson(item, &a->match_n_vectors);
    // end field match_n_vectors

    // processing classify_table_info_reply: u32 skip_n_vectors
    item = cJSON_GetObjectItem(o, "skip_n_vectors");
    if (!item) return 0;
    // start field skip_n_vectors
    vl_api_u32_fromjson(item, &a->skip_n_vectors);
    // end field skip_n_vectors

    // processing classify_table_info_reply: u32 active_sessions
    item = cJSON_GetObjectItem(o, "active_sessions");
    if (!item) return 0;
    // start field active_sessions
    vl_api_u32_fromjson(item, &a->active_sessions);
    // end field active_sessions

    // processing classify_table_info_reply: u32 next_table_index
    item = cJSON_GetObjectItem(o, "next_table_index");
    if (!item) return 0;
    // start field next_table_index
    vl_api_u32_fromjson(item, &a->next_table_index);
    // end field next_table_index

    // processing classify_table_info_reply: u32 miss_next_index
    item = cJSON_GetObjectItem(o, "miss_next_index");
    if (!item) return 0;
    // start field miss_next_index
    vl_api_u32_fromjson(item, &a->miss_next_index);
    // end field miss_next_index

    // processing classify_table_info_reply: u8 mask
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    s = u8string_fromjson(o, "mask");
    if (!s) return 0;
    a->mask_length = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_classify_session_dump_t *vl_api_classify_session_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_session_dump_t);
    vl_api_classify_session_dump_t *a = malloc(l);
    // processing classify_session_dump: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id


    *len = l;
    return a;
}
static inline vl_api_classify_session_details_t *vl_api_classify_session_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_session_details_t);
    vl_api_classify_session_details_t *a = malloc(l);
    // processing classify_session_details: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_session_details: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing classify_session_details: u32 hit_next_index
    item = cJSON_GetObjectItem(o, "hit_next_index");
    if (!item) return 0;
    // start field hit_next_index
    vl_api_u32_fromjson(item, &a->hit_next_index);
    // end field hit_next_index

    // processing classify_session_details: i32 advance
    item = cJSON_GetObjectItem(o, "advance");
    if (!item) return 0;
    // start field advance
    vl_api_i32_fromjson(item, &a->advance);
    // end field advance

    // processing classify_session_details: u32 opaque_index
    item = cJSON_GetObjectItem(o, "opaque_index");
    if (!item) return 0;
    // start field opaque_index
    vl_api_u32_fromjson(item, &a->opaque_index);
    // end field opaque_index

    // processing classify_session_details: u8 match
    item = cJSON_GetObjectItem(o, "match");
    if (!item) return 0;
    s = u8string_fromjson(o, "match");
    if (!s) return 0;
    a->match_length = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_flow_classify_set_interface_t *vl_api_flow_classify_set_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_flow_classify_set_interface_t);
    vl_api_flow_classify_set_interface_t *a = malloc(l);
    // processing flow_classify_set_interface: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing flow_classify_set_interface: u32 ip4_table_index
    item = cJSON_GetObjectItem(o, "ip4_table_index");
    if (!item) return 0;
    // start field ip4_table_index
    vl_api_u32_fromjson(item, &a->ip4_table_index);
    // end field ip4_table_index

    // processing flow_classify_set_interface: u32 ip6_table_index
    item = cJSON_GetObjectItem(o, "ip6_table_index");
    if (!item) return 0;
    // start field ip6_table_index
    vl_api_u32_fromjson(item, &a->ip6_table_index);
    // end field ip6_table_index

    // processing flow_classify_set_interface: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_flow_classify_set_interface_reply_t *vl_api_flow_classify_set_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_flow_classify_set_interface_reply_t);
    vl_api_flow_classify_set_interface_reply_t *a = malloc(l);
    // processing flow_classify_set_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_flow_classify_dump_t *vl_api_flow_classify_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_flow_classify_dump_t);
    vl_api_flow_classify_dump_t *a = malloc(l);
    // processing flow_classify_dump: vl_api_flow_classify_table_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_flow_classify_table_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type

    // processing flow_classify_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_flow_classify_details_t *vl_api_flow_classify_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_flow_classify_details_t);
    vl_api_flow_classify_details_t *a = malloc(l);
    // processing flow_classify_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing flow_classify_details: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_set_interface_ip_table_t *vl_api_classify_set_interface_ip_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_set_interface_ip_table_t);
    vl_api_classify_set_interface_ip_table_t *a = malloc(l);
    // processing classify_set_interface_ip_table: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6

    // processing classify_set_interface_ip_table: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing classify_set_interface_ip_table: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_set_interface_ip_table_reply_t *vl_api_classify_set_interface_ip_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_set_interface_ip_table_reply_t);
    vl_api_classify_set_interface_ip_table_reply_t *a = malloc(l);
    // processing classify_set_interface_ip_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_classify_set_interface_l2_tables_t *vl_api_classify_set_interface_l2_tables_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_set_interface_l2_tables_t);
    vl_api_classify_set_interface_l2_tables_t *a = malloc(l);
    // processing classify_set_interface_l2_tables: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing classify_set_interface_l2_tables: u32 ip4_table_index
    item = cJSON_GetObjectItem(o, "ip4_table_index");
    if (!item) return 0;
    // start field ip4_table_index
    vl_api_u32_fromjson(item, &a->ip4_table_index);
    // end field ip4_table_index

    // processing classify_set_interface_l2_tables: u32 ip6_table_index
    item = cJSON_GetObjectItem(o, "ip6_table_index");
    if (!item) return 0;
    // start field ip6_table_index
    vl_api_u32_fromjson(item, &a->ip6_table_index);
    // end field ip6_table_index

    // processing classify_set_interface_l2_tables: u32 other_table_index
    item = cJSON_GetObjectItem(o, "other_table_index");
    if (!item) return 0;
    // start field other_table_index
    vl_api_u32_fromjson(item, &a->other_table_index);
    // end field other_table_index

    // processing classify_set_interface_l2_tables: bool is_input
    item = cJSON_GetObjectItem(o, "is_input");
    if (!item) return 0;
    // start field is_input
    vl_api_bool_fromjson(item, &a->is_input);
    // end field is_input


    *len = l;
    return a;
}
static inline vl_api_classify_set_interface_l2_tables_reply_t *vl_api_classify_set_interface_l2_tables_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_set_interface_l2_tables_reply_t);
    vl_api_classify_set_interface_l2_tables_reply_t *a = malloc(l);
    // processing classify_set_interface_l2_tables_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_input_acl_set_interface_t *vl_api_input_acl_set_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_input_acl_set_interface_t);
    vl_api_input_acl_set_interface_t *a = malloc(l);
    // processing input_acl_set_interface: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing input_acl_set_interface: u32 ip4_table_index
    item = cJSON_GetObjectItem(o, "ip4_table_index");
    if (!item) return 0;
    // start field ip4_table_index
    vl_api_u32_fromjson(item, &a->ip4_table_index);
    // end field ip4_table_index

    // processing input_acl_set_interface: u32 ip6_table_index
    item = cJSON_GetObjectItem(o, "ip6_table_index");
    if (!item) return 0;
    // start field ip6_table_index
    vl_api_u32_fromjson(item, &a->ip6_table_index);
    // end field ip6_table_index

    // processing input_acl_set_interface: u32 l2_table_index
    item = cJSON_GetObjectItem(o, "l2_table_index");
    if (!item) return 0;
    // start field l2_table_index
    vl_api_u32_fromjson(item, &a->l2_table_index);
    // end field l2_table_index

    // processing input_acl_set_interface: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_input_acl_set_interface_reply_t *vl_api_input_acl_set_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_input_acl_set_interface_reply_t);
    vl_api_input_acl_set_interface_reply_t *a = malloc(l);
    // processing input_acl_set_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_output_acl_set_interface_t *vl_api_output_acl_set_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_output_acl_set_interface_t);
    vl_api_output_acl_set_interface_t *a = malloc(l);
    // processing output_acl_set_interface: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing output_acl_set_interface: u32 ip4_table_index
    item = cJSON_GetObjectItem(o, "ip4_table_index");
    if (!item) return 0;
    // start field ip4_table_index
    vl_api_u32_fromjson(item, &a->ip4_table_index);
    // end field ip4_table_index

    // processing output_acl_set_interface: u32 ip6_table_index
    item = cJSON_GetObjectItem(o, "ip6_table_index");
    if (!item) return 0;
    // start field ip6_table_index
    vl_api_u32_fromjson(item, &a->ip6_table_index);
    // end field ip6_table_index

    // processing output_acl_set_interface: u32 l2_table_index
    item = cJSON_GetObjectItem(o, "l2_table_index");
    if (!item) return 0;
    // start field l2_table_index
    vl_api_u32_fromjson(item, &a->l2_table_index);
    // end field l2_table_index

    // processing output_acl_set_interface: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_output_acl_set_interface_reply_t *vl_api_output_acl_set_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_output_acl_set_interface_reply_t);
    vl_api_output_acl_set_interface_reply_t *a = malloc(l);
    // processing output_acl_set_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_lookup_table_t *vl_api_classify_pcap_lookup_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_lookup_table_t);
    vl_api_classify_pcap_lookup_table_t *a = malloc(l);
    // processing classify_pcap_lookup_table: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing classify_pcap_lookup_table: u32 skip_n_vectors
    item = cJSON_GetObjectItem(o, "skip_n_vectors");
    if (!item) return 0;
    // start field skip_n_vectors
    vl_api_u32_fromjson(item, &a->skip_n_vectors);
    // end field skip_n_vectors

    // processing classify_pcap_lookup_table: u32 match_n_vectors
    item = cJSON_GetObjectItem(o, "match_n_vectors");
    if (!item) return 0;
    // start field match_n_vectors
    vl_api_u32_fromjson(item, &a->match_n_vectors);
    // end field match_n_vectors

    // processing classify_pcap_lookup_table: u8 mask
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    s = u8string_fromjson(o, "mask");
    if (!s) return 0;
    a->mask_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_lookup_table_reply_t *vl_api_classify_pcap_lookup_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_lookup_table_reply_t);
    vl_api_classify_pcap_lookup_table_reply_t *a = malloc(l);
    // processing classify_pcap_lookup_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_pcap_lookup_table_reply: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_set_table_t *vl_api_classify_pcap_set_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_set_table_t);
    vl_api_classify_pcap_set_table_t *a = malloc(l);
    // processing classify_pcap_set_table: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing classify_pcap_set_table: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index

    // processing classify_pcap_set_table: bool sort_masks
    item = cJSON_GetObjectItem(o, "sort_masks");
    if (!item) return 0;
    // start field sort_masks
    vl_api_bool_fromjson(item, &a->sort_masks);
    // end field sort_masks


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_set_table_reply_t *vl_api_classify_pcap_set_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_set_table_reply_t);
    vl_api_classify_pcap_set_table_reply_t *a = malloc(l);
    // processing classify_pcap_set_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_pcap_set_table_reply: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_get_tables_t *vl_api_classify_pcap_get_tables_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_get_tables_t);
    vl_api_classify_pcap_get_tables_t *a = malloc(l);
    // processing classify_pcap_get_tables: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_classify_pcap_get_tables_reply_t *vl_api_classify_pcap_get_tables_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_pcap_get_tables_reply_t);
    vl_api_classify_pcap_get_tables_reply_t *a = malloc(l);
    // processing classify_pcap_get_tables_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_pcap_get_tables_reply: u32 indices
    item = cJSON_GetObjectItem(o, "indices");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "indices");
        int size = cJSON_GetArraySize(array);
        a->count = size;
        a = realloc(a, l + sizeof(u32) * size);
        u32 *d = (void *)a + l;
        l += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }


    *len = l;
    return a;
}
static inline vl_api_classify_trace_lookup_table_t *vl_api_classify_trace_lookup_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_lookup_table_t);
    vl_api_classify_trace_lookup_table_t *a = malloc(l);
    // processing classify_trace_lookup_table: u32 skip_n_vectors
    item = cJSON_GetObjectItem(o, "skip_n_vectors");
    if (!item) return 0;
    // start field skip_n_vectors
    vl_api_u32_fromjson(item, &a->skip_n_vectors);
    // end field skip_n_vectors

    // processing classify_trace_lookup_table: u32 match_n_vectors
    item = cJSON_GetObjectItem(o, "match_n_vectors");
    if (!item) return 0;
    // start field match_n_vectors
    vl_api_u32_fromjson(item, &a->match_n_vectors);
    // end field match_n_vectors

    // processing classify_trace_lookup_table: u8 mask
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    s = u8string_fromjson(o, "mask");
    if (!s) return 0;
    a->mask_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_classify_trace_lookup_table_reply_t *vl_api_classify_trace_lookup_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_lookup_table_reply_t);
    vl_api_classify_trace_lookup_table_reply_t *a = malloc(l);
    // processing classify_trace_lookup_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_trace_lookup_table_reply: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_trace_set_table_t *vl_api_classify_trace_set_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_set_table_t);
    vl_api_classify_trace_set_table_t *a = malloc(l);
    // processing classify_trace_set_table: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index

    // processing classify_trace_set_table: bool sort_masks
    item = cJSON_GetObjectItem(o, "sort_masks");
    if (!item) return 0;
    // start field sort_masks
    vl_api_bool_fromjson(item, &a->sort_masks);
    // end field sort_masks


    *len = l;
    return a;
}
static inline vl_api_classify_trace_set_table_reply_t *vl_api_classify_trace_set_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_set_table_reply_t);
    vl_api_classify_trace_set_table_reply_t *a = malloc(l);
    // processing classify_trace_set_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_trace_set_table_reply: u32 table_index
    item = cJSON_GetObjectItem(o, "table_index");
    if (!item) return 0;
    // start field table_index
    vl_api_u32_fromjson(item, &a->table_index);
    // end field table_index


    *len = l;
    return a;
}
static inline vl_api_classify_trace_get_tables_t *vl_api_classify_trace_get_tables_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_get_tables_t);
    vl_api_classify_trace_get_tables_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_classify_trace_get_tables_reply_t *vl_api_classify_trace_get_tables_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_classify_trace_get_tables_reply_t);
    vl_api_classify_trace_get_tables_reply_t *a = malloc(l);
    // processing classify_trace_get_tables_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing classify_trace_get_tables_reply: u32 indices
    item = cJSON_GetObjectItem(o, "indices");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "indices");
        int size = cJSON_GetArraySize(array);
        a->count = size;
        a = realloc(a, l + sizeof(u32) * size);
        u32 *d = (void *)a + l;
        l += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }


    *len = l;
    return a;
}
#endif
