/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ethernet/ethernet_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_interface_api_fromjson_h
#define included_interface_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_sw_interface_set_flags_t *vl_api_sw_interface_set_flags_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_flags_t);
    vl_api_sw_interface_set_flags_t *a = malloc(l);
    // processing sw_interface_set_flags: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_flags: vl_api_if_status_flags_t flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    a = vl_api_if_status_flags_t_fromjson(a, &l, item, &a->flags);
    if (!a) return 0;
    // end field flags


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_flags_reply_t *vl_api_sw_interface_set_flags_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_flags_reply_t);
    vl_api_sw_interface_set_flags_reply_t *a = malloc(l);
    // processing sw_interface_set_flags_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_hw_interface_set_mtu_t *vl_api_hw_interface_set_mtu_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_hw_interface_set_mtu_t);
    vl_api_hw_interface_set_mtu_t *a = malloc(l);
    // processing hw_interface_set_mtu: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing hw_interface_set_mtu: u16 mtu
    item = cJSON_GetObjectItem(o, "mtu");
    if (!item) return 0;
    // start field mtu
    vl_api_u16_fromjson(item, &a->mtu);
    // end field mtu


    *len = l;
    return a;
}
static inline vl_api_hw_interface_set_mtu_reply_t *vl_api_hw_interface_set_mtu_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_hw_interface_set_mtu_reply_t);
    vl_api_hw_interface_set_mtu_reply_t *a = malloc(l);
    // processing hw_interface_set_mtu_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mtu_t *vl_api_sw_interface_set_mtu_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mtu_t);
    vl_api_sw_interface_set_mtu_t *a = malloc(l);
    // processing sw_interface_set_mtu: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_mtu: u32 mtu
    item = cJSON_GetObjectItem(o, "mtu");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "mtu");
        int size = cJSON_GetArraySize(array);
        if (size != 4) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &a->mtu[i]);
        }
    }


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mtu_reply_t *vl_api_sw_interface_set_mtu_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mtu_reply_t);
    vl_api_sw_interface_set_mtu_reply_t *a = malloc(l);
    // processing sw_interface_set_mtu_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_ip_directed_broadcast_t *vl_api_sw_interface_set_ip_directed_broadcast_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_ip_directed_broadcast_t);
    vl_api_sw_interface_set_ip_directed_broadcast_t *a = malloc(l);
    // processing sw_interface_set_ip_directed_broadcast: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_ip_directed_broadcast: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_ip_directed_broadcast_reply_t *vl_api_sw_interface_set_ip_directed_broadcast_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_ip_directed_broadcast_reply_t);
    vl_api_sw_interface_set_ip_directed_broadcast_reply_t *a = malloc(l);
    // processing sw_interface_set_ip_directed_broadcast_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_event_t *vl_api_sw_interface_event_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_event_t);
    vl_api_sw_interface_event_t *a = malloc(l);
    // processing sw_interface_event: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing sw_interface_event: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_event: vl_api_if_status_flags_t flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    a = vl_api_if_status_flags_t_fromjson(a, &l, item, &a->flags);
    if (!a) return 0;
    // end field flags

    // processing sw_interface_event: bool deleted
    item = cJSON_GetObjectItem(o, "deleted");
    if (!item) return 0;
    // start field deleted
    vl_api_bool_fromjson(item, &a->deleted);
    // end field deleted


    *len = l;
    return a;
}
static inline vl_api_want_interface_events_t *vl_api_want_interface_events_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_interface_events_t);
    vl_api_want_interface_events_t *a = malloc(l);
    // processing want_interface_events: u32 enable_disable
    item = cJSON_GetObjectItem(o, "enable_disable");
    if (!item) return 0;
    // start field enable_disable
    vl_api_u32_fromjson(item, &a->enable_disable);
    // end field enable_disable

    // processing want_interface_events: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid


    *len = l;
    return a;
}
static inline vl_api_want_interface_events_reply_t *vl_api_want_interface_events_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_interface_events_reply_t);
    vl_api_want_interface_events_reply_t *a = malloc(l);
    // processing want_interface_events_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_details_t *vl_api_sw_interface_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_details_t);
    vl_api_sw_interface_details_t *a = malloc(l);
    // processing sw_interface_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_details: u32 sup_sw_if_index
    item = cJSON_GetObjectItem(o, "sup_sw_if_index");
    if (!item) return 0;
    // start field sup_sw_if_index
    vl_api_u32_fromjson(item, &a->sup_sw_if_index);
    // end field sup_sw_if_index

    // processing sw_interface_details: vl_api_mac_address_t l2_address
    item = cJSON_GetObjectItem(o, "l2_address");
    if (!item) return 0;
    // start field l2_address
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->l2_address);
    if (!a) return 0;
    // end field l2_address

    // processing sw_interface_details: vl_api_if_status_flags_t flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    a = vl_api_if_status_flags_t_fromjson(a, &l, item, &a->flags);
    if (!a) return 0;
    // end field flags

    // processing sw_interface_details: vl_api_if_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_if_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type

    // processing sw_interface_details: vl_api_link_duplex_t link_duplex
    item = cJSON_GetObjectItem(o, "link_duplex");
    if (!item) return 0;
    // start field link_duplex
    a = vl_api_link_duplex_t_fromjson(a, &l, item, &a->link_duplex);
    if (!a) return 0;
    // end field link_duplex

    // processing sw_interface_details: u32 link_speed
    item = cJSON_GetObjectItem(o, "link_speed");
    if (!item) return 0;
    // start field link_speed
    vl_api_u32_fromjson(item, &a->link_speed);
    // end field link_speed

    // processing sw_interface_details: u16 link_mtu
    item = cJSON_GetObjectItem(o, "link_mtu");
    if (!item) return 0;
    // start field link_mtu
    vl_api_u16_fromjson(item, &a->link_mtu);
    // end field link_mtu

    // processing sw_interface_details: u32 mtu
    item = cJSON_GetObjectItem(o, "mtu");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "mtu");
        int size = cJSON_GetArraySize(array);
        if (size != 4) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &a->mtu[i]);
        }
    }

    // processing sw_interface_details: u32 sub_id
    item = cJSON_GetObjectItem(o, "sub_id");
    if (!item) return 0;
    // start field sub_id
    vl_api_u32_fromjson(item, &a->sub_id);
    // end field sub_id

    // processing sw_interface_details: u8 sub_number_of_tags
    item = cJSON_GetObjectItem(o, "sub_number_of_tags");
    if (!item) return 0;
    // start field sub_number_of_tags
    vl_api_u8_fromjson(item, &a->sub_number_of_tags);
    // end field sub_number_of_tags

    // processing sw_interface_details: u16 sub_outer_vlan_id
    item = cJSON_GetObjectItem(o, "sub_outer_vlan_id");
    if (!item) return 0;
    // start field sub_outer_vlan_id
    vl_api_u16_fromjson(item, &a->sub_outer_vlan_id);
    // end field sub_outer_vlan_id

    // processing sw_interface_details: u16 sub_inner_vlan_id
    item = cJSON_GetObjectItem(o, "sub_inner_vlan_id");
    if (!item) return 0;
    // start field sub_inner_vlan_id
    vl_api_u16_fromjson(item, &a->sub_inner_vlan_id);
    // end field sub_inner_vlan_id

    // processing sw_interface_details: vl_api_sub_if_flags_t sub_if_flags
    item = cJSON_GetObjectItem(o, "sub_if_flags");
    if (!item) return 0;
    // start field sub_if_flags
    a = vl_api_sub_if_flags_t_fromjson(a, &l, item, &a->sub_if_flags);
    if (!a) return 0;
    // end field sub_if_flags

    // processing sw_interface_details: u32 vtr_op
    item = cJSON_GetObjectItem(o, "vtr_op");
    if (!item) return 0;
    // start field vtr_op
    vl_api_u32_fromjson(item, &a->vtr_op);
    // end field vtr_op

    // processing sw_interface_details: u32 vtr_push_dot1q
    item = cJSON_GetObjectItem(o, "vtr_push_dot1q");
    if (!item) return 0;
    // start field vtr_push_dot1q
    vl_api_u32_fromjson(item, &a->vtr_push_dot1q);
    // end field vtr_push_dot1q

    // processing sw_interface_details: u32 vtr_tag1
    item = cJSON_GetObjectItem(o, "vtr_tag1");
    if (!item) return 0;
    // start field vtr_tag1
    vl_api_u32_fromjson(item, &a->vtr_tag1);
    // end field vtr_tag1

    // processing sw_interface_details: u32 vtr_tag2
    item = cJSON_GetObjectItem(o, "vtr_tag2");
    if (!item) return 0;
    // start field vtr_tag2
    vl_api_u32_fromjson(item, &a->vtr_tag2);
    // end field vtr_tag2

    // processing sw_interface_details: u16 outer_tag
    item = cJSON_GetObjectItem(o, "outer_tag");
    if (!item) return 0;
    // start field outer_tag
    vl_api_u16_fromjson(item, &a->outer_tag);
    // end field outer_tag

    // processing sw_interface_details: vl_api_mac_address_t b_dmac
    item = cJSON_GetObjectItem(o, "b_dmac");
    if (!item) return 0;
    // start field b_dmac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->b_dmac);
    if (!a) return 0;
    // end field b_dmac

    // processing sw_interface_details: vl_api_mac_address_t b_smac
    item = cJSON_GetObjectItem(o, "b_smac");
    if (!item) return 0;
    // start field b_smac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->b_smac);
    if (!a) return 0;
    // end field b_smac

    // processing sw_interface_details: u16 b_vlanid
    item = cJSON_GetObjectItem(o, "b_vlanid");
    if (!item) return 0;
    // start field b_vlanid
    vl_api_u16_fromjson(item, &a->b_vlanid);
    // end field b_vlanid

    // processing sw_interface_details: u32 i_sid
    item = cJSON_GetObjectItem(o, "i_sid");
    if (!item) return 0;
    // start field i_sid
    vl_api_u32_fromjson(item, &a->i_sid);
    // end field i_sid

    // processing sw_interface_details: string interface_name
    item = cJSON_GetObjectItem(o, "interface_name");
    if (!item) return 0;
    strncpy_s((char *)a->interface_name, sizeof(a->interface_name), cJSON_GetStringValue(item), sizeof(a->interface_name) - 1);

    // processing sw_interface_details: string interface_dev_type
    item = cJSON_GetObjectItem(o, "interface_dev_type");
    if (!item) return 0;
    strncpy_s((char *)a->interface_dev_type, sizeof(a->interface_dev_type), cJSON_GetStringValue(item), sizeof(a->interface_dev_type) - 1);

    // processing sw_interface_details: string tag
    item = cJSON_GetObjectItem(o, "tag");
    if (!item) return 0;
    strncpy_s((char *)a->tag, sizeof(a->tag), cJSON_GetStringValue(item), sizeof(a->tag) - 1);


    *len = l;
    return a;
}
static inline vl_api_sw_interface_dump_t *vl_api_sw_interface_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_dump_t);
    vl_api_sw_interface_dump_t *a = malloc(l);
    // processing sw_interface_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_dump: bool name_filter_valid
    item = cJSON_GetObjectItem(o, "name_filter_valid");
    if (!item) return 0;
    // start field name_filter_valid
    vl_api_bool_fromjson(item, &a->name_filter_valid);
    // end field name_filter_valid

    // processing sw_interface_dump: string name_filter
    item = cJSON_GetObjectItem(o, "name_filter");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_sw_interface_add_del_address_t *vl_api_sw_interface_add_del_address_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_add_del_address_t);
    vl_api_sw_interface_add_del_address_t *a = malloc(l);
    // processing sw_interface_add_del_address: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_add_del_address: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing sw_interface_add_del_address: bool del_all
    item = cJSON_GetObjectItem(o, "del_all");
    if (!item) return 0;
    // start field del_all
    vl_api_bool_fromjson(item, &a->del_all);
    // end field del_all

    // processing sw_interface_add_del_address: vl_api_address_with_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_address_with_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix


    *len = l;
    return a;
}
static inline vl_api_sw_interface_add_del_address_reply_t *vl_api_sw_interface_add_del_address_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_add_del_address_reply_t);
    vl_api_sw_interface_add_del_address_reply_t *a = malloc(l);
    // processing sw_interface_add_del_address_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_address_replace_begin_t *vl_api_sw_interface_address_replace_begin_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_address_replace_begin_t);
    vl_api_sw_interface_address_replace_begin_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sw_interface_address_replace_begin_reply_t *vl_api_sw_interface_address_replace_begin_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_address_replace_begin_reply_t);
    vl_api_sw_interface_address_replace_begin_reply_t *a = malloc(l);
    // processing sw_interface_address_replace_begin_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_address_replace_end_t *vl_api_sw_interface_address_replace_end_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_address_replace_end_t);
    vl_api_sw_interface_address_replace_end_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sw_interface_address_replace_end_reply_t *vl_api_sw_interface_address_replace_end_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_address_replace_end_reply_t);
    vl_api_sw_interface_address_replace_end_reply_t *a = malloc(l);
    // processing sw_interface_address_replace_end_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_table_t *vl_api_sw_interface_set_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_table_t);
    vl_api_sw_interface_set_table_t *a = malloc(l);
    // processing sw_interface_set_table: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_table: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6

    // processing sw_interface_set_table: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_table_reply_t *vl_api_sw_interface_set_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_table_reply_t);
    vl_api_sw_interface_set_table_reply_t *a = malloc(l);
    // processing sw_interface_set_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_get_table_t *vl_api_sw_interface_get_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_get_table_t);
    vl_api_sw_interface_get_table_t *a = malloc(l);
    // processing sw_interface_get_table: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_get_table: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_sw_interface_get_table_reply_t *vl_api_sw_interface_get_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_get_table_reply_t);
    vl_api_sw_interface_get_table_reply_t *a = malloc(l);
    // processing sw_interface_get_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing sw_interface_get_table_reply: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_unnumbered_t *vl_api_sw_interface_set_unnumbered_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_unnumbered_t);
    vl_api_sw_interface_set_unnumbered_t *a = malloc(l);
    // processing sw_interface_set_unnumbered: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_unnumbered: vl_api_interface_index_t unnumbered_sw_if_index
    item = cJSON_GetObjectItem(o, "unnumbered_sw_if_index");
    if (!item) return 0;
    // start field unnumbered_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->unnumbered_sw_if_index);
    if (!a) return 0;
    // end field unnumbered_sw_if_index

    // processing sw_interface_set_unnumbered: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_unnumbered_reply_t *vl_api_sw_interface_set_unnumbered_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_unnumbered_reply_t);
    vl_api_sw_interface_set_unnumbered_reply_t *a = malloc(l);
    // processing sw_interface_set_unnumbered_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_clear_stats_t *vl_api_sw_interface_clear_stats_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_clear_stats_t);
    vl_api_sw_interface_clear_stats_t *a = malloc(l);
    // processing sw_interface_clear_stats: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_sw_interface_clear_stats_reply_t *vl_api_sw_interface_clear_stats_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_clear_stats_reply_t);
    vl_api_sw_interface_clear_stats_reply_t *a = malloc(l);
    // processing sw_interface_clear_stats_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_tag_add_del_t *vl_api_sw_interface_tag_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_tag_add_del_t);
    vl_api_sw_interface_tag_add_del_t *a = malloc(l);
    // processing sw_interface_tag_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing sw_interface_tag_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_tag_add_del: string tag
    item = cJSON_GetObjectItem(o, "tag");
    if (!item) return 0;
    strncpy_s((char *)a->tag, sizeof(a->tag), cJSON_GetStringValue(item), sizeof(a->tag) - 1);


    *len = l;
    return a;
}
static inline vl_api_sw_interface_tag_add_del_reply_t *vl_api_sw_interface_tag_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_tag_add_del_reply_t);
    vl_api_sw_interface_tag_add_del_reply_t *a = malloc(l);
    // processing sw_interface_tag_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_add_del_mac_address_t *vl_api_sw_interface_add_del_mac_address_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_add_del_mac_address_t);
    vl_api_sw_interface_add_del_mac_address_t *a = malloc(l);
    // processing sw_interface_add_del_mac_address: u32 sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    vl_api_u32_fromjson(item, &a->sw_if_index);
    // end field sw_if_index

    // processing sw_interface_add_del_mac_address: vl_api_mac_address_t addr
    item = cJSON_GetObjectItem(o, "addr");
    if (!item) return 0;
    // start field addr
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->addr);
    if (!a) return 0;
    // end field addr

    // processing sw_interface_add_del_mac_address: u8 is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_u8_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_sw_interface_add_del_mac_address_reply_t *vl_api_sw_interface_add_del_mac_address_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_add_del_mac_address_reply_t);
    vl_api_sw_interface_add_del_mac_address_reply_t *a = malloc(l);
    // processing sw_interface_add_del_mac_address_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mac_address_t *vl_api_sw_interface_set_mac_address_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mac_address_t);
    vl_api_sw_interface_set_mac_address_t *a = malloc(l);
    // processing sw_interface_set_mac_address: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_mac_address: vl_api_mac_address_t mac_address
    item = cJSON_GetObjectItem(o, "mac_address");
    if (!item) return 0;
    // start field mac_address
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac_address);
    if (!a) return 0;
    // end field mac_address


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mac_address_reply_t *vl_api_sw_interface_set_mac_address_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mac_address_reply_t);
    vl_api_sw_interface_set_mac_address_reply_t *a = malloc(l);
    // processing sw_interface_set_mac_address_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_get_mac_address_t *vl_api_sw_interface_get_mac_address_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_get_mac_address_t);
    vl_api_sw_interface_get_mac_address_t *a = malloc(l);
    // processing sw_interface_get_mac_address: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_sw_interface_get_mac_address_reply_t *vl_api_sw_interface_get_mac_address_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_get_mac_address_reply_t);
    vl_api_sw_interface_get_mac_address_reply_t *a = malloc(l);
    // processing sw_interface_get_mac_address_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing sw_interface_get_mac_address_reply: vl_api_mac_address_t mac_address
    item = cJSON_GetObjectItem(o, "mac_address");
    if (!item) return 0;
    // start field mac_address
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac_address);
    if (!a) return 0;
    // end field mac_address


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_rx_mode_t *vl_api_sw_interface_set_rx_mode_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_rx_mode_t);
    vl_api_sw_interface_set_rx_mode_t *a = malloc(l);
    // processing sw_interface_set_rx_mode: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_rx_mode: bool queue_id_valid
    item = cJSON_GetObjectItem(o, "queue_id_valid");
    if (!item) return 0;
    // start field queue_id_valid
    vl_api_bool_fromjson(item, &a->queue_id_valid);
    // end field queue_id_valid

    // processing sw_interface_set_rx_mode: u32 queue_id
    item = cJSON_GetObjectItem(o, "queue_id");
    if (!item) return 0;
    // start field queue_id
    vl_api_u32_fromjson(item, &a->queue_id);
    // end field queue_id

    // processing sw_interface_set_rx_mode: vl_api_rx_mode_t mode
    item = cJSON_GetObjectItem(o, "mode");
    if (!item) return 0;
    // start field mode
    a = vl_api_rx_mode_t_fromjson(a, &l, item, &a->mode);
    if (!a) return 0;
    // end field mode


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_rx_mode_reply_t *vl_api_sw_interface_set_rx_mode_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_rx_mode_reply_t);
    vl_api_sw_interface_set_rx_mode_reply_t *a = malloc(l);
    // processing sw_interface_set_rx_mode_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_rx_placement_t *vl_api_sw_interface_set_rx_placement_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_rx_placement_t);
    vl_api_sw_interface_set_rx_placement_t *a = malloc(l);
    // processing sw_interface_set_rx_placement: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_rx_placement: u32 queue_id
    item = cJSON_GetObjectItem(o, "queue_id");
    if (!item) return 0;
    // start field queue_id
    vl_api_u32_fromjson(item, &a->queue_id);
    // end field queue_id

    // processing sw_interface_set_rx_placement: u32 worker_id
    item = cJSON_GetObjectItem(o, "worker_id");
    if (!item) return 0;
    // start field worker_id
    vl_api_u32_fromjson(item, &a->worker_id);
    // end field worker_id

    // processing sw_interface_set_rx_placement: bool is_main
    item = cJSON_GetObjectItem(o, "is_main");
    if (!item) return 0;
    // start field is_main
    vl_api_bool_fromjson(item, &a->is_main);
    // end field is_main


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_rx_placement_reply_t *vl_api_sw_interface_set_rx_placement_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_rx_placement_reply_t);
    vl_api_sw_interface_set_rx_placement_reply_t *a = malloc(l);
    // processing sw_interface_set_rx_placement_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_rx_placement_dump_t *vl_api_sw_interface_rx_placement_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_rx_placement_dump_t);
    vl_api_sw_interface_rx_placement_dump_t *a = malloc(l);
    // processing sw_interface_rx_placement_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_sw_interface_rx_placement_details_t *vl_api_sw_interface_rx_placement_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_rx_placement_details_t);
    vl_api_sw_interface_rx_placement_details_t *a = malloc(l);
    // processing sw_interface_rx_placement_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_rx_placement_details: u32 queue_id
    item = cJSON_GetObjectItem(o, "queue_id");
    if (!item) return 0;
    // start field queue_id
    vl_api_u32_fromjson(item, &a->queue_id);
    // end field queue_id

    // processing sw_interface_rx_placement_details: u32 worker_id
    item = cJSON_GetObjectItem(o, "worker_id");
    if (!item) return 0;
    // start field worker_id
    vl_api_u32_fromjson(item, &a->worker_id);
    // end field worker_id

    // processing sw_interface_rx_placement_details: vl_api_rx_mode_t mode
    item = cJSON_GetObjectItem(o, "mode");
    if (!item) return 0;
    // start field mode
    a = vl_api_rx_mode_t_fromjson(a, &l, item, &a->mode);
    if (!a) return 0;
    // end field mode


    *len = l;
    return a;
}
static inline vl_api_interface_name_renumber_t *vl_api_interface_name_renumber_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_interface_name_renumber_t);
    vl_api_interface_name_renumber_t *a = malloc(l);
    // processing interface_name_renumber: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing interface_name_renumber: u32 new_show_dev_instance
    item = cJSON_GetObjectItem(o, "new_show_dev_instance");
    if (!item) return 0;
    // start field new_show_dev_instance
    vl_api_u32_fromjson(item, &a->new_show_dev_instance);
    // end field new_show_dev_instance


    *len = l;
    return a;
}
static inline vl_api_interface_name_renumber_reply_t *vl_api_interface_name_renumber_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_interface_name_renumber_reply_t);
    vl_api_interface_name_renumber_reply_t *a = malloc(l);
    // processing interface_name_renumber_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_create_subif_t *vl_api_create_subif_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_subif_t);
    vl_api_create_subif_t *a = malloc(l);
    // processing create_subif: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing create_subif: u32 sub_id
    item = cJSON_GetObjectItem(o, "sub_id");
    if (!item) return 0;
    // start field sub_id
    vl_api_u32_fromjson(item, &a->sub_id);
    // end field sub_id

    // processing create_subif: vl_api_sub_if_flags_t sub_if_flags
    item = cJSON_GetObjectItem(o, "sub_if_flags");
    if (!item) return 0;
    // start field sub_if_flags
    a = vl_api_sub_if_flags_t_fromjson(a, &l, item, &a->sub_if_flags);
    if (!a) return 0;
    // end field sub_if_flags

    // processing create_subif: u16 outer_vlan_id
    item = cJSON_GetObjectItem(o, "outer_vlan_id");
    if (!item) return 0;
    // start field outer_vlan_id
    vl_api_u16_fromjson(item, &a->outer_vlan_id);
    // end field outer_vlan_id

    // processing create_subif: u16 inner_vlan_id
    item = cJSON_GetObjectItem(o, "inner_vlan_id");
    if (!item) return 0;
    // start field inner_vlan_id
    vl_api_u16_fromjson(item, &a->inner_vlan_id);
    // end field inner_vlan_id


    *len = l;
    return a;
}
static inline vl_api_create_subif_reply_t *vl_api_create_subif_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_subif_reply_t);
    vl_api_create_subif_reply_t *a = malloc(l);
    // processing create_subif_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing create_subif_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_create_vlan_subif_t *vl_api_create_vlan_subif_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_vlan_subif_t);
    vl_api_create_vlan_subif_t *a = malloc(l);
    // processing create_vlan_subif: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing create_vlan_subif: u32 vlan_id
    item = cJSON_GetObjectItem(o, "vlan_id");
    if (!item) return 0;
    // start field vlan_id
    vl_api_u32_fromjson(item, &a->vlan_id);
    // end field vlan_id


    *len = l;
    return a;
}
static inline vl_api_create_vlan_subif_reply_t *vl_api_create_vlan_subif_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_vlan_subif_reply_t);
    vl_api_create_vlan_subif_reply_t *a = malloc(l);
    // processing create_vlan_subif_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing create_vlan_subif_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_delete_subif_t *vl_api_delete_subif_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_delete_subif_t);
    vl_api_delete_subif_t *a = malloc(l);
    // processing delete_subif: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_delete_subif_reply_t *vl_api_delete_subif_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_delete_subif_reply_t);
    vl_api_delete_subif_reply_t *a = malloc(l);
    // processing delete_subif_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_create_loopback_t *vl_api_create_loopback_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_loopback_t);
    vl_api_create_loopback_t *a = malloc(l);
    // processing create_loopback: vl_api_mac_address_t mac_address
    item = cJSON_GetObjectItem(o, "mac_address");
    if (!item) return 0;
    // start field mac_address
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac_address);
    if (!a) return 0;
    // end field mac_address


    *len = l;
    return a;
}
static inline vl_api_create_loopback_reply_t *vl_api_create_loopback_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_loopback_reply_t);
    vl_api_create_loopback_reply_t *a = malloc(l);
    // processing create_loopback_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing create_loopback_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_create_loopback_instance_t *vl_api_create_loopback_instance_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_loopback_instance_t);
    vl_api_create_loopback_instance_t *a = malloc(l);
    // processing create_loopback_instance: vl_api_mac_address_t mac_address
    item = cJSON_GetObjectItem(o, "mac_address");
    if (!item) return 0;
    // start field mac_address
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac_address);
    if (!a) return 0;
    // end field mac_address

    // processing create_loopback_instance: bool is_specified
    item = cJSON_GetObjectItem(o, "is_specified");
    if (!item) return 0;
    // start field is_specified
    vl_api_bool_fromjson(item, &a->is_specified);
    // end field is_specified

    // processing create_loopback_instance: u32 user_instance
    item = cJSON_GetObjectItem(o, "user_instance");
    if (!item) return 0;
    // start field user_instance
    vl_api_u32_fromjson(item, &a->user_instance);
    // end field user_instance


    *len = l;
    return a;
}
static inline vl_api_create_loopback_instance_reply_t *vl_api_create_loopback_instance_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_create_loopback_instance_reply_t);
    vl_api_create_loopback_instance_reply_t *a = malloc(l);
    // processing create_loopback_instance_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing create_loopback_instance_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_delete_loopback_t *vl_api_delete_loopback_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_delete_loopback_t);
    vl_api_delete_loopback_t *a = malloc(l);
    // processing delete_loopback: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_delete_loopback_reply_t *vl_api_delete_loopback_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_delete_loopback_reply_t);
    vl_api_delete_loopback_reply_t *a = malloc(l);
    // processing delete_loopback_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_collect_detailed_interface_stats_t *vl_api_collect_detailed_interface_stats_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_collect_detailed_interface_stats_t);
    vl_api_collect_detailed_interface_stats_t *a = malloc(l);
    // processing collect_detailed_interface_stats: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing collect_detailed_interface_stats: bool enable_disable
    item = cJSON_GetObjectItem(o, "enable_disable");
    if (!item) return 0;
    // start field enable_disable
    vl_api_bool_fromjson(item, &a->enable_disable);
    // end field enable_disable


    *len = l;
    return a;
}
static inline vl_api_collect_detailed_interface_stats_reply_t *vl_api_collect_detailed_interface_stats_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_collect_detailed_interface_stats_reply_t);
    vl_api_collect_detailed_interface_stats_reply_t *a = malloc(l);
    // processing collect_detailed_interface_stats_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
