/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/ethernet/ethernet_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_ip_neighbor_api_fromjson_h
#define included_ip_neighbor_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ip_neighbor_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_neighbor_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_API_NEIGHBOR_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_API_NEIGHBOR_FLAG_STATIC") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IP_API_NEIGHBOR_FLAG_NO_FIB_ENTRY") == 0) {*a = 2; return mp;}
   return 0;
}
static inline void *vl_api_ip_neighbor_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_neighbor_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    mp = vl_api_ip_neighbor_flags_t_fromjson(mp, len, item, &a->flags);
    if (!mp) return 0;
    // end field flags
    item = cJSON_GetObjectItem(o, "mac_address");
    if (!item) return 0;
    // start field mac_address
    mp = vl_api_mac_address_t_fromjson(mp, len, item, &a->mac_address);
    if (!mp) return 0;
    // end field mac_address
    item = cJSON_GetObjectItem(o, "ip_address");
    if (!item) return 0;
    // start field ip_address
    mp = vl_api_address_t_fromjson(mp, len, item, &a->ip_address);
    if (!mp) return 0;
    // end field ip_address
    return mp;
}
static inline void *vl_api_ip_neighbor_event_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_neighbor_event_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_NEIGHBOR_API_EVENT_FLAG_ADDED") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IP_NEIGHBOR_API_EVENT_FLAG_REMOVED") == 0) {*a = 2; return mp;}
   return 0;
}
static inline vl_api_ip_neighbor_add_del_t *vl_api_ip_neighbor_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_add_del_t);
    vl_api_ip_neighbor_add_del_t *a = malloc(l);
    // processing ip_neighbor_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_neighbor_add_del: vl_api_ip_neighbor_t neighbor
    item = cJSON_GetObjectItem(o, "neighbor");
    if (!item) return 0;
    // start field neighbor
    a = vl_api_ip_neighbor_t_fromjson(a, &l, item, &a->neighbor);
    if (!a) return 0;
    // end field neighbor


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_add_del_reply_t *vl_api_ip_neighbor_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_add_del_reply_t);
    vl_api_ip_neighbor_add_del_reply_t *a = malloc(l);
    // processing ip_neighbor_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ip_neighbor_add_del_reply: u32 stats_index
    item = cJSON_GetObjectItem(o, "stats_index");
    if (!item) return 0;
    // start field stats_index
    vl_api_u32_fromjson(item, &a->stats_index);
    // end field stats_index


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_dump_t *vl_api_ip_neighbor_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_dump_t);
    vl_api_ip_neighbor_dump_t *a = malloc(l);
    // processing ip_neighbor_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_neighbor_dump: vl_api_address_family_t af
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    a = vl_api_address_family_t_fromjson(a, &l, item, &a->af);
    if (!a) return 0;
    // end field af


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_details_t *vl_api_ip_neighbor_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_details_t);
    vl_api_ip_neighbor_details_t *a = malloc(l);
    // processing ip_neighbor_details: f64 age
    item = cJSON_GetObjectItem(o, "age");
    if (!item) return 0;
    // start field age
    vl_api_f64_fromjson(item, &a->age);
    // end field age

    // processing ip_neighbor_details: vl_api_ip_neighbor_t neighbor
    item = cJSON_GetObjectItem(o, "neighbor");
    if (!item) return 0;
    // start field neighbor
    a = vl_api_ip_neighbor_t_fromjson(a, &l, item, &a->neighbor);
    if (!a) return 0;
    // end field neighbor


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_config_t *vl_api_ip_neighbor_config_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_config_t);
    vl_api_ip_neighbor_config_t *a = malloc(l);
    // processing ip_neighbor_config: vl_api_address_family_t af
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    a = vl_api_address_family_t_fromjson(a, &l, item, &a->af);
    if (!a) return 0;
    // end field af

    // processing ip_neighbor_config: u32 max_number
    item = cJSON_GetObjectItem(o, "max_number");
    if (!item) return 0;
    // start field max_number
    vl_api_u32_fromjson(item, &a->max_number);
    // end field max_number

    // processing ip_neighbor_config: u32 max_age
    item = cJSON_GetObjectItem(o, "max_age");
    if (!item) return 0;
    // start field max_age
    vl_api_u32_fromjson(item, &a->max_age);
    // end field max_age

    // processing ip_neighbor_config: bool recycle
    item = cJSON_GetObjectItem(o, "recycle");
    if (!item) return 0;
    // start field recycle
    vl_api_bool_fromjson(item, &a->recycle);
    // end field recycle


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_config_reply_t *vl_api_ip_neighbor_config_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_config_reply_t);
    vl_api_ip_neighbor_config_reply_t *a = malloc(l);
    // processing ip_neighbor_config_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_replace_begin_t *vl_api_ip_neighbor_replace_begin_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_replace_begin_t);
    vl_api_ip_neighbor_replace_begin_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_replace_begin_reply_t *vl_api_ip_neighbor_replace_begin_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_replace_begin_reply_t);
    vl_api_ip_neighbor_replace_begin_reply_t *a = malloc(l);
    // processing ip_neighbor_replace_begin_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_replace_end_t *vl_api_ip_neighbor_replace_end_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_replace_end_t);
    vl_api_ip_neighbor_replace_end_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_replace_end_reply_t *vl_api_ip_neighbor_replace_end_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_replace_end_reply_t);
    vl_api_ip_neighbor_replace_end_reply_t *a = malloc(l);
    // processing ip_neighbor_replace_end_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_flush_t *vl_api_ip_neighbor_flush_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_flush_t);
    vl_api_ip_neighbor_flush_t *a = malloc(l);
    // processing ip_neighbor_flush: vl_api_address_family_t af
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    a = vl_api_address_family_t_fromjson(a, &l, item, &a->af);
    if (!a) return 0;
    // end field af

    // processing ip_neighbor_flush: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_flush_reply_t *vl_api_ip_neighbor_flush_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_flush_reply_t);
    vl_api_ip_neighbor_flush_reply_t *a = malloc(l);
    // processing ip_neighbor_flush_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_want_ip_neighbor_events_t *vl_api_want_ip_neighbor_events_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip_neighbor_events_t);
    vl_api_want_ip_neighbor_events_t *a = malloc(l);
    // processing want_ip_neighbor_events: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing want_ip_neighbor_events: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing want_ip_neighbor_events: vl_api_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip

    // processing want_ip_neighbor_events: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_want_ip_neighbor_events_reply_t *vl_api_want_ip_neighbor_events_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip_neighbor_events_reply_t);
    vl_api_want_ip_neighbor_events_reply_t *a = malloc(l);
    // processing want_ip_neighbor_events_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_event_t *vl_api_ip_neighbor_event_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_event_t);
    vl_api_ip_neighbor_event_t *a = malloc(l);
    // processing ip_neighbor_event: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing ip_neighbor_event: vl_api_ip_neighbor_t neighbor
    item = cJSON_GetObjectItem(o, "neighbor");
    if (!item) return 0;
    // start field neighbor
    a = vl_api_ip_neighbor_t_fromjson(a, &l, item, &a->neighbor);
    if (!a) return 0;
    // end field neighbor


    *len = l;
    return a;
}
static inline vl_api_want_ip_neighbor_events_v2_t *vl_api_want_ip_neighbor_events_v2_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip_neighbor_events_v2_t);
    vl_api_want_ip_neighbor_events_v2_t *a = malloc(l);
    // processing want_ip_neighbor_events_v2: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing want_ip_neighbor_events_v2: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing want_ip_neighbor_events_v2: vl_api_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip

    // processing want_ip_neighbor_events_v2: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_want_ip_neighbor_events_v2_reply_t *vl_api_want_ip_neighbor_events_v2_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip_neighbor_events_v2_reply_t);
    vl_api_want_ip_neighbor_events_v2_reply_t *a = malloc(l);
    // processing want_ip_neighbor_events_v2_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_neighbor_event_v2_t *vl_api_ip_neighbor_event_v2_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_neighbor_event_v2_t);
    vl_api_ip_neighbor_event_v2_t *a = malloc(l);
    // processing ip_neighbor_event_v2: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing ip_neighbor_event_v2: vl_api_ip_neighbor_event_flags_t flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    a = vl_api_ip_neighbor_event_flags_t_fromjson(a, &l, item, &a->flags);
    if (!a) return 0;
    // end field flags

    // processing ip_neighbor_event_v2: vl_api_ip_neighbor_t neighbor
    item = cJSON_GetObjectItem(o, "neighbor");
    if (!item) return 0;
    // start field neighbor
    a = vl_api_ip_neighbor_t_fromjson(a, &l, item, &a->neighbor);
    if (!a) return 0;
    // end field neighbor


    *len = l;
    return a;
}
#endif
