/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/fib/fib_types.api_fromjson.h>
#include <vnet/ethernet/ethernet_types.api_fromjson.h>
#include <vnet/mfib/mfib_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_ip_api_fromjson_h
#define included_ip_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ip_table_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_table_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "is_ip6");
    if (!item) return 0;
    // start field is_ip6
    vl_api_bool_fromjson(item, &a->is_ip6);
    // end field is_ip6
    item = cJSON_GetObjectItem(o, "name");
    if (!item) return 0;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);
    return mp;
}
static inline void *vl_api_ip_route_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_route_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "stats_index");
    if (!item) return 0;
    // start field stats_index
    vl_api_u32_fromjson(item, &a->stats_index);
    // end field stats_index
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    mp = vl_api_prefix_t_fromjson(mp, len, item, &a->prefix);
    if (!mp) return 0;
    // end field prefix
    item = cJSON_GetObjectItem(o, "paths");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "paths");
        int size = cJSON_GetArraySize(array);
        a->n_paths = size;
        mp = realloc(mp, *len + sizeof(vl_api_fib_path_t) * size);
        vl_api_fib_path_t *d = (void *)mp + *len;
        *len += sizeof(vl_api_fib_path_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_fib_path_t_fromjson(mp, len, e, &d[i]); 
        }
    }
    return mp;
}
static inline void *vl_api_ip_mroute_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_mroute_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "entry_flags");
    if (!item) return 0;
    // start field entry_flags
    mp = vl_api_mfib_entry_flags_t_fromjson(mp, len, item, &a->entry_flags);
    if (!mp) return 0;
    // end field entry_flags
    item = cJSON_GetObjectItem(o, "rpf_id");
    if (!item) return 0;
    // start field rpf_id
    vl_api_u32_fromjson(item, &a->rpf_id);
    // end field rpf_id
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    mp = vl_api_mprefix_t_fromjson(mp, len, item, &a->prefix);
    if (!mp) return 0;
    // end field prefix
    item = cJSON_GetObjectItem(o, "paths");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "paths");
        int size = cJSON_GetArraySize(array);
        a->n_paths = size;
        mp = realloc(mp, *len + sizeof(vl_api_mfib_path_t) * size);
        vl_api_mfib_path_t *d = (void *)mp + *len;
        *len += sizeof(vl_api_mfib_path_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_mfib_path_t_fromjson(mp, len, e, &d[i]); 
        }
    }
    return mp;
}
static inline void *vl_api_punt_redirect_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_redirect_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "rx_sw_if_index");
    if (!item) return 0;
    // start field rx_sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->rx_sw_if_index);
    if (!mp) return 0;
    // end field rx_sw_if_index
    item = cJSON_GetObjectItem(o, "tx_sw_if_index");
    if (!item) return 0;
    // start field tx_sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->tx_sw_if_index);
    if (!mp) return 0;
    // end field tx_sw_if_index
    item = cJSON_GetObjectItem(o, "nh");
    if (!item) return 0;
    // start field nh
    mp = vl_api_address_t_fromjson(mp, len, item, &a->nh);
    if (!mp) return 0;
    // end field nh
    return mp;
}
static inline void *vl_api_ip_reass_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_reass_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_REASS_TYPE_FULL") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_REASS_TYPE_SHALLOW_VIRTUAL") == 0) {*a = 1; return mp;}
   return 0;
}
static inline vl_api_ip_table_add_del_t *vl_api_ip_table_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_add_del_t);
    vl_api_ip_table_add_del_t *a = malloc(l);
    // processing ip_table_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_table_add_del: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_table_add_del_reply_t *vl_api_ip_table_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_add_del_reply_t);
    vl_api_ip_table_add_del_reply_t *a = malloc(l);
    // processing ip_table_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_table_dump_t *vl_api_ip_table_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_dump_t);
    vl_api_ip_table_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip_table_replace_begin_t *vl_api_ip_table_replace_begin_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_replace_begin_t);
    vl_api_ip_table_replace_begin_t *a = malloc(l);
    // processing ip_table_replace_begin: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_table_replace_begin_reply_t *vl_api_ip_table_replace_begin_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_replace_begin_reply_t);
    vl_api_ip_table_replace_begin_reply_t *a = malloc(l);
    // processing ip_table_replace_begin_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_table_replace_end_t *vl_api_ip_table_replace_end_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_replace_end_t);
    vl_api_ip_table_replace_end_t *a = malloc(l);
    // processing ip_table_replace_end: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_table_replace_end_reply_t *vl_api_ip_table_replace_end_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_replace_end_reply_t);
    vl_api_ip_table_replace_end_reply_t *a = malloc(l);
    // processing ip_table_replace_end_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_table_flush_t *vl_api_ip_table_flush_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_flush_t);
    vl_api_ip_table_flush_t *a = malloc(l);
    // processing ip_table_flush: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_table_flush_reply_t *vl_api_ip_table_flush_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_flush_reply_t);
    vl_api_ip_table_flush_reply_t *a = malloc(l);
    // processing ip_table_flush_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_table_details_t *vl_api_ip_table_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_table_details_t);
    vl_api_ip_table_details_t *a = malloc(l);
    // processing ip_table_details: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_route_add_del_t *vl_api_ip_route_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_add_del_t);
    vl_api_ip_route_add_del_t *a = malloc(l);
    // processing ip_route_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_route_add_del: bool is_multipath
    item = cJSON_GetObjectItem(o, "is_multipath");
    if (!item) return 0;
    // start field is_multipath
    vl_api_bool_fromjson(item, &a->is_multipath);
    // end field is_multipath

    // processing ip_route_add_del: vl_api_ip_route_t route
    item = cJSON_GetObjectItem(o, "route");
    if (!item) return 0;
    // start field route
    a = vl_api_ip_route_t_fromjson(a, &l, item, &a->route);
    if (!a) return 0;
    // end field route


    *len = l;
    return a;
}
static inline vl_api_ip_route_add_del_reply_t *vl_api_ip_route_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_add_del_reply_t);
    vl_api_ip_route_add_del_reply_t *a = malloc(l);
    // processing ip_route_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ip_route_add_del_reply: u32 stats_index
    item = cJSON_GetObjectItem(o, "stats_index");
    if (!item) return 0;
    // start field stats_index
    vl_api_u32_fromjson(item, &a->stats_index);
    // end field stats_index


    *len = l;
    return a;
}
static inline vl_api_ip_route_dump_t *vl_api_ip_route_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_dump_t);
    vl_api_ip_route_dump_t *a = malloc(l);
    // processing ip_route_dump: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_route_details_t *vl_api_ip_route_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_details_t);
    vl_api_ip_route_details_t *a = malloc(l);
    // processing ip_route_details: vl_api_ip_route_t route
    item = cJSON_GetObjectItem(o, "route");
    if (!item) return 0;
    // start field route
    a = vl_api_ip_route_t_fromjson(a, &l, item, &a->route);
    if (!a) return 0;
    // end field route


    *len = l;
    return a;
}
static inline vl_api_ip_route_lookup_t *vl_api_ip_route_lookup_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_lookup_t);
    vl_api_ip_route_lookup_t *a = malloc(l);
    // processing ip_route_lookup: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing ip_route_lookup: u8 exact
    item = cJSON_GetObjectItem(o, "exact");
    if (!item) return 0;
    // start field exact
    vl_api_u8_fromjson(item, &a->exact);
    // end field exact

    // processing ip_route_lookup: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix


    *len = l;
    return a;
}
static inline vl_api_ip_route_lookup_reply_t *vl_api_ip_route_lookup_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_route_lookup_reply_t);
    vl_api_ip_route_lookup_reply_t *a = malloc(l);
    // processing ip_route_lookup_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ip_route_lookup_reply: vl_api_ip_route_t route
    item = cJSON_GetObjectItem(o, "route");
    if (!item) return 0;
    // start field route
    a = vl_api_ip_route_t_fromjson(a, &l, item, &a->route);
    if (!a) return 0;
    // end field route


    *len = l;
    return a;
}
static inline vl_api_set_ip_flow_hash_t *vl_api_set_ip_flow_hash_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ip_flow_hash_t);
    vl_api_set_ip_flow_hash_t *a = malloc(l);
    // processing set_ip_flow_hash: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing set_ip_flow_hash: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6

    // processing set_ip_flow_hash: bool src
    item = cJSON_GetObjectItem(o, "src");
    if (!item) return 0;
    // start field src
    vl_api_bool_fromjson(item, &a->src);
    // end field src

    // processing set_ip_flow_hash: bool dst
    item = cJSON_GetObjectItem(o, "dst");
    if (!item) return 0;
    // start field dst
    vl_api_bool_fromjson(item, &a->dst);
    // end field dst

    // processing set_ip_flow_hash: bool sport
    item = cJSON_GetObjectItem(o, "sport");
    if (!item) return 0;
    // start field sport
    vl_api_bool_fromjson(item, &a->sport);
    // end field sport

    // processing set_ip_flow_hash: bool dport
    item = cJSON_GetObjectItem(o, "dport");
    if (!item) return 0;
    // start field dport
    vl_api_bool_fromjson(item, &a->dport);
    // end field dport

    // processing set_ip_flow_hash: bool proto
    item = cJSON_GetObjectItem(o, "proto");
    if (!item) return 0;
    // start field proto
    vl_api_bool_fromjson(item, &a->proto);
    // end field proto

    // processing set_ip_flow_hash: bool reverse
    item = cJSON_GetObjectItem(o, "reverse");
    if (!item) return 0;
    // start field reverse
    vl_api_bool_fromjson(item, &a->reverse);
    // end field reverse

    // processing set_ip_flow_hash: bool symmetric
    item = cJSON_GetObjectItem(o, "symmetric");
    if (!item) return 0;
    // start field symmetric
    vl_api_bool_fromjson(item, &a->symmetric);
    // end field symmetric


    *len = l;
    return a;
}
static inline vl_api_set_ip_flow_hash_reply_t *vl_api_set_ip_flow_hash_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ip_flow_hash_reply_t);
    vl_api_set_ip_flow_hash_reply_t *a = malloc(l);
    // processing set_ip_flow_hash_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6_enable_disable_t *vl_api_sw_interface_ip6_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6_enable_disable_t);
    vl_api_sw_interface_ip6_enable_disable_t *a = malloc(l);
    // processing sw_interface_ip6_enable_disable: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_ip6_enable_disable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6_enable_disable_reply_t *vl_api_sw_interface_ip6_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6_enable_disable_reply_t);
    vl_api_sw_interface_ip6_enable_disable_reply_t *a = malloc(l);
    // processing sw_interface_ip6_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_mtable_dump_t *vl_api_ip_mtable_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mtable_dump_t);
    vl_api_ip_mtable_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip_mtable_details_t *vl_api_ip_mtable_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mtable_details_t);
    vl_api_ip_mtable_details_t *a = malloc(l);
    // processing ip_mtable_details: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_mroute_add_del_t *vl_api_ip_mroute_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mroute_add_del_t);
    vl_api_ip_mroute_add_del_t *a = malloc(l);
    // processing ip_mroute_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_mroute_add_del: bool is_multipath
    item = cJSON_GetObjectItem(o, "is_multipath");
    if (!item) return 0;
    // start field is_multipath
    vl_api_bool_fromjson(item, &a->is_multipath);
    // end field is_multipath

    // processing ip_mroute_add_del: vl_api_ip_mroute_t route
    item = cJSON_GetObjectItem(o, "route");
    if (!item) return 0;
    // start field route
    a = vl_api_ip_mroute_t_fromjson(a, &l, item, &a->route);
    if (!a) return 0;
    // end field route


    *len = l;
    return a;
}
static inline vl_api_ip_mroute_add_del_reply_t *vl_api_ip_mroute_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mroute_add_del_reply_t);
    vl_api_ip_mroute_add_del_reply_t *a = malloc(l);
    // processing ip_mroute_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ip_mroute_add_del_reply: u32 stats_index
    item = cJSON_GetObjectItem(o, "stats_index");
    if (!item) return 0;
    // start field stats_index
    vl_api_u32_fromjson(item, &a->stats_index);
    // end field stats_index


    *len = l;
    return a;
}
static inline vl_api_ip_mroute_dump_t *vl_api_ip_mroute_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mroute_dump_t);
    vl_api_ip_mroute_dump_t *a = malloc(l);
    // processing ip_mroute_dump: vl_api_ip_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_ip_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_ip_mroute_details_t *vl_api_ip_mroute_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_mroute_details_t);
    vl_api_ip_mroute_details_t *a = malloc(l);
    // processing ip_mroute_details: vl_api_ip_mroute_t route
    item = cJSON_GetObjectItem(o, "route");
    if (!item) return 0;
    // start field route
    a = vl_api_ip_mroute_t_fromjson(a, &l, item, &a->route);
    if (!a) return 0;
    // end field route


    *len = l;
    return a;
}
static inline vl_api_ip_address_details_t *vl_api_ip_address_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_address_details_t);
    vl_api_ip_address_details_t *a = malloc(l);
    // processing ip_address_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_address_details: vl_api_address_with_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_address_with_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix


    *len = l;
    return a;
}
static inline vl_api_ip_address_dump_t *vl_api_ip_address_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_address_dump_t);
    vl_api_ip_address_dump_t *a = malloc(l);
    // processing ip_address_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_address_dump: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_ip_unnumbered_details_t *vl_api_ip_unnumbered_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_unnumbered_details_t);
    vl_api_ip_unnumbered_details_t *a = malloc(l);
    // processing ip_unnumbered_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_unnumbered_details: vl_api_interface_index_t ip_sw_if_index
    item = cJSON_GetObjectItem(o, "ip_sw_if_index");
    if (!item) return 0;
    // start field ip_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->ip_sw_if_index);
    if (!a) return 0;
    // end field ip_sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ip_unnumbered_dump_t *vl_api_ip_unnumbered_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_unnumbered_dump_t);
    vl_api_ip_unnumbered_dump_t *a = malloc(l);
    // processing ip_unnumbered_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ip_details_t *vl_api_ip_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_details_t);
    vl_api_ip_details_t *a = malloc(l);
    // processing ip_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_details: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_ip_dump_t *vl_api_ip_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_dump_t);
    vl_api_ip_dump_t *a = malloc(l);
    // processing ip_dump: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_mfib_signal_dump_t *vl_api_mfib_signal_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mfib_signal_dump_t);
    vl_api_mfib_signal_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_mfib_signal_details_t *vl_api_mfib_signal_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mfib_signal_details_t);
    vl_api_mfib_signal_details_t *a = malloc(l);
    // processing mfib_signal_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing mfib_signal_details: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing mfib_signal_details: vl_api_mprefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_mprefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing mfib_signal_details: u16 ip_packet_len
    item = cJSON_GetObjectItem(o, "ip_packet_len");
    if (!item) return 0;
    // start field ip_packet_len
    vl_api_u16_fromjson(item, &a->ip_packet_len);
    // end field ip_packet_len

    // processing mfib_signal_details: u8 ip_packet_data
    item = cJSON_GetObjectItem(o, "ip_packet_data");
    if (!item) return 0;
    u8string_fromjson2(o, "ip_packet_data", a->ip_packet_data);


    *len = l;
    return a;
}
static inline vl_api_ip_punt_police_t *vl_api_ip_punt_police_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_police_t);
    vl_api_ip_punt_police_t *a = malloc(l);
    // processing ip_punt_police: u32 policer_index
    item = cJSON_GetObjectItem(o, "policer_index");
    if (!item) return 0;
    // start field policer_index
    vl_api_u32_fromjson(item, &a->policer_index);
    // end field policer_index

    // processing ip_punt_police: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_punt_police: bool is_ip6
    item = cJSON_GetObjectItem(o, "is_ip6");
    if (!item) return 0;
    // start field is_ip6
    vl_api_bool_fromjson(item, &a->is_ip6);
    // end field is_ip6


    *len = l;
    return a;
}
static inline vl_api_ip_punt_police_reply_t *vl_api_ip_punt_police_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_police_reply_t);
    vl_api_ip_punt_police_reply_t *a = malloc(l);
    // processing ip_punt_police_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_punt_redirect_t *vl_api_ip_punt_redirect_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_redirect_t);
    vl_api_ip_punt_redirect_t *a = malloc(l);
    // processing ip_punt_redirect: vl_api_punt_redirect_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_redirect_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt

    // processing ip_punt_redirect: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_ip_punt_redirect_reply_t *vl_api_ip_punt_redirect_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_redirect_reply_t);
    vl_api_ip_punt_redirect_reply_t *a = malloc(l);
    // processing ip_punt_redirect_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_punt_redirect_dump_t *vl_api_ip_punt_redirect_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_redirect_dump_t);
    vl_api_ip_punt_redirect_dump_t *a = malloc(l);
    // processing ip_punt_redirect_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_punt_redirect_dump: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_ip_punt_redirect_details_t *vl_api_ip_punt_redirect_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_punt_redirect_details_t);
    vl_api_ip_punt_redirect_details_t *a = malloc(l);
    // processing ip_punt_redirect_details: vl_api_punt_redirect_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_redirect_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt


    *len = l;
    return a;
}
static inline vl_api_ip_container_proxy_add_del_t *vl_api_ip_container_proxy_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_container_proxy_add_del_t);
    vl_api_ip_container_proxy_add_del_t *a = malloc(l);
    // processing ip_container_proxy_add_del: vl_api_prefix_t pfx
    item = cJSON_GetObjectItem(o, "pfx");
    if (!item) return 0;
    // start field pfx
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->pfx);
    if (!a) return 0;
    // end field pfx

    // processing ip_container_proxy_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_container_proxy_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_ip_container_proxy_add_del_reply_t *vl_api_ip_container_proxy_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_container_proxy_add_del_reply_t);
    vl_api_ip_container_proxy_add_del_reply_t *a = malloc(l);
    // processing ip_container_proxy_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_container_proxy_dump_t *vl_api_ip_container_proxy_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_container_proxy_dump_t);
    vl_api_ip_container_proxy_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip_container_proxy_details_t *vl_api_ip_container_proxy_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_container_proxy_details_t);
    vl_api_ip_container_proxy_details_t *a = malloc(l);
    // processing ip_container_proxy_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_container_proxy_details: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix


    *len = l;
    return a;
}
static inline vl_api_ip_source_and_port_range_check_add_del_t *vl_api_ip_source_and_port_range_check_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_source_and_port_range_check_add_del_t);
    vl_api_ip_source_and_port_range_check_add_del_t *a = malloc(l);
    // processing ip_source_and_port_range_check_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_source_and_port_range_check_add_del: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing ip_source_and_port_range_check_add_del: u8 number_of_ranges
    item = cJSON_GetObjectItem(o, "number_of_ranges");
    if (!item) return 0;
    // start field number_of_ranges
    vl_api_u8_fromjson(item, &a->number_of_ranges);
    // end field number_of_ranges

    // processing ip_source_and_port_range_check_add_del: u16 low_ports
    item = cJSON_GetObjectItem(o, "low_ports");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "low_ports");
        int size = cJSON_GetArraySize(array);
        if (size != 32) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u16_fromjson(e, &a->low_ports[i]);
        }
    }

    // processing ip_source_and_port_range_check_add_del: u16 high_ports
    item = cJSON_GetObjectItem(o, "high_ports");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "high_ports");
        int size = cJSON_GetArraySize(array);
        if (size != 32) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u16_fromjson(e, &a->high_ports[i]);
        }
    }

    // processing ip_source_and_port_range_check_add_del: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id


    *len = l;
    return a;
}
static inline vl_api_ip_source_and_port_range_check_add_del_reply_t *vl_api_ip_source_and_port_range_check_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_source_and_port_range_check_add_del_reply_t);
    vl_api_ip_source_and_port_range_check_add_del_reply_t *a = malloc(l);
    // processing ip_source_and_port_range_check_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_source_and_port_range_check_interface_add_del_t *vl_api_ip_source_and_port_range_check_interface_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_source_and_port_range_check_interface_add_del_t);
    vl_api_ip_source_and_port_range_check_interface_add_del_t *a = malloc(l);
    // processing ip_source_and_port_range_check_interface_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip_source_and_port_range_check_interface_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_source_and_port_range_check_interface_add_del: u32 tcp_in_vrf_id
    item = cJSON_GetObjectItem(o, "tcp_in_vrf_id");
    if (!item) return 0;
    // start field tcp_in_vrf_id
    vl_api_u32_fromjson(item, &a->tcp_in_vrf_id);
    // end field tcp_in_vrf_id

    // processing ip_source_and_port_range_check_interface_add_del: u32 tcp_out_vrf_id
    item = cJSON_GetObjectItem(o, "tcp_out_vrf_id");
    if (!item) return 0;
    // start field tcp_out_vrf_id
    vl_api_u32_fromjson(item, &a->tcp_out_vrf_id);
    // end field tcp_out_vrf_id

    // processing ip_source_and_port_range_check_interface_add_del: u32 udp_in_vrf_id
    item = cJSON_GetObjectItem(o, "udp_in_vrf_id");
    if (!item) return 0;
    // start field udp_in_vrf_id
    vl_api_u32_fromjson(item, &a->udp_in_vrf_id);
    // end field udp_in_vrf_id

    // processing ip_source_and_port_range_check_interface_add_del: u32 udp_out_vrf_id
    item = cJSON_GetObjectItem(o, "udp_out_vrf_id");
    if (!item) return 0;
    // start field udp_out_vrf_id
    vl_api_u32_fromjson(item, &a->udp_out_vrf_id);
    // end field udp_out_vrf_id


    *len = l;
    return a;
}
static inline vl_api_ip_source_and_port_range_check_interface_add_del_reply_t *vl_api_ip_source_and_port_range_check_interface_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_source_and_port_range_check_interface_add_del_reply_t);
    vl_api_ip_source_and_port_range_check_interface_add_del_reply_t *a = malloc(l);
    // processing ip_source_and_port_range_check_interface_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6_set_link_local_address_t *vl_api_sw_interface_ip6_set_link_local_address_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6_set_link_local_address_t);
    vl_api_sw_interface_ip6_set_link_local_address_t *a = malloc(l);
    // processing sw_interface_ip6_set_link_local_address: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_ip6_set_link_local_address: vl_api_ip6_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6_set_link_local_address_reply_t *vl_api_sw_interface_ip6_set_link_local_address_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6_set_link_local_address_reply_t);
    vl_api_sw_interface_ip6_set_link_local_address_reply_t *a = malloc(l);
    // processing sw_interface_ip6_set_link_local_address_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ioam_enable_t *vl_api_ioam_enable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ioam_enable_t);
    vl_api_ioam_enable_t *a = malloc(l);
    // processing ioam_enable: u16 id
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u16_fromjson(item, &a->id);
    // end field id

    // processing ioam_enable: bool seqno
    item = cJSON_GetObjectItem(o, "seqno");
    if (!item) return 0;
    // start field seqno
    vl_api_bool_fromjson(item, &a->seqno);
    // end field seqno

    // processing ioam_enable: bool analyse
    item = cJSON_GetObjectItem(o, "analyse");
    if (!item) return 0;
    // start field analyse
    vl_api_bool_fromjson(item, &a->analyse);
    // end field analyse

    // processing ioam_enable: bool pot_enable
    item = cJSON_GetObjectItem(o, "pot_enable");
    if (!item) return 0;
    // start field pot_enable
    vl_api_bool_fromjson(item, &a->pot_enable);
    // end field pot_enable

    // processing ioam_enable: bool trace_enable
    item = cJSON_GetObjectItem(o, "trace_enable");
    if (!item) return 0;
    // start field trace_enable
    vl_api_bool_fromjson(item, &a->trace_enable);
    // end field trace_enable

    // processing ioam_enable: u32 node_id
    item = cJSON_GetObjectItem(o, "node_id");
    if (!item) return 0;
    // start field node_id
    vl_api_u32_fromjson(item, &a->node_id);
    // end field node_id


    *len = l;
    return a;
}
static inline vl_api_ioam_enable_reply_t *vl_api_ioam_enable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ioam_enable_reply_t);
    vl_api_ioam_enable_reply_t *a = malloc(l);
    // processing ioam_enable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ioam_disable_t *vl_api_ioam_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ioam_disable_t);
    vl_api_ioam_disable_t *a = malloc(l);
    // processing ioam_disable: u16 id
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u16_fromjson(item, &a->id);
    // end field id


    *len = l;
    return a;
}
static inline vl_api_ioam_disable_reply_t *vl_api_ioam_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ioam_disable_reply_t);
    vl_api_ioam_disable_reply_t *a = malloc(l);
    // processing ioam_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_set_t *vl_api_ip_reassembly_set_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_set_t);
    vl_api_ip_reassembly_set_t *a = malloc(l);
    // processing ip_reassembly_set: u32 timeout_ms
    item = cJSON_GetObjectItem(o, "timeout_ms");
    if (!item) return 0;
    // start field timeout_ms
    vl_api_u32_fromjson(item, &a->timeout_ms);
    // end field timeout_ms

    // processing ip_reassembly_set: u32 max_reassemblies
    item = cJSON_GetObjectItem(o, "max_reassemblies");
    if (!item) return 0;
    // start field max_reassemblies
    vl_api_u32_fromjson(item, &a->max_reassemblies);
    // end field max_reassemblies

    // processing ip_reassembly_set: u32 max_reassembly_length
    item = cJSON_GetObjectItem(o, "max_reassembly_length");
    if (!item) return 0;
    // start field max_reassembly_length
    vl_api_u32_fromjson(item, &a->max_reassembly_length);
    // end field max_reassembly_length

    // processing ip_reassembly_set: u32 expire_walk_interval_ms
    item = cJSON_GetObjectItem(o, "expire_walk_interval_ms");
    if (!item) return 0;
    // start field expire_walk_interval_ms
    vl_api_u32_fromjson(item, &a->expire_walk_interval_ms);
    // end field expire_walk_interval_ms

    // processing ip_reassembly_set: bool is_ip6
    item = cJSON_GetObjectItem(o, "is_ip6");
    if (!item) return 0;
    // start field is_ip6
    vl_api_bool_fromjson(item, &a->is_ip6);
    // end field is_ip6

    // processing ip_reassembly_set: vl_api_ip_reass_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_ip_reass_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_set_reply_t *vl_api_ip_reassembly_set_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_set_reply_t);
    vl_api_ip_reassembly_set_reply_t *a = malloc(l);
    // processing ip_reassembly_set_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_get_t *vl_api_ip_reassembly_get_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_get_t);
    vl_api_ip_reassembly_get_t *a = malloc(l);
    // processing ip_reassembly_get: bool is_ip6
    item = cJSON_GetObjectItem(o, "is_ip6");
    if (!item) return 0;
    // start field is_ip6
    vl_api_bool_fromjson(item, &a->is_ip6);
    // end field is_ip6

    // processing ip_reassembly_get: vl_api_ip_reass_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_ip_reass_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_get_reply_t *vl_api_ip_reassembly_get_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_get_reply_t);
    vl_api_ip_reassembly_get_reply_t *a = malloc(l);
    // processing ip_reassembly_get_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ip_reassembly_get_reply: u32 timeout_ms
    item = cJSON_GetObjectItem(o, "timeout_ms");
    if (!item) return 0;
    // start field timeout_ms
    vl_api_u32_fromjson(item, &a->timeout_ms);
    // end field timeout_ms

    // processing ip_reassembly_get_reply: u32 max_reassemblies
    item = cJSON_GetObjectItem(o, "max_reassemblies");
    if (!item) return 0;
    // start field max_reassemblies
    vl_api_u32_fromjson(item, &a->max_reassemblies);
    // end field max_reassemblies

    // processing ip_reassembly_get_reply: u32 max_reassembly_length
    item = cJSON_GetObjectItem(o, "max_reassembly_length");
    if (!item) return 0;
    // start field max_reassembly_length
    vl_api_u32_fromjson(item, &a->max_reassembly_length);
    // end field max_reassembly_length

    // processing ip_reassembly_get_reply: u32 expire_walk_interval_ms
    item = cJSON_GetObjectItem(o, "expire_walk_interval_ms");
    if (!item) return 0;
    // start field expire_walk_interval_ms
    vl_api_u32_fromjson(item, &a->expire_walk_interval_ms);
    // end field expire_walk_interval_ms

    // processing ip_reassembly_get_reply: bool is_ip6
    item = cJSON_GetObjectItem(o, "is_ip6");
    if (!item) return 0;
    // start field is_ip6
    vl_api_bool_fromjson(item, &a->is_ip6);
    // end field is_ip6


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_enable_disable_t *vl_api_ip_reassembly_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_enable_disable_t);
    vl_api_ip_reassembly_enable_disable_t *a = malloc(l);
    // processing ip_reassembly_enable_disable: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip_reassembly_enable_disable: bool enable_ip4
    item = cJSON_GetObjectItem(o, "enable_ip4");
    if (!item) return 0;
    // start field enable_ip4
    vl_api_bool_fromjson(item, &a->enable_ip4);
    // end field enable_ip4

    // processing ip_reassembly_enable_disable: bool enable_ip6
    item = cJSON_GetObjectItem(o, "enable_ip6");
    if (!item) return 0;
    // start field enable_ip6
    vl_api_bool_fromjson(item, &a->enable_ip6);
    // end field enable_ip6

    // processing ip_reassembly_enable_disable: vl_api_ip_reass_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_ip_reass_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type


    *len = l;
    return a;
}
static inline vl_api_ip_reassembly_enable_disable_reply_t *vl_api_ip_reassembly_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip_reassembly_enable_disable_reply_t);
    vl_api_ip_reassembly_enable_disable_reply_t *a = malloc(l);
    // processing ip_reassembly_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
