/* Imported API files */
#ifndef included_ip_types_api_fromjson_h
#define included_ip_types_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

/* Manual print ip4_address */
/* Manual print ip6_address */
static inline void *vl_api_address_family_t_fromjson (void *mp, int *len, cJSON *o, vl_api_address_family_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "ADDRESS_IP4") == 0) {*a = 0; return mp;}
    if (strcmp(p, "ADDRESS_IP6") == 0) {*a = 1; return mp;}
   return 0;
}
static inline void *vl_api_ip_feature_location_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_feature_location_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_API_FEATURE_INPUT") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_API_FEATURE_OUTPUT") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IP_API_FEATURE_LOCAL") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IP_API_FEATURE_PUNT") == 0) {*a = 3; return mp;}
    if (strcmp(p, "IP_API_FEATURE_DROP") == 0) {*a = 4; return mp;}
   return 0;
}
static inline void *vl_api_ip_ecn_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_ecn_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_API_ECN_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_API_ECN_ECT0") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IP_API_ECN_ECT1") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IP_API_ECN_CE") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_ip_dscp_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_dscp_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_API_DSCP_CS0") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS1") == 0) {*a = 8; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF11") == 0) {*a = 10; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF12") == 0) {*a = 12; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF13") == 0) {*a = 14; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS2") == 0) {*a = 16; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF21") == 0) {*a = 18; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF22") == 0) {*a = 20; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF23") == 0) {*a = 22; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS3") == 0) {*a = 24; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF31") == 0) {*a = 26; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF32") == 0) {*a = 28; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF33") == 0) {*a = 30; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS4") == 0) {*a = 32; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF41") == 0) {*a = 34; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF42") == 0) {*a = 36; return mp;}
    if (strcmp(p, "IP_API_DSCP_AF43") == 0) {*a = 38; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS5") == 0) {*a = 40; return mp;}
    if (strcmp(p, "IP_API_DSCP_EF") == 0) {*a = 46; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS6") == 0) {*a = 48; return mp;}
    if (strcmp(p, "IP_API_DSCP_CS7") == 0) {*a = 50; return mp;}
   return 0;
}
static inline void *vl_api_ip_proto_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip_proto_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IP_API_PROTO_HOPOPT") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IP_API_PROTO_ICMP") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IP_API_PROTO_IGMP") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IP_API_PROTO_TCP") == 0) {*a = 6; return mp;}
    if (strcmp(p, "IP_API_PROTO_UDP") == 0) {*a = 17; return mp;}
    if (strcmp(p, "IP_API_PROTO_GRE") == 0) {*a = 47; return mp;}
    if (strcmp(p, "IP_API_PROTO_ESP") == 0) {*a = 50; return mp;}
    if (strcmp(p, "IP_API_PROTO_AH") == 0) {*a = 51; return mp;}
    if (strcmp(p, "IP_API_PROTO_ICMP6") == 0) {*a = 58; return mp;}
    if (strcmp(p, "IP_API_PROTO_EIGRP") == 0) {*a = 88; return mp;}
    if (strcmp(p, "IP_API_PROTO_OSPF") == 0) {*a = 89; return mp;}
    if (strcmp(p, "IP_API_PROTO_SCTP") == 0) {*a = 132; return mp;}
    if (strcmp(p, "IP_API_PROTO_RESERVED") == 0) {*a = 255; return mp;}
   return 0;
}
static inline void *vl_api_address_union_t_fromjson (void *mp, int *len, cJSON *o, vl_api_address_union_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "ip4");
    if (item) {
    // start field ip4
    mp = vl_api_ip4_address_t_fromjson(mp, len, item, &a->ip4);
    if (!mp) return 0;
    // end field ip4
    };
    item = cJSON_GetObjectItem(o, "ip6");
    if (item) {
    // start field ip6
    mp = vl_api_ip6_address_t_fromjson(mp, len, item, &a->ip6);
    if (!mp) return 0;
    // end field ip6
    };
    return mp;
}
/* Manual print address */
/* Manual print prefix */
static inline void *vl_api_ip4_address_and_mask_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip4_address_and_mask_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "addr");
    if (!item) return 0;
    // start field addr
    mp = vl_api_ip4_address_t_fromjson(mp, len, item, &a->addr);
    if (!mp) return 0;
    // end field addr
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    // start field mask
    mp = vl_api_ip4_address_t_fromjson(mp, len, item, &a->mask);
    if (!mp) return 0;
    // end field mask
    return mp;
}
static inline void *vl_api_ip6_address_and_mask_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip6_address_and_mask_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "addr");
    if (!item) return 0;
    // start field addr
    mp = vl_api_ip6_address_t_fromjson(mp, len, item, &a->addr);
    if (!mp) return 0;
    // end field addr
    item = cJSON_GetObjectItem(o, "mask");
    if (!item) return 0;
    // start field mask
    mp = vl_api_ip6_address_t_fromjson(mp, len, item, &a->mask);
    if (!mp) return 0;
    // end field mask
    return mp;
}
static inline void *vl_api_mprefix_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mprefix_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    mp = vl_api_address_family_t_fromjson(mp, len, item, &a->af);
    if (!mp) return 0;
    // end field af
    item = cJSON_GetObjectItem(o, "grp_address_length");
    if (!item) return 0;
    // start field grp_address_length
    vl_api_u16_fromjson(item, &a->grp_address_length);
    // end field grp_address_length
    item = cJSON_GetObjectItem(o, "grp_address");
    if (!item) return 0;
    // start field grp_address
    mp = vl_api_address_union_t_fromjson(mp, len, item, &a->grp_address);
    if (!mp) return 0;
    // end field grp_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    mp = vl_api_address_union_t_fromjson(mp, len, item, &a->src_address);
    if (!mp) return 0;
    // end field src_address
    return mp;
}
/* Manual print ip6_prefix */
/* Manual print ip4_prefix */
/* Manual print address_with_prefix */
/* Manual print ip4_address_with_prefix */
/* Manual print ip6_address_with_prefix */
static inline void *vl_api_prefix_matcher_t_fromjson (void *mp, int *len, cJSON *o, vl_api_prefix_matcher_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "le");
    if (!item) return 0;
    // start field le
    vl_api_u8_fromjson(item, &a->le);
    // end field le
    item = cJSON_GetObjectItem(o, "ge");
    if (!item) return 0;
    // start field ge
    vl_api_u8_fromjson(item, &a->ge);
    // end field ge
    return mp;
}
#endif
