/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_punt_api_fromjson_h
#define included_punt_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_punt_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "PUNT_API_TYPE_L4") == 0) {*a = 1; return mp;}
    if (strcmp(p, "PUNT_API_TYPE_IP_PROTO") == 0) {*a = 2; return mp;}
    if (strcmp(p, "PUNT_API_TYPE_EXCEPTION") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_punt_l4_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_l4_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    mp = vl_api_address_family_t_fromjson(mp, len, item, &a->af);
    if (!mp) return 0;
    // end field af
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    mp = vl_api_ip_proto_t_fromjson(mp, len, item, &a->protocol);
    if (!mp) return 0;
    // end field protocol
    item = cJSON_GetObjectItem(o, "port");
    if (!item) return 0;
    // start field port
    vl_api_u16_fromjson(item, &a->port);
    // end field port
    return mp;
}
static inline void *vl_api_punt_ip_proto_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_ip_proto_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "af");
    if (!item) return 0;
    // start field af
    mp = vl_api_address_family_t_fromjson(mp, len, item, &a->af);
    if (!mp) return 0;
    // end field af
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    mp = vl_api_ip_proto_t_fromjson(mp, len, item, &a->protocol);
    if (!mp) return 0;
    // end field protocol
    return mp;
}
static inline void *vl_api_punt_exception_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_exception_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id
    return mp;
}
static inline void *vl_api_punt_union_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_union_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "exception");
    if (item) {
    // start field exception
    mp = vl_api_punt_exception_t_fromjson(mp, len, item, &a->exception);
    if (!mp) return 0;
    // end field exception
    };
    item = cJSON_GetObjectItem(o, "l4");
    if (item) {
    // start field l4
    mp = vl_api_punt_l4_t_fromjson(mp, len, item, &a->l4);
    if (!mp) return 0;
    // end field l4
    };
    item = cJSON_GetObjectItem(o, "ip_proto");
    if (item) {
    // start field ip_proto
    mp = vl_api_punt_ip_proto_t_fromjson(mp, len, item, &a->ip_proto);
    if (!mp) return 0;
    // end field ip_proto
    };
    return mp;
}
static inline void *vl_api_punt_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    mp = vl_api_punt_type_t_fromjson(mp, len, item, &a->type);
    if (!mp) return 0;
    // end field type
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    mp = vl_api_punt_union_t_fromjson(mp, len, item, &a->punt);
    if (!mp) return 0;
    // end field punt
    return mp;
}
static inline void *vl_api_punt_reason_t_fromjson (void *mp, int *len, cJSON *o, vl_api_punt_reason_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id
    item = cJSON_GetObjectItem(o, "name");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    mp = realloc(mp, *len + plen);
    vl_api_c_string_to_api_string(p, (void *)mp + *len - sizeof(vl_api_string_t));
    *len += plen;
    return mp;
}
static inline vl_api_set_punt_t *vl_api_set_punt_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_punt_t);
    vl_api_set_punt_t *a = malloc(l);
    // processing set_punt: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing set_punt: vl_api_punt_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt


    *len = l;
    return a;
}
static inline vl_api_set_punt_reply_t *vl_api_set_punt_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_punt_reply_t);
    vl_api_set_punt_reply_t *a = malloc(l);
    // processing set_punt_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_punt_socket_register_t *vl_api_punt_socket_register_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_register_t);
    vl_api_punt_socket_register_t *a = malloc(l);
    // processing punt_socket_register: u32 header_version
    item = cJSON_GetObjectItem(o, "header_version");
    if (!item) return 0;
    // start field header_version
    vl_api_u32_fromjson(item, &a->header_version);
    // end field header_version

    // processing punt_socket_register: vl_api_punt_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt

    // processing punt_socket_register: string pathname
    item = cJSON_GetObjectItem(o, "pathname");
    if (!item) return 0;
    strncpy_s((char *)a->pathname, sizeof(a->pathname), cJSON_GetStringValue(item), sizeof(a->pathname) - 1);


    *len = l;
    return a;
}
static inline vl_api_punt_socket_register_reply_t *vl_api_punt_socket_register_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_register_reply_t);
    vl_api_punt_socket_register_reply_t *a = malloc(l);
    // processing punt_socket_register_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing punt_socket_register_reply: string pathname
    item = cJSON_GetObjectItem(o, "pathname");
    if (!item) return 0;
    strncpy_s((char *)a->pathname, sizeof(a->pathname), cJSON_GetStringValue(item), sizeof(a->pathname) - 1);


    *len = l;
    return a;
}
static inline vl_api_punt_socket_dump_t *vl_api_punt_socket_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_dump_t);
    vl_api_punt_socket_dump_t *a = malloc(l);
    // processing punt_socket_dump: vl_api_punt_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_punt_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type


    *len = l;
    return a;
}
static inline vl_api_punt_socket_details_t *vl_api_punt_socket_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_details_t);
    vl_api_punt_socket_details_t *a = malloc(l);
    // processing punt_socket_details: vl_api_punt_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt

    // processing punt_socket_details: string pathname
    item = cJSON_GetObjectItem(o, "pathname");
    if (!item) return 0;
    strncpy_s((char *)a->pathname, sizeof(a->pathname), cJSON_GetStringValue(item), sizeof(a->pathname) - 1);


    *len = l;
    return a;
}
static inline vl_api_punt_socket_deregister_t *vl_api_punt_socket_deregister_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_deregister_t);
    vl_api_punt_socket_deregister_t *a = malloc(l);
    // processing punt_socket_deregister: vl_api_punt_t punt
    item = cJSON_GetObjectItem(o, "punt");
    if (!item) return 0;
    // start field punt
    a = vl_api_punt_t_fromjson(a, &l, item, &a->punt);
    if (!a) return 0;
    // end field punt


    *len = l;
    return a;
}
static inline vl_api_punt_socket_deregister_reply_t *vl_api_punt_socket_deregister_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_socket_deregister_reply_t);
    vl_api_punt_socket_deregister_reply_t *a = malloc(l);
    // processing punt_socket_deregister_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_punt_reason_dump_t *vl_api_punt_reason_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_reason_dump_t);
    vl_api_punt_reason_dump_t *a = malloc(l);
    // processing punt_reason_dump: vl_api_punt_reason_t reason
    item = cJSON_GetObjectItem(o, "reason");
    if (!item) return 0;
    // start field reason
    a = vl_api_punt_reason_t_fromjson(a, &l, item, &a->reason);
    if (!a) return 0;
    // end field reason


    *len = l;
    return a;
}
static inline vl_api_punt_reason_details_t *vl_api_punt_reason_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_punt_reason_details_t);
    vl_api_punt_reason_details_t *a = malloc(l);
    // processing punt_reason_details: vl_api_punt_reason_t reason
    item = cJSON_GetObjectItem(o, "reason");
    if (!item) return 0;
    // start field reason
    a = vl_api_punt_reason_t_fromjson(a, &l, item, &a->reason);
    if (!a) return 0;
    // end field reason


    *len = l;
    return a;
}
#endif
