/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_ip6_nd_api_fromjson_h
#define included_ip6_nd_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ip6_ra_prefix_info_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ip6_ra_prefix_info_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    mp = vl_api_prefix_t_fromjson(mp, len, item, &a->prefix);
    if (!mp) return 0;
    // end field prefix
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    vl_api_u8_fromjson(item, &a->flags);
    // end field flags
    item = cJSON_GetObjectItem(o, "valid_time");
    if (!item) return 0;
    // start field valid_time
    vl_api_u32_fromjson(item, &a->valid_time);
    // end field valid_time
    item = cJSON_GetObjectItem(o, "preferred_time");
    if (!item) return 0;
    // start field preferred_time
    vl_api_u32_fromjson(item, &a->preferred_time);
    // end field preferred_time
    return mp;
}
static inline vl_api_sw_interface_ip6nd_ra_config_t *vl_api_sw_interface_ip6nd_ra_config_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6nd_ra_config_t);
    vl_api_sw_interface_ip6nd_ra_config_t *a = malloc(l);
    // processing sw_interface_ip6nd_ra_config: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_ip6nd_ra_config: u8 suppress
    item = cJSON_GetObjectItem(o, "suppress");
    if (!item) return 0;
    // start field suppress
    vl_api_u8_fromjson(item, &a->suppress);
    // end field suppress

    // processing sw_interface_ip6nd_ra_config: u8 managed
    item = cJSON_GetObjectItem(o, "managed");
    if (!item) return 0;
    // start field managed
    vl_api_u8_fromjson(item, &a->managed);
    // end field managed

    // processing sw_interface_ip6nd_ra_config: u8 other
    item = cJSON_GetObjectItem(o, "other");
    if (!item) return 0;
    // start field other
    vl_api_u8_fromjson(item, &a->other);
    // end field other

    // processing sw_interface_ip6nd_ra_config: u8 ll_option
    item = cJSON_GetObjectItem(o, "ll_option");
    if (!item) return 0;
    // start field ll_option
    vl_api_u8_fromjson(item, &a->ll_option);
    // end field ll_option

    // processing sw_interface_ip6nd_ra_config: u8 send_unicast
    item = cJSON_GetObjectItem(o, "send_unicast");
    if (!item) return 0;
    // start field send_unicast
    vl_api_u8_fromjson(item, &a->send_unicast);
    // end field send_unicast

    // processing sw_interface_ip6nd_ra_config: u8 cease
    item = cJSON_GetObjectItem(o, "cease");
    if (!item) return 0;
    // start field cease
    vl_api_u8_fromjson(item, &a->cease);
    // end field cease

    // processing sw_interface_ip6nd_ra_config: bool is_no
    item = cJSON_GetObjectItem(o, "is_no");
    if (!item) return 0;
    // start field is_no
    vl_api_bool_fromjson(item, &a->is_no);
    // end field is_no

    // processing sw_interface_ip6nd_ra_config: u8 default_router
    item = cJSON_GetObjectItem(o, "default_router");
    if (!item) return 0;
    // start field default_router
    vl_api_u8_fromjson(item, &a->default_router);
    // end field default_router

    // processing sw_interface_ip6nd_ra_config: u32 max_interval
    item = cJSON_GetObjectItem(o, "max_interval");
    if (!item) return 0;
    // start field max_interval
    vl_api_u32_fromjson(item, &a->max_interval);
    // end field max_interval

    // processing sw_interface_ip6nd_ra_config: u32 min_interval
    item = cJSON_GetObjectItem(o, "min_interval");
    if (!item) return 0;
    // start field min_interval
    vl_api_u32_fromjson(item, &a->min_interval);
    // end field min_interval

    // processing sw_interface_ip6nd_ra_config: u32 lifetime
    item = cJSON_GetObjectItem(o, "lifetime");
    if (!item) return 0;
    // start field lifetime
    vl_api_u32_fromjson(item, &a->lifetime);
    // end field lifetime

    // processing sw_interface_ip6nd_ra_config: u32 initial_count
    item = cJSON_GetObjectItem(o, "initial_count");
    if (!item) return 0;
    // start field initial_count
    vl_api_u32_fromjson(item, &a->initial_count);
    // end field initial_count

    // processing sw_interface_ip6nd_ra_config: u32 initial_interval
    item = cJSON_GetObjectItem(o, "initial_interval");
    if (!item) return 0;
    // start field initial_interval
    vl_api_u32_fromjson(item, &a->initial_interval);
    // end field initial_interval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6nd_ra_config_reply_t *vl_api_sw_interface_ip6nd_ra_config_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6nd_ra_config_reply_t);
    vl_api_sw_interface_ip6nd_ra_config_reply_t *a = malloc(l);
    // processing sw_interface_ip6nd_ra_config_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6nd_ra_prefix_t *vl_api_sw_interface_ip6nd_ra_prefix_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6nd_ra_prefix_t);
    vl_api_sw_interface_ip6nd_ra_prefix_t *a = malloc(l);
    // processing sw_interface_ip6nd_ra_prefix: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_ip6nd_ra_prefix: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing sw_interface_ip6nd_ra_prefix: bool use_default
    item = cJSON_GetObjectItem(o, "use_default");
    if (!item) return 0;
    // start field use_default
    vl_api_bool_fromjson(item, &a->use_default);
    // end field use_default

    // processing sw_interface_ip6nd_ra_prefix: bool no_advertise
    item = cJSON_GetObjectItem(o, "no_advertise");
    if (!item) return 0;
    // start field no_advertise
    vl_api_bool_fromjson(item, &a->no_advertise);
    // end field no_advertise

    // processing sw_interface_ip6nd_ra_prefix: bool off_link
    item = cJSON_GetObjectItem(o, "off_link");
    if (!item) return 0;
    // start field off_link
    vl_api_bool_fromjson(item, &a->off_link);
    // end field off_link

    // processing sw_interface_ip6nd_ra_prefix: bool no_autoconfig
    item = cJSON_GetObjectItem(o, "no_autoconfig");
    if (!item) return 0;
    // start field no_autoconfig
    vl_api_bool_fromjson(item, &a->no_autoconfig);
    // end field no_autoconfig

    // processing sw_interface_ip6nd_ra_prefix: bool no_onlink
    item = cJSON_GetObjectItem(o, "no_onlink");
    if (!item) return 0;
    // start field no_onlink
    vl_api_bool_fromjson(item, &a->no_onlink);
    // end field no_onlink

    // processing sw_interface_ip6nd_ra_prefix: bool is_no
    item = cJSON_GetObjectItem(o, "is_no");
    if (!item) return 0;
    // start field is_no
    vl_api_bool_fromjson(item, &a->is_no);
    // end field is_no

    // processing sw_interface_ip6nd_ra_prefix: u32 val_lifetime
    item = cJSON_GetObjectItem(o, "val_lifetime");
    if (!item) return 0;
    // start field val_lifetime
    vl_api_u32_fromjson(item, &a->val_lifetime);
    // end field val_lifetime

    // processing sw_interface_ip6nd_ra_prefix: u32 pref_lifetime
    item = cJSON_GetObjectItem(o, "pref_lifetime");
    if (!item) return 0;
    // start field pref_lifetime
    vl_api_u32_fromjson(item, &a->pref_lifetime);
    // end field pref_lifetime


    *len = l;
    return a;
}
static inline vl_api_sw_interface_ip6nd_ra_prefix_reply_t *vl_api_sw_interface_ip6nd_ra_prefix_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_ip6nd_ra_prefix_reply_t);
    vl_api_sw_interface_ip6nd_ra_prefix_reply_t *a = malloc(l);
    // processing sw_interface_ip6nd_ra_prefix_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip6nd_proxy_add_del_t *vl_api_ip6nd_proxy_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_proxy_add_del_t);
    vl_api_ip6nd_proxy_add_del_t *a = malloc(l);
    // processing ip6nd_proxy_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip6nd_proxy_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ip6nd_proxy_add_del: vl_api_ip6_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip


    *len = l;
    return a;
}
static inline vl_api_ip6nd_proxy_add_del_reply_t *vl_api_ip6nd_proxy_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_proxy_add_del_reply_t);
    vl_api_ip6nd_proxy_add_del_reply_t *a = malloc(l);
    // processing ip6nd_proxy_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip6nd_proxy_details_t *vl_api_ip6nd_proxy_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_proxy_details_t);
    vl_api_ip6nd_proxy_details_t *a = malloc(l);
    // processing ip6nd_proxy_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip6nd_proxy_details: vl_api_ip6_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip


    *len = l;
    return a;
}
static inline vl_api_ip6nd_proxy_dump_t *vl_api_ip6nd_proxy_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_proxy_dump_t);
    vl_api_ip6nd_proxy_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ip6nd_send_router_solicitation_t *vl_api_ip6nd_send_router_solicitation_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_send_router_solicitation_t);
    vl_api_ip6nd_send_router_solicitation_t *a = malloc(l);
    // processing ip6nd_send_router_solicitation: u32 irt
    item = cJSON_GetObjectItem(o, "irt");
    if (!item) return 0;
    // start field irt
    vl_api_u32_fromjson(item, &a->irt);
    // end field irt

    // processing ip6nd_send_router_solicitation: u32 mrt
    item = cJSON_GetObjectItem(o, "mrt");
    if (!item) return 0;
    // start field mrt
    vl_api_u32_fromjson(item, &a->mrt);
    // end field mrt

    // processing ip6nd_send_router_solicitation: u32 mrc
    item = cJSON_GetObjectItem(o, "mrc");
    if (!item) return 0;
    // start field mrc
    vl_api_u32_fromjson(item, &a->mrc);
    // end field mrc

    // processing ip6nd_send_router_solicitation: u32 mrd
    item = cJSON_GetObjectItem(o, "mrd");
    if (!item) return 0;
    // start field mrd
    vl_api_u32_fromjson(item, &a->mrd);
    // end field mrd

    // processing ip6nd_send_router_solicitation: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip6nd_send_router_solicitation: bool stop
    item = cJSON_GetObjectItem(o, "stop");
    if (!item) return 0;
    // start field stop
    vl_api_bool_fromjson(item, &a->stop);
    // end field stop


    *len = l;
    return a;
}
static inline vl_api_ip6nd_send_router_solicitation_reply_t *vl_api_ip6nd_send_router_solicitation_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6nd_send_router_solicitation_reply_t);
    vl_api_ip6nd_send_router_solicitation_reply_t *a = malloc(l);
    // processing ip6nd_send_router_solicitation_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_want_ip6_ra_events_t *vl_api_want_ip6_ra_events_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip6_ra_events_t);
    vl_api_want_ip6_ra_events_t *a = malloc(l);
    // processing want_ip6_ra_events: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing want_ip6_ra_events: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid


    *len = l;
    return a;
}
static inline vl_api_want_ip6_ra_events_reply_t *vl_api_want_ip6_ra_events_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_ip6_ra_events_reply_t);
    vl_api_want_ip6_ra_events_reply_t *a = malloc(l);
    // processing want_ip6_ra_events_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ip6_ra_event_t *vl_api_ip6_ra_event_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6_ra_event_t);
    vl_api_ip6_ra_event_t *a = malloc(l);
    // processing ip6_ra_event: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing ip6_ra_event: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip6_ra_event: vl_api_ip6_address_t router_addr
    item = cJSON_GetObjectItem(o, "router_addr");
    if (!item) return 0;
    // start field router_addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->router_addr);
    if (!a) return 0;
    // end field router_addr

    // processing ip6_ra_event: u8 current_hop_limit
    item = cJSON_GetObjectItem(o, "current_hop_limit");
    if (!item) return 0;
    // start field current_hop_limit
    vl_api_u8_fromjson(item, &a->current_hop_limit);
    // end field current_hop_limit

    // processing ip6_ra_event: u8 flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    vl_api_u8_fromjson(item, &a->flags);
    // end field flags

    // processing ip6_ra_event: u16 router_lifetime_in_sec
    item = cJSON_GetObjectItem(o, "router_lifetime_in_sec");
    if (!item) return 0;
    // start field router_lifetime_in_sec
    vl_api_u16_fromjson(item, &a->router_lifetime_in_sec);
    // end field router_lifetime_in_sec

    // processing ip6_ra_event: u32 neighbor_reachable_time_in_msec
    item = cJSON_GetObjectItem(o, "neighbor_reachable_time_in_msec");
    if (!item) return 0;
    // start field neighbor_reachable_time_in_msec
    vl_api_u32_fromjson(item, &a->neighbor_reachable_time_in_msec);
    // end field neighbor_reachable_time_in_msec

    // processing ip6_ra_event: u32 time_in_msec_between_retransmitted_neighbor_solicitations
    item = cJSON_GetObjectItem(o, "time_in_msec_between_retransmitted_neighbor_solicitations");
    if (!item) return 0;
    // start field time_in_msec_between_retransmitted_neighbor_solicitations
    vl_api_u32_fromjson(item, &a->time_in_msec_between_retransmitted_neighbor_solicitations);
    // end field time_in_msec_between_retransmitted_neighbor_solicitations

    // processing ip6_ra_event: vl_api_ip6_ra_prefix_info_t prefixes
    item = cJSON_GetObjectItem(o, "prefixes");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "prefixes");
        int size = cJSON_GetArraySize(array);
        a->n_prefixes = size;
        a = realloc(a, l + sizeof(vl_api_ip6_ra_prefix_info_t) * size);
        vl_api_ip6_ra_prefix_info_t *d = (void *)a + l;
        l += sizeof(vl_api_ip6_ra_prefix_info_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_ip6_ra_prefix_info_t_fromjson(a, len, e, &d[i]); 
        }
    }


    *len = l;
    return a;
}
#endif
