/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_ipfix_export_api_fromjson_h
#define included_ipfix_export_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_set_ipfix_exporter_t *vl_api_set_ipfix_exporter_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ipfix_exporter_t);
    vl_api_set_ipfix_exporter_t *a = malloc(l);
    // processing set_ipfix_exporter: vl_api_address_t collector_address
    item = cJSON_GetObjectItem(o, "collector_address");
    if (!item) return 0;
    // start field collector_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->collector_address);
    if (!a) return 0;
    // end field collector_address

    // processing set_ipfix_exporter: u16 collector_port
    item = cJSON_GetObjectItem(o, "collector_port");
    if (!item) return 0;
    // start field collector_port
    vl_api_u16_fromjson(item, &a->collector_port);
    // end field collector_port

    // processing set_ipfix_exporter: vl_api_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing set_ipfix_exporter: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing set_ipfix_exporter: u32 path_mtu
    item = cJSON_GetObjectItem(o, "path_mtu");
    if (!item) return 0;
    // start field path_mtu
    vl_api_u32_fromjson(item, &a->path_mtu);
    // end field path_mtu

    // processing set_ipfix_exporter: u32 template_interval
    item = cJSON_GetObjectItem(o, "template_interval");
    if (!item) return 0;
    // start field template_interval
    vl_api_u32_fromjson(item, &a->template_interval);
    // end field template_interval

    // processing set_ipfix_exporter: bool udp_checksum
    item = cJSON_GetObjectItem(o, "udp_checksum");
    if (!item) return 0;
    // start field udp_checksum
    vl_api_bool_fromjson(item, &a->udp_checksum);
    // end field udp_checksum


    *len = l;
    return a;
}
static inline vl_api_set_ipfix_exporter_reply_t *vl_api_set_ipfix_exporter_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ipfix_exporter_reply_t);
    vl_api_set_ipfix_exporter_reply_t *a = malloc(l);
    // processing set_ipfix_exporter_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipfix_exporter_dump_t *vl_api_ipfix_exporter_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_exporter_dump_t);
    vl_api_ipfix_exporter_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipfix_exporter_details_t *vl_api_ipfix_exporter_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_exporter_details_t);
    vl_api_ipfix_exporter_details_t *a = malloc(l);
    // processing ipfix_exporter_details: vl_api_address_t collector_address
    item = cJSON_GetObjectItem(o, "collector_address");
    if (!item) return 0;
    // start field collector_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->collector_address);
    if (!a) return 0;
    // end field collector_address

    // processing ipfix_exporter_details: u16 collector_port
    item = cJSON_GetObjectItem(o, "collector_port");
    if (!item) return 0;
    // start field collector_port
    vl_api_u16_fromjson(item, &a->collector_port);
    // end field collector_port

    // processing ipfix_exporter_details: vl_api_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing ipfix_exporter_details: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing ipfix_exporter_details: u32 path_mtu
    item = cJSON_GetObjectItem(o, "path_mtu");
    if (!item) return 0;
    // start field path_mtu
    vl_api_u32_fromjson(item, &a->path_mtu);
    // end field path_mtu

    // processing ipfix_exporter_details: u32 template_interval
    item = cJSON_GetObjectItem(o, "template_interval");
    if (!item) return 0;
    // start field template_interval
    vl_api_u32_fromjson(item, &a->template_interval);
    // end field template_interval

    // processing ipfix_exporter_details: bool udp_checksum
    item = cJSON_GetObjectItem(o, "udp_checksum");
    if (!item) return 0;
    // start field udp_checksum
    vl_api_bool_fromjson(item, &a->udp_checksum);
    // end field udp_checksum


    *len = l;
    return a;
}
static inline vl_api_set_ipfix_classify_stream_t *vl_api_set_ipfix_classify_stream_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ipfix_classify_stream_t);
    vl_api_set_ipfix_classify_stream_t *a = malloc(l);
    // processing set_ipfix_classify_stream: u32 domain_id
    item = cJSON_GetObjectItem(o, "domain_id");
    if (!item) return 0;
    // start field domain_id
    vl_api_u32_fromjson(item, &a->domain_id);
    // end field domain_id

    // processing set_ipfix_classify_stream: u16 src_port
    item = cJSON_GetObjectItem(o, "src_port");
    if (!item) return 0;
    // start field src_port
    vl_api_u16_fromjson(item, &a->src_port);
    // end field src_port


    *len = l;
    return a;
}
static inline vl_api_set_ipfix_classify_stream_reply_t *vl_api_set_ipfix_classify_stream_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_set_ipfix_classify_stream_reply_t);
    vl_api_set_ipfix_classify_stream_reply_t *a = malloc(l);
    // processing set_ipfix_classify_stream_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_stream_dump_t *vl_api_ipfix_classify_stream_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_stream_dump_t);
    vl_api_ipfix_classify_stream_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_stream_details_t *vl_api_ipfix_classify_stream_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_stream_details_t);
    vl_api_ipfix_classify_stream_details_t *a = malloc(l);
    // processing ipfix_classify_stream_details: u32 domain_id
    item = cJSON_GetObjectItem(o, "domain_id");
    if (!item) return 0;
    // start field domain_id
    vl_api_u32_fromjson(item, &a->domain_id);
    // end field domain_id

    // processing ipfix_classify_stream_details: u16 src_port
    item = cJSON_GetObjectItem(o, "src_port");
    if (!item) return 0;
    // start field src_port
    vl_api_u16_fromjson(item, &a->src_port);
    // end field src_port


    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_table_add_del_t *vl_api_ipfix_classify_table_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_table_add_del_t);
    vl_api_ipfix_classify_table_add_del_t *a = malloc(l);
    // processing ipfix_classify_table_add_del: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing ipfix_classify_table_add_del: vl_api_address_family_t ip_version
    item = cJSON_GetObjectItem(o, "ip_version");
    if (!item) return 0;
    // start field ip_version
    a = vl_api_address_family_t_fromjson(a, &l, item, &a->ip_version);
    if (!a) return 0;
    // end field ip_version

    // processing ipfix_classify_table_add_del: vl_api_ip_proto_t transport_protocol
    item = cJSON_GetObjectItem(o, "transport_protocol");
    if (!item) return 0;
    // start field transport_protocol
    a = vl_api_ip_proto_t_fromjson(a, &l, item, &a->transport_protocol);
    if (!a) return 0;
    // end field transport_protocol

    // processing ipfix_classify_table_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_table_add_del_reply_t *vl_api_ipfix_classify_table_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_table_add_del_reply_t);
    vl_api_ipfix_classify_table_add_del_reply_t *a = malloc(l);
    // processing ipfix_classify_table_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_table_dump_t *vl_api_ipfix_classify_table_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_table_dump_t);
    vl_api_ipfix_classify_table_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipfix_classify_table_details_t *vl_api_ipfix_classify_table_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_classify_table_details_t);
    vl_api_ipfix_classify_table_details_t *a = malloc(l);
    // processing ipfix_classify_table_details: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing ipfix_classify_table_details: vl_api_address_family_t ip_version
    item = cJSON_GetObjectItem(o, "ip_version");
    if (!item) return 0;
    // start field ip_version
    a = vl_api_address_family_t_fromjson(a, &l, item, &a->ip_version);
    if (!a) return 0;
    // end field ip_version

    // processing ipfix_classify_table_details: vl_api_ip_proto_t transport_protocol
    item = cJSON_GetObjectItem(o, "transport_protocol");
    if (!item) return 0;
    // start field transport_protocol
    a = vl_api_ip_proto_t_fromjson(a, &l, item, &a->transport_protocol);
    if (!a) return 0;
    // end field transport_protocol


    *len = l;
    return a;
}
static inline vl_api_ipfix_flush_t *vl_api_ipfix_flush_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_flush_t);
    vl_api_ipfix_flush_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipfix_flush_reply_t *vl_api_ipfix_flush_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipfix_flush_reply_t);
    vl_api_ipfix_flush_reply_t *a = malloc(l);
    // processing ipfix_flush_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
