/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/tunnel/tunnel_types.api_fromjson.h>
#ifndef included_ipip_api_fromjson_h
#define included_ipip_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ipip_tunnel_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipip_tunnel_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "instance");
    if (!item) return 0;
    // start field instance
    vl_api_u32_fromjson(item, &a->instance);
    // end field instance
    item = cJSON_GetObjectItem(o, "src");
    if (!item) return 0;
    // start field src
    mp = vl_api_address_t_fromjson(mp, len, item, &a->src);
    if (!mp) return 0;
    // end field src
    item = cJSON_GetObjectItem(o, "dst");
    if (!item) return 0;
    // start field dst
    mp = vl_api_address_t_fromjson(mp, len, item, &a->dst);
    if (!mp) return 0;
    // end field dst
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    mp = vl_api_tunnel_encap_decap_flags_t_fromjson(mp, len, item, &a->flags);
    if (!mp) return 0;
    // end field flags
    item = cJSON_GetObjectItem(o, "mode");
    if (!item) return 0;
    // start field mode
    mp = vl_api_tunnel_mode_t_fromjson(mp, len, item, &a->mode);
    if (!mp) return 0;
    // end field mode
    item = cJSON_GetObjectItem(o, "dscp");
    if (!item) return 0;
    // start field dscp
    mp = vl_api_ip_dscp_t_fromjson(mp, len, item, &a->dscp);
    if (!mp) return 0;
    // end field dscp
    return mp;
}
static inline vl_api_ipip_add_tunnel_t *vl_api_ipip_add_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_add_tunnel_t);
    vl_api_ipip_add_tunnel_t *a = malloc(l);
    // processing ipip_add_tunnel: vl_api_ipip_tunnel_t tunnel
    item = cJSON_GetObjectItem(o, "tunnel");
    if (!item) return 0;
    // start field tunnel
    a = vl_api_ipip_tunnel_t_fromjson(a, &l, item, &a->tunnel);
    if (!a) return 0;
    // end field tunnel


    *len = l;
    return a;
}
static inline vl_api_ipip_add_tunnel_reply_t *vl_api_ipip_add_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_add_tunnel_reply_t);
    vl_api_ipip_add_tunnel_reply_t *a = malloc(l);
    // processing ipip_add_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipip_add_tunnel_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipip_del_tunnel_t *vl_api_ipip_del_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_del_tunnel_t);
    vl_api_ipip_del_tunnel_t *a = malloc(l);
    // processing ipip_del_tunnel: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipip_del_tunnel_reply_t *vl_api_ipip_del_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_del_tunnel_reply_t);
    vl_api_ipip_del_tunnel_reply_t *a = malloc(l);
    // processing ipip_del_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipip_6rd_add_tunnel_t *vl_api_ipip_6rd_add_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_6rd_add_tunnel_t);
    vl_api_ipip_6rd_add_tunnel_t *a = malloc(l);
    // processing ipip_6rd_add_tunnel: u32 ip6_table_id
    item = cJSON_GetObjectItem(o, "ip6_table_id");
    if (!item) return 0;
    // start field ip6_table_id
    vl_api_u32_fromjson(item, &a->ip6_table_id);
    // end field ip6_table_id

    // processing ipip_6rd_add_tunnel: u32 ip4_table_id
    item = cJSON_GetObjectItem(o, "ip4_table_id");
    if (!item) return 0;
    // start field ip4_table_id
    vl_api_u32_fromjson(item, &a->ip4_table_id);
    // end field ip4_table_id

    // processing ipip_6rd_add_tunnel: vl_api_ip6_prefix_t ip6_prefix
    item = cJSON_GetObjectItem(o, "ip6_prefix");
    if (!item) return 0;
    // start field ip6_prefix
    a = vl_api_ip6_prefix_t_fromjson(a, &l, item, &a->ip6_prefix);
    if (!a) return 0;
    // end field ip6_prefix

    // processing ipip_6rd_add_tunnel: vl_api_ip4_prefix_t ip4_prefix
    item = cJSON_GetObjectItem(o, "ip4_prefix");
    if (!item) return 0;
    // start field ip4_prefix
    a = vl_api_ip4_prefix_t_fromjson(a, &l, item, &a->ip4_prefix);
    if (!a) return 0;
    // end field ip4_prefix

    // processing ipip_6rd_add_tunnel: vl_api_ip4_address_t ip4_src
    item = cJSON_GetObjectItem(o, "ip4_src");
    if (!item) return 0;
    // start field ip4_src
    a = vl_api_ip4_address_t_fromjson(a, &l, item, &a->ip4_src);
    if (!a) return 0;
    // end field ip4_src

    // processing ipip_6rd_add_tunnel: bool security_check
    item = cJSON_GetObjectItem(o, "security_check");
    if (!item) return 0;
    // start field security_check
    vl_api_bool_fromjson(item, &a->security_check);
    // end field security_check

    // processing ipip_6rd_add_tunnel: u8 tc_tos
    item = cJSON_GetObjectItem(o, "tc_tos");
    if (!item) return 0;
    // start field tc_tos
    vl_api_u8_fromjson(item, &a->tc_tos);
    // end field tc_tos


    *len = l;
    return a;
}
static inline vl_api_ipip_6rd_add_tunnel_reply_t *vl_api_ipip_6rd_add_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_6rd_add_tunnel_reply_t);
    vl_api_ipip_6rd_add_tunnel_reply_t *a = malloc(l);
    // processing ipip_6rd_add_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipip_6rd_add_tunnel_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipip_6rd_del_tunnel_t *vl_api_ipip_6rd_del_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_6rd_del_tunnel_t);
    vl_api_ipip_6rd_del_tunnel_t *a = malloc(l);
    // processing ipip_6rd_del_tunnel: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipip_6rd_del_tunnel_reply_t *vl_api_ipip_6rd_del_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_6rd_del_tunnel_reply_t);
    vl_api_ipip_6rd_del_tunnel_reply_t *a = malloc(l);
    // processing ipip_6rd_del_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipip_tunnel_dump_t *vl_api_ipip_tunnel_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_tunnel_dump_t);
    vl_api_ipip_tunnel_dump_t *a = malloc(l);
    // processing ipip_tunnel_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipip_tunnel_details_t *vl_api_ipip_tunnel_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipip_tunnel_details_t);
    vl_api_ipip_tunnel_details_t *a = malloc(l);
    // processing ipip_tunnel_details: vl_api_ipip_tunnel_t tunnel
    item = cJSON_GetObjectItem(o, "tunnel");
    if (!item) return 0;
    // start field tunnel
    a = vl_api_ipip_tunnel_t_fromjson(a, &l, item, &a->tunnel);
    if (!a) return 0;
    // end field tunnel


    *len = l;
    return a;
}
#endif
