/* Imported API files */
#include <vnet/ipsec/ipsec_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/tunnel/tunnel_types.api_fromjson.h>
#ifndef included_ipsec_api_fromjson_h
#define included_ipsec_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ipsec_spd_action_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_spd_action_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IPSEC_API_SPD_ACTION_BYPASS") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IPSEC_API_SPD_ACTION_DISCARD") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IPSEC_API_SPD_ACTION_RESOLVE") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IPSEC_API_SPD_ACTION_PROTECT") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_ipsec_spd_entry_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_spd_entry_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "spd_id");
    if (!item) return 0;
    // start field spd_id
    vl_api_u32_fromjson(item, &a->spd_id);
    // end field spd_id
    item = cJSON_GetObjectItem(o, "priority");
    if (!item) return 0;
    // start field priority
    vl_api_i32_fromjson(item, &a->priority);
    // end field priority
    item = cJSON_GetObjectItem(o, "is_outbound");
    if (!item) return 0;
    // start field is_outbound
    vl_api_bool_fromjson(item, &a->is_outbound);
    // end field is_outbound
    item = cJSON_GetObjectItem(o, "sa_id");
    if (!item) return 0;
    // start field sa_id
    vl_api_u32_fromjson(item, &a->sa_id);
    // end field sa_id
    item = cJSON_GetObjectItem(o, "policy");
    if (!item) return 0;
    // start field policy
    mp = vl_api_ipsec_spd_action_t_fromjson(mp, len, item, &a->policy);
    if (!mp) return 0;
    // end field policy
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    vl_api_u8_fromjson(item, &a->protocol);
    // end field protocol
    item = cJSON_GetObjectItem(o, "remote_address_start");
    if (!item) return 0;
    // start field remote_address_start
    mp = vl_api_address_t_fromjson(mp, len, item, &a->remote_address_start);
    if (!mp) return 0;
    // end field remote_address_start
    item = cJSON_GetObjectItem(o, "remote_address_stop");
    if (!item) return 0;
    // start field remote_address_stop
    mp = vl_api_address_t_fromjson(mp, len, item, &a->remote_address_stop);
    if (!mp) return 0;
    // end field remote_address_stop
    item = cJSON_GetObjectItem(o, "local_address_start");
    if (!item) return 0;
    // start field local_address_start
    mp = vl_api_address_t_fromjson(mp, len, item, &a->local_address_start);
    if (!mp) return 0;
    // end field local_address_start
    item = cJSON_GetObjectItem(o, "local_address_stop");
    if (!item) return 0;
    // start field local_address_stop
    mp = vl_api_address_t_fromjson(mp, len, item, &a->local_address_stop);
    if (!mp) return 0;
    // end field local_address_stop
    item = cJSON_GetObjectItem(o, "remote_port_start");
    if (!item) return 0;
    // start field remote_port_start
    vl_api_u16_fromjson(item, &a->remote_port_start);
    // end field remote_port_start
    item = cJSON_GetObjectItem(o, "remote_port_stop");
    if (!item) return 0;
    // start field remote_port_stop
    vl_api_u16_fromjson(item, &a->remote_port_stop);
    // end field remote_port_stop
    item = cJSON_GetObjectItem(o, "local_port_start");
    if (!item) return 0;
    // start field local_port_start
    vl_api_u16_fromjson(item, &a->local_port_start);
    // end field local_port_start
    item = cJSON_GetObjectItem(o, "local_port_stop");
    if (!item) return 0;
    // start field local_port_stop
    vl_api_u16_fromjson(item, &a->local_port_stop);
    // end field local_port_stop
    return mp;
}
static inline void *vl_api_ipsec_tunnel_protect_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_tunnel_protect_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "nh");
    if (!item) return 0;
    // start field nh
    mp = vl_api_address_t_fromjson(mp, len, item, &a->nh);
    if (!mp) return 0;
    // end field nh
    item = cJSON_GetObjectItem(o, "sa_out");
    if (!item) return 0;
    // start field sa_out
    vl_api_u32_fromjson(item, &a->sa_out);
    // end field sa_out
    item = cJSON_GetObjectItem(o, "sa_in");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sa_in");
        int size = cJSON_GetArraySize(array);
        a->n_sa_in = size;
        mp = realloc(mp, *len + sizeof(u32) * size);
        u32 *d = (void *)mp + *len;
        *len += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }
    return mp;
}
static inline void *vl_api_ipsec_itf_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_itf_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "user_instance");
    if (!item) return 0;
    // start field user_instance
    vl_api_u32_fromjson(item, &a->user_instance);
    // end field user_instance
    item = cJSON_GetObjectItem(o, "mode");
    if (!item) return 0;
    // start field mode
    mp = vl_api_tunnel_mode_t_fromjson(mp, len, item, &a->mode);
    if (!mp) return 0;
    // end field mode
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    return mp;
}
static inline vl_api_ipsec_spd_add_del_t *vl_api_ipsec_spd_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_add_del_t);
    vl_api_ipsec_spd_add_del_t *a = malloc(l);
    // processing ipsec_spd_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_spd_add_del: u32 spd_id
    item = cJSON_GetObjectItem(o, "spd_id");
    if (!item) return 0;
    // start field spd_id
    vl_api_u32_fromjson(item, &a->spd_id);
    // end field spd_id


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_add_del_reply_t *vl_api_ipsec_spd_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_add_del_reply_t);
    vl_api_ipsec_spd_add_del_reply_t *a = malloc(l);
    // processing ipsec_spd_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_interface_add_del_spd_t *vl_api_ipsec_interface_add_del_spd_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_interface_add_del_spd_t);
    vl_api_ipsec_interface_add_del_spd_t *a = malloc(l);
    // processing ipsec_interface_add_del_spd: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_interface_add_del_spd: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ipsec_interface_add_del_spd: u32 spd_id
    item = cJSON_GetObjectItem(o, "spd_id");
    if (!item) return 0;
    // start field spd_id
    vl_api_u32_fromjson(item, &a->spd_id);
    // end field spd_id


    *len = l;
    return a;
}
static inline vl_api_ipsec_interface_add_del_spd_reply_t *vl_api_ipsec_interface_add_del_spd_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_interface_add_del_spd_reply_t);
    vl_api_ipsec_interface_add_del_spd_reply_t *a = malloc(l);
    // processing ipsec_interface_add_del_spd_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_entry_add_del_t *vl_api_ipsec_spd_entry_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_entry_add_del_t);
    vl_api_ipsec_spd_entry_add_del_t *a = malloc(l);
    // processing ipsec_spd_entry_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_spd_entry_add_del: vl_api_ipsec_spd_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_spd_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_entry_add_del_reply_t *vl_api_ipsec_spd_entry_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_entry_add_del_reply_t);
    vl_api_ipsec_spd_entry_add_del_reply_t *a = malloc(l);
    // processing ipsec_spd_entry_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipsec_spd_entry_add_del_reply: u32 stat_index
    item = cJSON_GetObjectItem(o, "stat_index");
    if (!item) return 0;
    // start field stat_index
    vl_api_u32_fromjson(item, &a->stat_index);
    // end field stat_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_spds_dump_t *vl_api_ipsec_spds_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spds_dump_t);
    vl_api_ipsec_spds_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipsec_spds_details_t *vl_api_ipsec_spds_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spds_details_t);
    vl_api_ipsec_spds_details_t *a = malloc(l);
    // processing ipsec_spds_details: u32 spd_id
    item = cJSON_GetObjectItem(o, "spd_id");
    if (!item) return 0;
    // start field spd_id
    vl_api_u32_fromjson(item, &a->spd_id);
    // end field spd_id

    // processing ipsec_spds_details: u32 npolicies
    item = cJSON_GetObjectItem(o, "npolicies");
    if (!item) return 0;
    // start field npolicies
    vl_api_u32_fromjson(item, &a->npolicies);
    // end field npolicies


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_dump_t *vl_api_ipsec_spd_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_dump_t);
    vl_api_ipsec_spd_dump_t *a = malloc(l);
    // processing ipsec_spd_dump: u32 spd_id
    item = cJSON_GetObjectItem(o, "spd_id");
    if (!item) return 0;
    // start field spd_id
    vl_api_u32_fromjson(item, &a->spd_id);
    // end field spd_id

    // processing ipsec_spd_dump: u32 sa_id
    item = cJSON_GetObjectItem(o, "sa_id");
    if (!item) return 0;
    // start field sa_id
    vl_api_u32_fromjson(item, &a->sa_id);
    // end field sa_id


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_details_t *vl_api_ipsec_spd_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_details_t);
    vl_api_ipsec_spd_details_t *a = malloc(l);
    // processing ipsec_spd_details: vl_api_ipsec_spd_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_spd_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_ipsec_sad_entry_add_del_t *vl_api_ipsec_sad_entry_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sad_entry_add_del_t);
    vl_api_ipsec_sad_entry_add_del_t *a = malloc(l);
    // processing ipsec_sad_entry_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_sad_entry_add_del: vl_api_ipsec_sad_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_sad_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_ipsec_sad_entry_add_del_v2_t *vl_api_ipsec_sad_entry_add_del_v2_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sad_entry_add_del_v2_t);
    vl_api_ipsec_sad_entry_add_del_v2_t *a = malloc(l);
    // processing ipsec_sad_entry_add_del_v2: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_sad_entry_add_del_v2: vl_api_ipsec_sad_entry_v2_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_sad_entry_v2_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_ipsec_sad_entry_add_del_reply_t *vl_api_ipsec_sad_entry_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sad_entry_add_del_reply_t);
    vl_api_ipsec_sad_entry_add_del_reply_t *a = malloc(l);
    // processing ipsec_sad_entry_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipsec_sad_entry_add_del_reply: u32 stat_index
    item = cJSON_GetObjectItem(o, "stat_index");
    if (!item) return 0;
    // start field stat_index
    vl_api_u32_fromjson(item, &a->stat_index);
    // end field stat_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_sad_entry_add_del_v2_reply_t *vl_api_ipsec_sad_entry_add_del_v2_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sad_entry_add_del_v2_reply_t);
    vl_api_ipsec_sad_entry_add_del_v2_reply_t *a = malloc(l);
    // processing ipsec_sad_entry_add_del_v2_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipsec_sad_entry_add_del_v2_reply: u32 stat_index
    item = cJSON_GetObjectItem(o, "stat_index");
    if (!item) return 0;
    // start field stat_index
    vl_api_u32_fromjson(item, &a->stat_index);
    // end field stat_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_update_t *vl_api_ipsec_tunnel_protect_update_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_update_t);
    vl_api_ipsec_tunnel_protect_update_t *a = malloc(l);
    // processing ipsec_tunnel_protect_update: vl_api_ipsec_tunnel_protect_t tunnel
    item = cJSON_GetObjectItem(o, "tunnel");
    if (!item) return 0;
    // start field tunnel
    a = vl_api_ipsec_tunnel_protect_t_fromjson(a, &l, item, &a->tunnel);
    if (!a) return 0;
    // end field tunnel


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_update_reply_t *vl_api_ipsec_tunnel_protect_update_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_update_reply_t);
    vl_api_ipsec_tunnel_protect_update_reply_t *a = malloc(l);
    // processing ipsec_tunnel_protect_update_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_del_t *vl_api_ipsec_tunnel_protect_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_del_t);
    vl_api_ipsec_tunnel_protect_del_t *a = malloc(l);
    // processing ipsec_tunnel_protect_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ipsec_tunnel_protect_del: vl_api_address_t nh
    item = cJSON_GetObjectItem(o, "nh");
    if (!item) return 0;
    // start field nh
    a = vl_api_address_t_fromjson(a, &l, item, &a->nh);
    if (!a) return 0;
    // end field nh


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_del_reply_t *vl_api_ipsec_tunnel_protect_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_del_reply_t);
    vl_api_ipsec_tunnel_protect_del_reply_t *a = malloc(l);
    // processing ipsec_tunnel_protect_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_dump_t *vl_api_ipsec_tunnel_protect_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_dump_t);
    vl_api_ipsec_tunnel_protect_dump_t *a = malloc(l);
    // processing ipsec_tunnel_protect_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_protect_details_t *vl_api_ipsec_tunnel_protect_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_protect_details_t);
    vl_api_ipsec_tunnel_protect_details_t *a = malloc(l);
    // processing ipsec_tunnel_protect_details: vl_api_ipsec_tunnel_protect_t tun
    item = cJSON_GetObjectItem(o, "tun");
    if (!item) return 0;
    // start field tun
    a = vl_api_ipsec_tunnel_protect_t_fromjson(a, &l, item, &a->tun);
    if (!a) return 0;
    // end field tun


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_interface_dump_t *vl_api_ipsec_spd_interface_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_interface_dump_t);
    vl_api_ipsec_spd_interface_dump_t *a = malloc(l);
    // processing ipsec_spd_interface_dump: u32 spd_index
    item = cJSON_GetObjectItem(o, "spd_index");
    if (!item) return 0;
    // start field spd_index
    vl_api_u32_fromjson(item, &a->spd_index);
    // end field spd_index

    // processing ipsec_spd_interface_dump: u8 spd_index_valid
    item = cJSON_GetObjectItem(o, "spd_index_valid");
    if (!item) return 0;
    // start field spd_index_valid
    vl_api_u8_fromjson(item, &a->spd_index_valid);
    // end field spd_index_valid


    *len = l;
    return a;
}
static inline vl_api_ipsec_spd_interface_details_t *vl_api_ipsec_spd_interface_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_spd_interface_details_t);
    vl_api_ipsec_spd_interface_details_t *a = malloc(l);
    // processing ipsec_spd_interface_details: u32 spd_index
    item = cJSON_GetObjectItem(o, "spd_index");
    if (!item) return 0;
    // start field spd_index
    vl_api_u32_fromjson(item, &a->spd_index);
    // end field spd_index

    // processing ipsec_spd_interface_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_if_add_del_t *vl_api_ipsec_tunnel_if_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_if_add_del_t);
    vl_api_ipsec_tunnel_if_add_del_t *a = malloc(l);
    // processing ipsec_tunnel_if_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing ipsec_tunnel_if_add_del: bool esn
    item = cJSON_GetObjectItem(o, "esn");
    if (!item) return 0;
    // start field esn
    vl_api_bool_fromjson(item, &a->esn);
    // end field esn

    // processing ipsec_tunnel_if_add_del: bool anti_replay
    item = cJSON_GetObjectItem(o, "anti_replay");
    if (!item) return 0;
    // start field anti_replay
    vl_api_bool_fromjson(item, &a->anti_replay);
    // end field anti_replay

    // processing ipsec_tunnel_if_add_del: vl_api_address_t local_ip
    item = cJSON_GetObjectItem(o, "local_ip");
    if (!item) return 0;
    // start field local_ip
    a = vl_api_address_t_fromjson(a, &l, item, &a->local_ip);
    if (!a) return 0;
    // end field local_ip

    // processing ipsec_tunnel_if_add_del: vl_api_address_t remote_ip
    item = cJSON_GetObjectItem(o, "remote_ip");
    if (!item) return 0;
    // start field remote_ip
    a = vl_api_address_t_fromjson(a, &l, item, &a->remote_ip);
    if (!a) return 0;
    // end field remote_ip

    // processing ipsec_tunnel_if_add_del: u32 local_spi
    item = cJSON_GetObjectItem(o, "local_spi");
    if (!item) return 0;
    // start field local_spi
    vl_api_u32_fromjson(item, &a->local_spi);
    // end field local_spi

    // processing ipsec_tunnel_if_add_del: u32 remote_spi
    item = cJSON_GetObjectItem(o, "remote_spi");
    if (!item) return 0;
    // start field remote_spi
    vl_api_u32_fromjson(item, &a->remote_spi);
    // end field remote_spi

    // processing ipsec_tunnel_if_add_del: u8 crypto_alg
    item = cJSON_GetObjectItem(o, "crypto_alg");
    if (!item) return 0;
    // start field crypto_alg
    vl_api_u8_fromjson(item, &a->crypto_alg);
    // end field crypto_alg

    // processing ipsec_tunnel_if_add_del: u8 local_crypto_key_len
    item = cJSON_GetObjectItem(o, "local_crypto_key_len");
    if (!item) return 0;
    // start field local_crypto_key_len
    vl_api_u8_fromjson(item, &a->local_crypto_key_len);
    // end field local_crypto_key_len

    // processing ipsec_tunnel_if_add_del: u8 local_crypto_key
    item = cJSON_GetObjectItem(o, "local_crypto_key");
    if (!item) return 0;
    u8string_fromjson2(o, "local_crypto_key", a->local_crypto_key);

    // processing ipsec_tunnel_if_add_del: u8 remote_crypto_key_len
    item = cJSON_GetObjectItem(o, "remote_crypto_key_len");
    if (!item) return 0;
    // start field remote_crypto_key_len
    vl_api_u8_fromjson(item, &a->remote_crypto_key_len);
    // end field remote_crypto_key_len

    // processing ipsec_tunnel_if_add_del: u8 remote_crypto_key
    item = cJSON_GetObjectItem(o, "remote_crypto_key");
    if (!item) return 0;
    u8string_fromjson2(o, "remote_crypto_key", a->remote_crypto_key);

    // processing ipsec_tunnel_if_add_del: u8 integ_alg
    item = cJSON_GetObjectItem(o, "integ_alg");
    if (!item) return 0;
    // start field integ_alg
    vl_api_u8_fromjson(item, &a->integ_alg);
    // end field integ_alg

    // processing ipsec_tunnel_if_add_del: u8 local_integ_key_len
    item = cJSON_GetObjectItem(o, "local_integ_key_len");
    if (!item) return 0;
    // start field local_integ_key_len
    vl_api_u8_fromjson(item, &a->local_integ_key_len);
    // end field local_integ_key_len

    // processing ipsec_tunnel_if_add_del: u8 local_integ_key
    item = cJSON_GetObjectItem(o, "local_integ_key");
    if (!item) return 0;
    u8string_fromjson2(o, "local_integ_key", a->local_integ_key);

    // processing ipsec_tunnel_if_add_del: u8 remote_integ_key_len
    item = cJSON_GetObjectItem(o, "remote_integ_key_len");
    if (!item) return 0;
    // start field remote_integ_key_len
    vl_api_u8_fromjson(item, &a->remote_integ_key_len);
    // end field remote_integ_key_len

    // processing ipsec_tunnel_if_add_del: u8 remote_integ_key
    item = cJSON_GetObjectItem(o, "remote_integ_key");
    if (!item) return 0;
    u8string_fromjson2(o, "remote_integ_key", a->remote_integ_key);

    // processing ipsec_tunnel_if_add_del: bool renumber
    item = cJSON_GetObjectItem(o, "renumber");
    if (!item) return 0;
    // start field renumber
    vl_api_bool_fromjson(item, &a->renumber);
    // end field renumber

    // processing ipsec_tunnel_if_add_del: u32 show_instance
    item = cJSON_GetObjectItem(o, "show_instance");
    if (!item) return 0;
    // start field show_instance
    vl_api_u32_fromjson(item, &a->show_instance);
    // end field show_instance

    // processing ipsec_tunnel_if_add_del: bool udp_encap
    item = cJSON_GetObjectItem(o, "udp_encap");
    if (!item) return 0;
    // start field udp_encap
    vl_api_bool_fromjson(item, &a->udp_encap);
    // end field udp_encap

    // processing ipsec_tunnel_if_add_del: u32 tx_table_id
    item = cJSON_GetObjectItem(o, "tx_table_id");
    if (!item) return 0;
    // start field tx_table_id
    vl_api_u32_fromjson(item, &a->tx_table_id);
    // end field tx_table_id

    // processing ipsec_tunnel_if_add_del: u32 salt
    item = cJSON_GetObjectItem(o, "salt");
    if (!item) return 0;
    // start field salt
    vl_api_u32_fromjson(item, &a->salt);
    // end field salt


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_if_add_del_reply_t *vl_api_ipsec_tunnel_if_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_if_add_del_reply_t);
    vl_api_ipsec_tunnel_if_add_del_reply_t *a = malloc(l);
    // processing ipsec_tunnel_if_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipsec_tunnel_if_add_del_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_create_t *vl_api_ipsec_itf_create_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_create_t);
    vl_api_ipsec_itf_create_t *a = malloc(l);
    // processing ipsec_itf_create: vl_api_ipsec_itf_t itf
    item = cJSON_GetObjectItem(o, "itf");
    if (!item) return 0;
    // start field itf
    a = vl_api_ipsec_itf_t_fromjson(a, &l, item, &a->itf);
    if (!a) return 0;
    // end field itf


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_create_reply_t *vl_api_ipsec_itf_create_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_create_reply_t);
    vl_api_ipsec_itf_create_reply_t *a = malloc(l);
    // processing ipsec_itf_create_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing ipsec_itf_create_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_delete_t *vl_api_ipsec_itf_delete_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_delete_t);
    vl_api_ipsec_itf_delete_t *a = malloc(l);
    // processing ipsec_itf_delete: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_delete_reply_t *vl_api_ipsec_itf_delete_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_delete_reply_t);
    vl_api_ipsec_itf_delete_reply_t *a = malloc(l);
    // processing ipsec_itf_delete_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_dump_t *vl_api_ipsec_itf_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_dump_t);
    vl_api_ipsec_itf_dump_t *a = malloc(l);
    // processing ipsec_itf_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_itf_details_t *vl_api_ipsec_itf_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_itf_details_t);
    vl_api_ipsec_itf_details_t *a = malloc(l);
    // processing ipsec_itf_details: vl_api_ipsec_itf_t itf
    item = cJSON_GetObjectItem(o, "itf");
    if (!item) return 0;
    // start field itf
    a = vl_api_ipsec_itf_t_fromjson(a, &l, item, &a->itf);
    if (!a) return 0;
    // end field itf


    *len = l;
    return a;
}
static inline vl_api_ipsec_sa_dump_t *vl_api_ipsec_sa_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sa_dump_t);
    vl_api_ipsec_sa_dump_t *a = malloc(l);
    // processing ipsec_sa_dump: u32 sa_id
    item = cJSON_GetObjectItem(o, "sa_id");
    if (!item) return 0;
    // start field sa_id
    vl_api_u32_fromjson(item, &a->sa_id);
    // end field sa_id


    *len = l;
    return a;
}
static inline vl_api_ipsec_sa_v2_dump_t *vl_api_ipsec_sa_v2_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sa_v2_dump_t);
    vl_api_ipsec_sa_v2_dump_t *a = malloc(l);
    // processing ipsec_sa_v2_dump: u32 sa_id
    item = cJSON_GetObjectItem(o, "sa_id");
    if (!item) return 0;
    // start field sa_id
    vl_api_u32_fromjson(item, &a->sa_id);
    // end field sa_id


    *len = l;
    return a;
}
static inline vl_api_ipsec_sa_details_t *vl_api_ipsec_sa_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sa_details_t);
    vl_api_ipsec_sa_details_t *a = malloc(l);
    // processing ipsec_sa_details: vl_api_ipsec_sad_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_sad_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry

    // processing ipsec_sa_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ipsec_sa_details: u32 salt
    item = cJSON_GetObjectItem(o, "salt");
    if (!item) return 0;
    // start field salt
    vl_api_u32_fromjson(item, &a->salt);
    // end field salt

    // processing ipsec_sa_details: u64 seq_outbound
    item = cJSON_GetObjectItem(o, "seq_outbound");
    if (!item) return 0;
    // start field seq_outbound
    vl_api_u64_fromjson(item, &a->seq_outbound);
    // end field seq_outbound

    // processing ipsec_sa_details: u64 last_seq_inbound
    item = cJSON_GetObjectItem(o, "last_seq_inbound");
    if (!item) return 0;
    // start field last_seq_inbound
    vl_api_u64_fromjson(item, &a->last_seq_inbound);
    // end field last_seq_inbound

    // processing ipsec_sa_details: u64 replay_window
    item = cJSON_GetObjectItem(o, "replay_window");
    if (!item) return 0;
    // start field replay_window
    vl_api_u64_fromjson(item, &a->replay_window);
    // end field replay_window

    // processing ipsec_sa_details: u32 stat_index
    item = cJSON_GetObjectItem(o, "stat_index");
    if (!item) return 0;
    // start field stat_index
    vl_api_u32_fromjson(item, &a->stat_index);
    // end field stat_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_sa_v2_details_t *vl_api_ipsec_sa_v2_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_sa_v2_details_t);
    vl_api_ipsec_sa_v2_details_t *a = malloc(l);
    // processing ipsec_sa_v2_details: vl_api_ipsec_sad_entry_v2_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_ipsec_sad_entry_v2_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry

    // processing ipsec_sa_v2_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ipsec_sa_v2_details: u32 salt
    item = cJSON_GetObjectItem(o, "salt");
    if (!item) return 0;
    // start field salt
    vl_api_u32_fromjson(item, &a->salt);
    // end field salt

    // processing ipsec_sa_v2_details: u64 seq_outbound
    item = cJSON_GetObjectItem(o, "seq_outbound");
    if (!item) return 0;
    // start field seq_outbound
    vl_api_u64_fromjson(item, &a->seq_outbound);
    // end field seq_outbound

    // processing ipsec_sa_v2_details: u64 last_seq_inbound
    item = cJSON_GetObjectItem(o, "last_seq_inbound");
    if (!item) return 0;
    // start field last_seq_inbound
    vl_api_u64_fromjson(item, &a->last_seq_inbound);
    // end field last_seq_inbound

    // processing ipsec_sa_v2_details: u64 replay_window
    item = cJSON_GetObjectItem(o, "replay_window");
    if (!item) return 0;
    // start field replay_window
    vl_api_u64_fromjson(item, &a->replay_window);
    // end field replay_window

    // processing ipsec_sa_v2_details: u32 stat_index
    item = cJSON_GetObjectItem(o, "stat_index");
    if (!item) return 0;
    // start field stat_index
    vl_api_u32_fromjson(item, &a->stat_index);
    // end field stat_index


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_if_set_sa_t *vl_api_ipsec_tunnel_if_set_sa_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_if_set_sa_t);
    vl_api_ipsec_tunnel_if_set_sa_t *a = malloc(l);
    // processing ipsec_tunnel_if_set_sa: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ipsec_tunnel_if_set_sa: u32 sa_id
    item = cJSON_GetObjectItem(o, "sa_id");
    if (!item) return 0;
    // start field sa_id
    vl_api_u32_fromjson(item, &a->sa_id);
    // end field sa_id

    // processing ipsec_tunnel_if_set_sa: u8 is_outbound
    item = cJSON_GetObjectItem(o, "is_outbound");
    if (!item) return 0;
    // start field is_outbound
    vl_api_u8_fromjson(item, &a->is_outbound);
    // end field is_outbound


    *len = l;
    return a;
}
static inline vl_api_ipsec_tunnel_if_set_sa_reply_t *vl_api_ipsec_tunnel_if_set_sa_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_tunnel_if_set_sa_reply_t);
    vl_api_ipsec_tunnel_if_set_sa_reply_t *a = malloc(l);
    // processing ipsec_tunnel_if_set_sa_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_backend_dump_t *vl_api_ipsec_backend_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_backend_dump_t);
    vl_api_ipsec_backend_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_ipsec_backend_details_t *vl_api_ipsec_backend_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_backend_details_t);
    vl_api_ipsec_backend_details_t *a = malloc(l);
    // processing ipsec_backend_details: string name
    item = cJSON_GetObjectItem(o, "name");
    if (!item) return 0;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    // processing ipsec_backend_details: vl_api_ipsec_proto_t protocol
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    a = vl_api_ipsec_proto_t_fromjson(a, &l, item, &a->protocol);
    if (!a) return 0;
    // end field protocol

    // processing ipsec_backend_details: u8 index
    item = cJSON_GetObjectItem(o, "index");
    if (!item) return 0;
    // start field index
    vl_api_u8_fromjson(item, &a->index);
    // end field index

    // processing ipsec_backend_details: bool active
    item = cJSON_GetObjectItem(o, "active");
    if (!item) return 0;
    // start field active
    vl_api_bool_fromjson(item, &a->active);
    // end field active


    *len = l;
    return a;
}
static inline vl_api_ipsec_select_backend_t *vl_api_ipsec_select_backend_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_select_backend_t);
    vl_api_ipsec_select_backend_t *a = malloc(l);
    // processing ipsec_select_backend: vl_api_ipsec_proto_t protocol
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    a = vl_api_ipsec_proto_t_fromjson(a, &l, item, &a->protocol);
    if (!a) return 0;
    // end field protocol

    // processing ipsec_select_backend: u8 index
    item = cJSON_GetObjectItem(o, "index");
    if (!item) return 0;
    // start field index
    vl_api_u8_fromjson(item, &a->index);
    // end field index


    *len = l;
    return a;
}
static inline vl_api_ipsec_select_backend_reply_t *vl_api_ipsec_select_backend_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_select_backend_reply_t);
    vl_api_ipsec_select_backend_reply_t *a = malloc(l);
    // processing ipsec_select_backend_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_ipsec_set_async_mode_t *vl_api_ipsec_set_async_mode_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_set_async_mode_t);
    vl_api_ipsec_set_async_mode_t *a = malloc(l);
    // processing ipsec_set_async_mode: bool async_enable
    item = cJSON_GetObjectItem(o, "async_enable");
    if (!item) return 0;
    // start field async_enable
    vl_api_bool_fromjson(item, &a->async_enable);
    // end field async_enable


    *len = l;
    return a;
}
static inline vl_api_ipsec_set_async_mode_reply_t *vl_api_ipsec_set_async_mode_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ipsec_set_async_mode_reply_t);
    vl_api_ipsec_set_async_mode_reply_t *a = malloc(l);
    // processing ipsec_set_async_mode_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
