/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/tunnel/tunnel_types.api_fromjson.h>
#ifndef included_ipsec_types_api_fromjson_h
#define included_ipsec_types_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_ipsec_crypto_alg_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_crypto_alg_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CBC_128") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CBC_192") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CBC_256") == 0) {*a = 3; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CTR_128") == 0) {*a = 4; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CTR_192") == 0) {*a = 5; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_CTR_256") == 0) {*a = 6; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_GCM_128") == 0) {*a = 7; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_GCM_192") == 0) {*a = 8; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_AES_GCM_256") == 0) {*a = 9; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_DES_CBC") == 0) {*a = 10; return mp;}
    if (strcmp(p, "IPSEC_API_CRYPTO_ALG_3DES_CBC") == 0) {*a = 11; return mp;}
   return 0;
}
static inline void *vl_api_ipsec_integ_alg_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_integ_alg_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IPSEC_API_INTEG_ALG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_MD5_96") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_SHA1_96") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_SHA_256_96") == 0) {*a = 3; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_SHA_256_128") == 0) {*a = 4; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_SHA_384_192") == 0) {*a = 5; return mp;}
    if (strcmp(p, "IPSEC_API_INTEG_ALG_SHA_512_256") == 0) {*a = 6; return mp;}
   return 0;
}
static inline void *vl_api_ipsec_sad_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_sad_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IPSEC_API_SAD_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_USE_ESN") == 0) {*a = 1; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_USE_ANTI_REPLAY") == 0) {*a = 2; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_IS_TUNNEL") == 0) {*a = 4; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_IS_TUNNEL_V6") == 0) {*a = 8; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_UDP_ENCAP") == 0) {*a = 16; return mp;}
    if (strcmp(p, "IPSEC_API_SAD_FLAG_IS_INBOUND") == 0) {*a = 64; return mp;}
   return 0;
}
static inline void *vl_api_ipsec_proto_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_proto_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "IPSEC_API_PROTO_ESP") == 0) {*a = 50; return mp;}
    if (strcmp(p, "IPSEC_API_PROTO_AH") == 0) {*a = 51; return mp;}
   return 0;
}
static inline void *vl_api_key_t_fromjson (void *mp, int *len, cJSON *o, vl_api_key_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "length");
    if (!item) return 0;
    // start field length
    vl_api_u8_fromjson(item, &a->length);
    // end field length
    item = cJSON_GetObjectItem(o, "data");
    if (!item) return 0;
    u8string_fromjson2(o, "data", a->data);
    return mp;
}
static inline void *vl_api_ipsec_sad_entry_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_sad_entry_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sad_id");
    if (!item) return 0;
    // start field sad_id
    vl_api_u32_fromjson(item, &a->sad_id);
    // end field sad_id
    item = cJSON_GetObjectItem(o, "spi");
    if (!item) return 0;
    // start field spi
    vl_api_u32_fromjson(item, &a->spi);
    // end field spi
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    mp = vl_api_ipsec_proto_t_fromjson(mp, len, item, &a->protocol);
    if (!mp) return 0;
    // end field protocol
    item = cJSON_GetObjectItem(o, "crypto_algorithm");
    if (!item) return 0;
    // start field crypto_algorithm
    mp = vl_api_ipsec_crypto_alg_t_fromjson(mp, len, item, &a->crypto_algorithm);
    if (!mp) return 0;
    // end field crypto_algorithm
    item = cJSON_GetObjectItem(o, "crypto_key");
    if (!item) return 0;
    // start field crypto_key
    mp = vl_api_key_t_fromjson(mp, len, item, &a->crypto_key);
    if (!mp) return 0;
    // end field crypto_key
    item = cJSON_GetObjectItem(o, "integrity_algorithm");
    if (!item) return 0;
    // start field integrity_algorithm
    mp = vl_api_ipsec_integ_alg_t_fromjson(mp, len, item, &a->integrity_algorithm);
    if (!mp) return 0;
    // end field integrity_algorithm
    item = cJSON_GetObjectItem(o, "integrity_key");
    if (!item) return 0;
    // start field integrity_key
    mp = vl_api_key_t_fromjson(mp, len, item, &a->integrity_key);
    if (!mp) return 0;
    // end field integrity_key
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    mp = vl_api_ipsec_sad_flags_t_fromjson(mp, len, item, &a->flags);
    if (!mp) return 0;
    // end field flags
    item = cJSON_GetObjectItem(o, "tunnel_src");
    if (!item) return 0;
    // start field tunnel_src
    mp = vl_api_address_t_fromjson(mp, len, item, &a->tunnel_src);
    if (!mp) return 0;
    // end field tunnel_src
    item = cJSON_GetObjectItem(o, "tunnel_dst");
    if (!item) return 0;
    // start field tunnel_dst
    mp = vl_api_address_t_fromjson(mp, len, item, &a->tunnel_dst);
    if (!mp) return 0;
    // end field tunnel_dst
    item = cJSON_GetObjectItem(o, "tx_table_id");
    if (!item) return 0;
    // start field tx_table_id
    vl_api_u32_fromjson(item, &a->tx_table_id);
    // end field tx_table_id
    item = cJSON_GetObjectItem(o, "salt");
    if (!item) return 0;
    // start field salt
    vl_api_u32_fromjson(item, &a->salt);
    // end field salt
    item = cJSON_GetObjectItem(o, "udp_src_port");
    if (!item) return 0;
    // start field udp_src_port
    vl_api_u16_fromjson(item, &a->udp_src_port);
    // end field udp_src_port
    item = cJSON_GetObjectItem(o, "udp_dst_port");
    if (!item) return 0;
    // start field udp_dst_port
    vl_api_u16_fromjson(item, &a->udp_dst_port);
    // end field udp_dst_port
    return mp;
}
static inline void *vl_api_ipsec_sad_entry_v2_t_fromjson (void *mp, int *len, cJSON *o, vl_api_ipsec_sad_entry_v2_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sad_id");
    if (!item) return 0;
    // start field sad_id
    vl_api_u32_fromjson(item, &a->sad_id);
    // end field sad_id
    item = cJSON_GetObjectItem(o, "spi");
    if (!item) return 0;
    // start field spi
    vl_api_u32_fromjson(item, &a->spi);
    // end field spi
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    mp = vl_api_ipsec_proto_t_fromjson(mp, len, item, &a->protocol);
    if (!mp) return 0;
    // end field protocol
    item = cJSON_GetObjectItem(o, "crypto_algorithm");
    if (!item) return 0;
    // start field crypto_algorithm
    mp = vl_api_ipsec_crypto_alg_t_fromjson(mp, len, item, &a->crypto_algorithm);
    if (!mp) return 0;
    // end field crypto_algorithm
    item = cJSON_GetObjectItem(o, "crypto_key");
    if (!item) return 0;
    // start field crypto_key
    mp = vl_api_key_t_fromjson(mp, len, item, &a->crypto_key);
    if (!mp) return 0;
    // end field crypto_key
    item = cJSON_GetObjectItem(o, "integrity_algorithm");
    if (!item) return 0;
    // start field integrity_algorithm
    mp = vl_api_ipsec_integ_alg_t_fromjson(mp, len, item, &a->integrity_algorithm);
    if (!mp) return 0;
    // end field integrity_algorithm
    item = cJSON_GetObjectItem(o, "integrity_key");
    if (!item) return 0;
    // start field integrity_key
    mp = vl_api_key_t_fromjson(mp, len, item, &a->integrity_key);
    if (!mp) return 0;
    // end field integrity_key
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    mp = vl_api_ipsec_sad_flags_t_fromjson(mp, len, item, &a->flags);
    if (!mp) return 0;
    // end field flags
    item = cJSON_GetObjectItem(o, "tunnel_src");
    if (!item) return 0;
    // start field tunnel_src
    mp = vl_api_address_t_fromjson(mp, len, item, &a->tunnel_src);
    if (!mp) return 0;
    // end field tunnel_src
    item = cJSON_GetObjectItem(o, "tunnel_dst");
    if (!item) return 0;
    // start field tunnel_dst
    mp = vl_api_address_t_fromjson(mp, len, item, &a->tunnel_dst);
    if (!mp) return 0;
    // end field tunnel_dst
    item = cJSON_GetObjectItem(o, "tunnel_flags");
    if (!item) return 0;
    // start field tunnel_flags
    mp = vl_api_tunnel_encap_decap_flags_t_fromjson(mp, len, item, &a->tunnel_flags);
    if (!mp) return 0;
    // end field tunnel_flags
    item = cJSON_GetObjectItem(o, "dscp");
    if (!item) return 0;
    // start field dscp
    mp = vl_api_ip_dscp_t_fromjson(mp, len, item, &a->dscp);
    if (!mp) return 0;
    // end field dscp
    item = cJSON_GetObjectItem(o, "tx_table_id");
    if (!item) return 0;
    // start field tx_table_id
    vl_api_u32_fromjson(item, &a->tx_table_id);
    // end field tx_table_id
    item = cJSON_GetObjectItem(o, "salt");
    if (!item) return 0;
    // start field salt
    vl_api_u32_fromjson(item, &a->salt);
    // end field salt
    item = cJSON_GetObjectItem(o, "udp_src_port");
    if (!item) return 0;
    // start field udp_src_port
    vl_api_u16_fromjson(item, &a->udp_src_port);
    // end field udp_src_port
    item = cJSON_GetObjectItem(o, "udp_dst_port");
    if (!item) return 0;
    // start field udp_dst_port
    vl_api_u16_fromjson(item, &a->udp_dst_port);
    // end field udp_dst_port
    return mp;
}
#endif
