/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/ethernet/ethernet_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_l2_api_fromjson_h
#define included_l2_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_mac_event_action_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mac_event_action_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "MAC_EVENT_ACTION_API_ADD") == 0) {*a = 0; return mp;}
    if (strcmp(p, "MAC_EVENT_ACTION_API_DELETE") == 0) {*a = 1; return mp;}
    if (strcmp(p, "MAC_EVENT_ACTION_API_MOVE") == 0) {*a = 2; return mp;}
   return 0;
}
static inline void *vl_api_mac_entry_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mac_entry_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "mac_addr");
    if (!item) return 0;
    // start field mac_addr
    mp = vl_api_mac_address_t_fromjson(mp, len, item, &a->mac_addr);
    if (!mp) return 0;
    // end field mac_addr
    item = cJSON_GetObjectItem(o, "action");
    if (!item) return 0;
    // start field action
    mp = vl_api_mac_event_action_t_fromjson(mp, len, item, &a->action);
    if (!mp) return 0;
    // end field action
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    vl_api_u8_fromjson(item, &a->flags);
    // end field flags
    return mp;
}
static inline void *vl_api_bridge_domain_sw_if_t_fromjson (void *mp, int *len, cJSON *o, vl_api_bridge_domain_sw_if_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "context");
    if (!item) return 0;
    // start field context
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "shg");
    if (!item) return 0;
    // start field shg
    vl_api_u8_fromjson(item, &a->shg);
    // end field shg
    return mp;
}
static inline void *vl_api_bd_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_bd_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "BRIDGE_API_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_LEARN") == 0) {*a = 1; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_FWD") == 0) {*a = 2; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_FLOOD") == 0) {*a = 4; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_UU_FLOOD") == 0) {*a = 8; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_ARP_TERM") == 0) {*a = 16; return mp;}
    if (strcmp(p, "BRIDGE_API_FLAG_ARP_UFWD") == 0) {*a = 32; return mp;}
   return 0;
}
static inline void *vl_api_l2_port_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_l2_port_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "L2_API_PORT_TYPE_NORMAL") == 0) {*a = 0; return mp;}
    if (strcmp(p, "L2_API_PORT_TYPE_BVI") == 0) {*a = 1; return mp;}
    if (strcmp(p, "L2_API_PORT_TYPE_UU_FWD") == 0) {*a = 2; return mp;}
   return 0;
}
static inline void *vl_api_bd_ip_mac_t_fromjson (void *mp, int *len, cJSON *o, vl_api_bd_ip_mac_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    mp = vl_api_address_t_fromjson(mp, len, item, &a->ip);
    if (!mp) return 0;
    // end field ip
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    // start field mac
    mp = vl_api_mac_address_t_fromjson(mp, len, item, &a->mac);
    if (!mp) return 0;
    // end field mac
    return mp;
}
static inline vl_api_l2_xconnect_details_t *vl_api_l2_xconnect_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_xconnect_details_t);
    vl_api_l2_xconnect_details_t *a = malloc(l);
    // processing l2_xconnect_details: vl_api_interface_index_t rx_sw_if_index
    item = cJSON_GetObjectItem(o, "rx_sw_if_index");
    if (!item) return 0;
    // start field rx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->rx_sw_if_index);
    if (!a) return 0;
    // end field rx_sw_if_index

    // processing l2_xconnect_details: vl_api_interface_index_t tx_sw_if_index
    item = cJSON_GetObjectItem(o, "tx_sw_if_index");
    if (!item) return 0;
    // start field tx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->tx_sw_if_index);
    if (!a) return 0;
    // end field tx_sw_if_index


    *len = l;
    return a;
}
static inline vl_api_l2_xconnect_dump_t *vl_api_l2_xconnect_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_xconnect_dump_t);
    vl_api_l2_xconnect_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_l2_fib_table_details_t *vl_api_l2_fib_table_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_fib_table_details_t);
    vl_api_l2_fib_table_details_t *a = malloc(l);
    // processing l2_fib_table_details: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing l2_fib_table_details: vl_api_mac_address_t mac
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    // start field mac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac);
    if (!a) return 0;
    // end field mac

    // processing l2_fib_table_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_fib_table_details: bool static_mac
    item = cJSON_GetObjectItem(o, "static_mac");
    if (!item) return 0;
    // start field static_mac
    vl_api_bool_fromjson(item, &a->static_mac);
    // end field static_mac

    // processing l2_fib_table_details: bool filter_mac
    item = cJSON_GetObjectItem(o, "filter_mac");
    if (!item) return 0;
    // start field filter_mac
    vl_api_bool_fromjson(item, &a->filter_mac);
    // end field filter_mac

    // processing l2_fib_table_details: bool bvi_mac
    item = cJSON_GetObjectItem(o, "bvi_mac");
    if (!item) return 0;
    // start field bvi_mac
    vl_api_bool_fromjson(item, &a->bvi_mac);
    // end field bvi_mac


    *len = l;
    return a;
}
static inline vl_api_l2_fib_table_dump_t *vl_api_l2_fib_table_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_fib_table_dump_t);
    vl_api_l2_fib_table_dump_t *a = malloc(l);
    // processing l2_fib_table_dump: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id


    *len = l;
    return a;
}
static inline vl_api_l2_fib_clear_table_t *vl_api_l2_fib_clear_table_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_fib_clear_table_t);
    vl_api_l2_fib_clear_table_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_l2_fib_clear_table_reply_t *vl_api_l2_fib_clear_table_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_fib_clear_table_reply_t);
    vl_api_l2_fib_clear_table_reply_t *a = malloc(l);
    // processing l2_fib_clear_table_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_all_t *vl_api_l2fib_flush_all_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_all_t);
    vl_api_l2fib_flush_all_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_all_reply_t *vl_api_l2fib_flush_all_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_all_reply_t);
    vl_api_l2fib_flush_all_reply_t *a = malloc(l);
    // processing l2fib_flush_all_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_bd_t *vl_api_l2fib_flush_bd_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_bd_t);
    vl_api_l2fib_flush_bd_t *a = malloc(l);
    // processing l2fib_flush_bd: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id


    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_bd_reply_t *vl_api_l2fib_flush_bd_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_bd_reply_t);
    vl_api_l2fib_flush_bd_reply_t *a = malloc(l);
    // processing l2fib_flush_bd_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_int_t *vl_api_l2fib_flush_int_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_int_t);
    vl_api_l2fib_flush_int_t *a = malloc(l);
    // processing l2fib_flush_int: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_l2fib_flush_int_reply_t *vl_api_l2fib_flush_int_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_flush_int_reply_t);
    vl_api_l2fib_flush_int_reply_t *a = malloc(l);
    // processing l2fib_flush_int_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2fib_add_del_t *vl_api_l2fib_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_add_del_t);
    vl_api_l2fib_add_del_t *a = malloc(l);
    // processing l2fib_add_del: vl_api_mac_address_t mac
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    // start field mac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac);
    if (!a) return 0;
    // end field mac

    // processing l2fib_add_del: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing l2fib_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2fib_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing l2fib_add_del: bool static_mac
    item = cJSON_GetObjectItem(o, "static_mac");
    if (!item) return 0;
    // start field static_mac
    vl_api_bool_fromjson(item, &a->static_mac);
    // end field static_mac

    // processing l2fib_add_del: bool filter_mac
    item = cJSON_GetObjectItem(o, "filter_mac");
    if (!item) return 0;
    // start field filter_mac
    vl_api_bool_fromjson(item, &a->filter_mac);
    // end field filter_mac

    // processing l2fib_add_del: bool bvi_mac
    item = cJSON_GetObjectItem(o, "bvi_mac");
    if (!item) return 0;
    // start field bvi_mac
    vl_api_bool_fromjson(item, &a->bvi_mac);
    // end field bvi_mac


    *len = l;
    return a;
}
static inline vl_api_l2fib_add_del_reply_t *vl_api_l2fib_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2fib_add_del_reply_t);
    vl_api_l2fib_add_del_reply_t *a = malloc(l);
    // processing l2fib_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_want_l2_macs_events_t *vl_api_want_l2_macs_events_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_l2_macs_events_t);
    vl_api_want_l2_macs_events_t *a = malloc(l);
    // processing want_l2_macs_events: u32 learn_limit
    item = cJSON_GetObjectItem(o, "learn_limit");
    if (!item) return 0;
    // start field learn_limit
    vl_api_u32_fromjson(item, &a->learn_limit);
    // end field learn_limit

    // processing want_l2_macs_events: u8 scan_delay
    item = cJSON_GetObjectItem(o, "scan_delay");
    if (!item) return 0;
    // start field scan_delay
    vl_api_u8_fromjson(item, &a->scan_delay);
    // end field scan_delay

    // processing want_l2_macs_events: u8 max_macs_in_event
    item = cJSON_GetObjectItem(o, "max_macs_in_event");
    if (!item) return 0;
    // start field max_macs_in_event
    vl_api_u8_fromjson(item, &a->max_macs_in_event);
    // end field max_macs_in_event

    // processing want_l2_macs_events: bool enable_disable
    item = cJSON_GetObjectItem(o, "enable_disable");
    if (!item) return 0;
    // start field enable_disable
    vl_api_bool_fromjson(item, &a->enable_disable);
    // end field enable_disable

    // processing want_l2_macs_events: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid


    *len = l;
    return a;
}
static inline vl_api_want_l2_macs_events_reply_t *vl_api_want_l2_macs_events_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_l2_macs_events_reply_t);
    vl_api_want_l2_macs_events_reply_t *a = malloc(l);
    // processing want_l2_macs_events_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2_macs_event_t *vl_api_l2_macs_event_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_macs_event_t);
    vl_api_l2_macs_event_t *a = malloc(l);
    // processing l2_macs_event: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing l2_macs_event: vl_api_mac_entry_t mac
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "mac");
        int size = cJSON_GetArraySize(array);
        a->n_macs = size;
        a = realloc(a, l + sizeof(vl_api_mac_entry_t) * size);
        vl_api_mac_entry_t *d = (void *)a + l;
        l += sizeof(vl_api_mac_entry_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_mac_entry_t_fromjson(a, len, e, &d[i]); 
        }
    }


    *len = l;
    return a;
}
static inline vl_api_l2_flags_t *vl_api_l2_flags_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_flags_t);
    vl_api_l2_flags_t *a = malloc(l);
    // processing l2_flags: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_flags: bool is_set
    item = cJSON_GetObjectItem(o, "is_set");
    if (!item) return 0;
    // start field is_set
    vl_api_bool_fromjson(item, &a->is_set);
    // end field is_set

    // processing l2_flags: u32 feature_bitmap
    item = cJSON_GetObjectItem(o, "feature_bitmap");
    if (!item) return 0;
    // start field feature_bitmap
    vl_api_u32_fromjson(item, &a->feature_bitmap);
    // end field feature_bitmap


    *len = l;
    return a;
}
static inline vl_api_l2_flags_reply_t *vl_api_l2_flags_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_flags_reply_t);
    vl_api_l2_flags_reply_t *a = malloc(l);
    // processing l2_flags_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing l2_flags_reply: u32 resulting_feature_bitmap
    item = cJSON_GetObjectItem(o, "resulting_feature_bitmap");
    if (!item) return 0;
    // start field resulting_feature_bitmap
    vl_api_u32_fromjson(item, &a->resulting_feature_bitmap);
    // end field resulting_feature_bitmap


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_set_mac_age_t *vl_api_bridge_domain_set_mac_age_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_set_mac_age_t);
    vl_api_bridge_domain_set_mac_age_t *a = malloc(l);
    // processing bridge_domain_set_mac_age: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing bridge_domain_set_mac_age: u8 mac_age
    item = cJSON_GetObjectItem(o, "mac_age");
    if (!item) return 0;
    // start field mac_age
    vl_api_u8_fromjson(item, &a->mac_age);
    // end field mac_age


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_set_mac_age_reply_t *vl_api_bridge_domain_set_mac_age_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_set_mac_age_reply_t);
    vl_api_bridge_domain_set_mac_age_reply_t *a = malloc(l);
    // processing bridge_domain_set_mac_age_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_add_del_t *vl_api_bridge_domain_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_add_del_t);
    vl_api_bridge_domain_add_del_t *a = malloc(l);
    // processing bridge_domain_add_del: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing bridge_domain_add_del: bool flood
    item = cJSON_GetObjectItem(o, "flood");
    if (!item) return 0;
    // start field flood
    vl_api_bool_fromjson(item, &a->flood);
    // end field flood

    // processing bridge_domain_add_del: bool uu_flood
    item = cJSON_GetObjectItem(o, "uu_flood");
    if (!item) return 0;
    // start field uu_flood
    vl_api_bool_fromjson(item, &a->uu_flood);
    // end field uu_flood

    // processing bridge_domain_add_del: bool forward
    item = cJSON_GetObjectItem(o, "forward");
    if (!item) return 0;
    // start field forward
    vl_api_bool_fromjson(item, &a->forward);
    // end field forward

    // processing bridge_domain_add_del: bool learn
    item = cJSON_GetObjectItem(o, "learn");
    if (!item) return 0;
    // start field learn
    vl_api_bool_fromjson(item, &a->learn);
    // end field learn

    // processing bridge_domain_add_del: bool arp_term
    item = cJSON_GetObjectItem(o, "arp_term");
    if (!item) return 0;
    // start field arp_term
    vl_api_bool_fromjson(item, &a->arp_term);
    // end field arp_term

    // processing bridge_domain_add_del: bool arp_ufwd
    item = cJSON_GetObjectItem(o, "arp_ufwd");
    if (!item) return 0;
    // start field arp_ufwd
    vl_api_bool_fromjson(item, &a->arp_ufwd);
    // end field arp_ufwd

    // processing bridge_domain_add_del: u8 mac_age
    item = cJSON_GetObjectItem(o, "mac_age");
    if (!item) return 0;
    // start field mac_age
    vl_api_u8_fromjson(item, &a->mac_age);
    // end field mac_age

    // processing bridge_domain_add_del: string bd_tag
    item = cJSON_GetObjectItem(o, "bd_tag");
    if (!item) return 0;
    strncpy_s((char *)a->bd_tag, sizeof(a->bd_tag), cJSON_GetStringValue(item), sizeof(a->bd_tag) - 1);

    // processing bridge_domain_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_add_del_reply_t *vl_api_bridge_domain_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_add_del_reply_t);
    vl_api_bridge_domain_add_del_reply_t *a = malloc(l);
    // processing bridge_domain_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_dump_t *vl_api_bridge_domain_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_dump_t);
    vl_api_bridge_domain_dump_t *a = malloc(l);
    // processing bridge_domain_dump: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing bridge_domain_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_bridge_domain_details_t *vl_api_bridge_domain_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_domain_details_t);
    vl_api_bridge_domain_details_t *a = malloc(l);
    // processing bridge_domain_details: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing bridge_domain_details: bool flood
    item = cJSON_GetObjectItem(o, "flood");
    if (!item) return 0;
    // start field flood
    vl_api_bool_fromjson(item, &a->flood);
    // end field flood

    // processing bridge_domain_details: bool uu_flood
    item = cJSON_GetObjectItem(o, "uu_flood");
    if (!item) return 0;
    // start field uu_flood
    vl_api_bool_fromjson(item, &a->uu_flood);
    // end field uu_flood

    // processing bridge_domain_details: bool forward
    item = cJSON_GetObjectItem(o, "forward");
    if (!item) return 0;
    // start field forward
    vl_api_bool_fromjson(item, &a->forward);
    // end field forward

    // processing bridge_domain_details: bool learn
    item = cJSON_GetObjectItem(o, "learn");
    if (!item) return 0;
    // start field learn
    vl_api_bool_fromjson(item, &a->learn);
    // end field learn

    // processing bridge_domain_details: bool arp_term
    item = cJSON_GetObjectItem(o, "arp_term");
    if (!item) return 0;
    // start field arp_term
    vl_api_bool_fromjson(item, &a->arp_term);
    // end field arp_term

    // processing bridge_domain_details: bool arp_ufwd
    item = cJSON_GetObjectItem(o, "arp_ufwd");
    if (!item) return 0;
    // start field arp_ufwd
    vl_api_bool_fromjson(item, &a->arp_ufwd);
    // end field arp_ufwd

    // processing bridge_domain_details: u8 mac_age
    item = cJSON_GetObjectItem(o, "mac_age");
    if (!item) return 0;
    // start field mac_age
    vl_api_u8_fromjson(item, &a->mac_age);
    // end field mac_age

    // processing bridge_domain_details: string bd_tag
    item = cJSON_GetObjectItem(o, "bd_tag");
    if (!item) return 0;
    strncpy_s((char *)a->bd_tag, sizeof(a->bd_tag), cJSON_GetStringValue(item), sizeof(a->bd_tag) - 1);

    // processing bridge_domain_details: vl_api_interface_index_t bvi_sw_if_index
    item = cJSON_GetObjectItem(o, "bvi_sw_if_index");
    if (!item) return 0;
    // start field bvi_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->bvi_sw_if_index);
    if (!a) return 0;
    // end field bvi_sw_if_index

    // processing bridge_domain_details: vl_api_interface_index_t uu_fwd_sw_if_index
    item = cJSON_GetObjectItem(o, "uu_fwd_sw_if_index");
    if (!item) return 0;
    // start field uu_fwd_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->uu_fwd_sw_if_index);
    if (!a) return 0;
    // end field uu_fwd_sw_if_index

    // processing bridge_domain_details: vl_api_bridge_domain_sw_if_t sw_if_details
    item = cJSON_GetObjectItem(o, "sw_if_details");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sw_if_details");
        int size = cJSON_GetArraySize(array);
        a->n_sw_ifs = size;
        a = realloc(a, l + sizeof(vl_api_bridge_domain_sw_if_t) * size);
        vl_api_bridge_domain_sw_if_t *d = (void *)a + l;
        l += sizeof(vl_api_bridge_domain_sw_if_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_bridge_domain_sw_if_t_fromjson(a, len, e, &d[i]); 
        }
    }


    *len = l;
    return a;
}
static inline vl_api_bridge_flags_t *vl_api_bridge_flags_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_flags_t);
    vl_api_bridge_flags_t *a = malloc(l);
    // processing bridge_flags: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing bridge_flags: bool is_set
    item = cJSON_GetObjectItem(o, "is_set");
    if (!item) return 0;
    // start field is_set
    vl_api_bool_fromjson(item, &a->is_set);
    // end field is_set

    // processing bridge_flags: vl_api_bd_flags_t flags
    item = cJSON_GetObjectItem(o, "flags");
    if (!item) return 0;
    // start field flags
    a = vl_api_bd_flags_t_fromjson(a, &l, item, &a->flags);
    if (!a) return 0;
    // end field flags


    *len = l;
    return a;
}
static inline vl_api_bridge_flags_reply_t *vl_api_bridge_flags_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bridge_flags_reply_t);
    vl_api_bridge_flags_reply_t *a = malloc(l);
    // processing bridge_flags_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing bridge_flags_reply: u32 resulting_feature_bitmap
    item = cJSON_GetObjectItem(o, "resulting_feature_bitmap");
    if (!item) return 0;
    // start field resulting_feature_bitmap
    vl_api_u32_fromjson(item, &a->resulting_feature_bitmap);
    // end field resulting_feature_bitmap


    *len = l;
    return a;
}
static inline vl_api_l2_interface_vlan_tag_rewrite_t *vl_api_l2_interface_vlan_tag_rewrite_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_vlan_tag_rewrite_t);
    vl_api_l2_interface_vlan_tag_rewrite_t *a = malloc(l);
    // processing l2_interface_vlan_tag_rewrite: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_interface_vlan_tag_rewrite: u32 vtr_op
    item = cJSON_GetObjectItem(o, "vtr_op");
    if (!item) return 0;
    // start field vtr_op
    vl_api_u32_fromjson(item, &a->vtr_op);
    // end field vtr_op

    // processing l2_interface_vlan_tag_rewrite: u32 push_dot1q
    item = cJSON_GetObjectItem(o, "push_dot1q");
    if (!item) return 0;
    // start field push_dot1q
    vl_api_u32_fromjson(item, &a->push_dot1q);
    // end field push_dot1q

    // processing l2_interface_vlan_tag_rewrite: u32 tag1
    item = cJSON_GetObjectItem(o, "tag1");
    if (!item) return 0;
    // start field tag1
    vl_api_u32_fromjson(item, &a->tag1);
    // end field tag1

    // processing l2_interface_vlan_tag_rewrite: u32 tag2
    item = cJSON_GetObjectItem(o, "tag2");
    if (!item) return 0;
    // start field tag2
    vl_api_u32_fromjson(item, &a->tag2);
    // end field tag2


    *len = l;
    return a;
}
static inline vl_api_l2_interface_vlan_tag_rewrite_reply_t *vl_api_l2_interface_vlan_tag_rewrite_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_vlan_tag_rewrite_reply_t);
    vl_api_l2_interface_vlan_tag_rewrite_reply_t *a = malloc(l);
    // processing l2_interface_vlan_tag_rewrite_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2_interface_pbb_tag_rewrite_t *vl_api_l2_interface_pbb_tag_rewrite_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_pbb_tag_rewrite_t);
    vl_api_l2_interface_pbb_tag_rewrite_t *a = malloc(l);
    // processing l2_interface_pbb_tag_rewrite: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_interface_pbb_tag_rewrite: u32 vtr_op
    item = cJSON_GetObjectItem(o, "vtr_op");
    if (!item) return 0;
    // start field vtr_op
    vl_api_u32_fromjson(item, &a->vtr_op);
    // end field vtr_op

    // processing l2_interface_pbb_tag_rewrite: u16 outer_tag
    item = cJSON_GetObjectItem(o, "outer_tag");
    if (!item) return 0;
    // start field outer_tag
    vl_api_u16_fromjson(item, &a->outer_tag);
    // end field outer_tag

    // processing l2_interface_pbb_tag_rewrite: vl_api_mac_address_t b_dmac
    item = cJSON_GetObjectItem(o, "b_dmac");
    if (!item) return 0;
    // start field b_dmac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->b_dmac);
    if (!a) return 0;
    // end field b_dmac

    // processing l2_interface_pbb_tag_rewrite: vl_api_mac_address_t b_smac
    item = cJSON_GetObjectItem(o, "b_smac");
    if (!item) return 0;
    // start field b_smac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->b_smac);
    if (!a) return 0;
    // end field b_smac

    // processing l2_interface_pbb_tag_rewrite: u16 b_vlanid
    item = cJSON_GetObjectItem(o, "b_vlanid");
    if (!item) return 0;
    // start field b_vlanid
    vl_api_u16_fromjson(item, &a->b_vlanid);
    // end field b_vlanid

    // processing l2_interface_pbb_tag_rewrite: u32 i_sid
    item = cJSON_GetObjectItem(o, "i_sid");
    if (!item) return 0;
    // start field i_sid
    vl_api_u32_fromjson(item, &a->i_sid);
    // end field i_sid


    *len = l;
    return a;
}
static inline vl_api_l2_interface_pbb_tag_rewrite_reply_t *vl_api_l2_interface_pbb_tag_rewrite_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_pbb_tag_rewrite_reply_t);
    vl_api_l2_interface_pbb_tag_rewrite_reply_t *a = malloc(l);
    // processing l2_interface_pbb_tag_rewrite_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2_patch_add_del_t *vl_api_l2_patch_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_patch_add_del_t);
    vl_api_l2_patch_add_del_t *a = malloc(l);
    // processing l2_patch_add_del: vl_api_interface_index_t rx_sw_if_index
    item = cJSON_GetObjectItem(o, "rx_sw_if_index");
    if (!item) return 0;
    // start field rx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->rx_sw_if_index);
    if (!a) return 0;
    // end field rx_sw_if_index

    // processing l2_patch_add_del: vl_api_interface_index_t tx_sw_if_index
    item = cJSON_GetObjectItem(o, "tx_sw_if_index");
    if (!item) return 0;
    // start field tx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->tx_sw_if_index);
    if (!a) return 0;
    // end field tx_sw_if_index

    // processing l2_patch_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_l2_patch_add_del_reply_t *vl_api_l2_patch_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_patch_add_del_reply_t);
    vl_api_l2_patch_add_del_reply_t *a = malloc(l);
    // processing l2_patch_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_l2_xconnect_t *vl_api_sw_interface_set_l2_xconnect_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_l2_xconnect_t);
    vl_api_sw_interface_set_l2_xconnect_t *a = malloc(l);
    // processing sw_interface_set_l2_xconnect: vl_api_interface_index_t rx_sw_if_index
    item = cJSON_GetObjectItem(o, "rx_sw_if_index");
    if (!item) return 0;
    // start field rx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->rx_sw_if_index);
    if (!a) return 0;
    // end field rx_sw_if_index

    // processing sw_interface_set_l2_xconnect: vl_api_interface_index_t tx_sw_if_index
    item = cJSON_GetObjectItem(o, "tx_sw_if_index");
    if (!item) return 0;
    // start field tx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->tx_sw_if_index);
    if (!a) return 0;
    // end field tx_sw_if_index

    // processing sw_interface_set_l2_xconnect: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_l2_xconnect_reply_t *vl_api_sw_interface_set_l2_xconnect_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_l2_xconnect_reply_t);
    vl_api_sw_interface_set_l2_xconnect_reply_t *a = malloc(l);
    // processing sw_interface_set_l2_xconnect_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_l2_bridge_t *vl_api_sw_interface_set_l2_bridge_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_l2_bridge_t);
    vl_api_sw_interface_set_l2_bridge_t *a = malloc(l);
    // processing sw_interface_set_l2_bridge: vl_api_interface_index_t rx_sw_if_index
    item = cJSON_GetObjectItem(o, "rx_sw_if_index");
    if (!item) return 0;
    // start field rx_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->rx_sw_if_index);
    if (!a) return 0;
    // end field rx_sw_if_index

    // processing sw_interface_set_l2_bridge: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id

    // processing sw_interface_set_l2_bridge: vl_api_l2_port_type_t port_type
    item = cJSON_GetObjectItem(o, "port_type");
    if (!item) return 0;
    // start field port_type
    a = vl_api_l2_port_type_t_fromjson(a, &l, item, &a->port_type);
    if (!a) return 0;
    // end field port_type

    // processing sw_interface_set_l2_bridge: u8 shg
    item = cJSON_GetObjectItem(o, "shg");
    if (!item) return 0;
    // start field shg
    vl_api_u8_fromjson(item, &a->shg);
    // end field shg

    // processing sw_interface_set_l2_bridge: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_l2_bridge_reply_t *vl_api_sw_interface_set_l2_bridge_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_l2_bridge_reply_t);
    vl_api_sw_interface_set_l2_bridge_reply_t *a = malloc(l);
    // processing sw_interface_set_l2_bridge_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_add_del_t *vl_api_bd_ip_mac_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_add_del_t);
    vl_api_bd_ip_mac_add_del_t *a = malloc(l);
    // processing bd_ip_mac_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing bd_ip_mac_add_del: vl_api_bd_ip_mac_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_bd_ip_mac_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_add_del_reply_t *vl_api_bd_ip_mac_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_add_del_reply_t);
    vl_api_bd_ip_mac_add_del_reply_t *a = malloc(l);
    // processing bd_ip_mac_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_flush_t *vl_api_bd_ip_mac_flush_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_flush_t);
    vl_api_bd_ip_mac_flush_t *a = malloc(l);
    // processing bd_ip_mac_flush: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_flush_reply_t *vl_api_bd_ip_mac_flush_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_flush_reply_t);
    vl_api_bd_ip_mac_flush_reply_t *a = malloc(l);
    // processing bd_ip_mac_flush_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_details_t *vl_api_bd_ip_mac_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_details_t);
    vl_api_bd_ip_mac_details_t *a = malloc(l);
    // processing bd_ip_mac_details: vl_api_bd_ip_mac_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_bd_ip_mac_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_bd_ip_mac_dump_t *vl_api_bd_ip_mac_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bd_ip_mac_dump_t);
    vl_api_bd_ip_mac_dump_t *a = malloc(l);
    // processing bd_ip_mac_dump: u32 bd_id
    item = cJSON_GetObjectItem(o, "bd_id");
    if (!item) return 0;
    // start field bd_id
    vl_api_u32_fromjson(item, &a->bd_id);
    // end field bd_id


    *len = l;
    return a;
}
static inline vl_api_l2_interface_efp_filter_t *vl_api_l2_interface_efp_filter_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_efp_filter_t);
    vl_api_l2_interface_efp_filter_t *a = malloc(l);
    // processing l2_interface_efp_filter: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_interface_efp_filter: bool enable_disable
    item = cJSON_GetObjectItem(o, "enable_disable");
    if (!item) return 0;
    // start field enable_disable
    vl_api_bool_fromjson(item, &a->enable_disable);
    // end field enable_disable


    *len = l;
    return a;
}
static inline vl_api_l2_interface_efp_filter_reply_t *vl_api_l2_interface_efp_filter_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_interface_efp_filter_reply_t);
    vl_api_l2_interface_efp_filter_reply_t *a = malloc(l);
    // processing l2_interface_efp_filter_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vpath_t *vl_api_sw_interface_set_vpath_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vpath_t);
    vl_api_sw_interface_set_vpath_t *a = malloc(l);
    // processing sw_interface_set_vpath: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_vpath: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vpath_reply_t *vl_api_sw_interface_set_vpath_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vpath_reply_t);
    vl_api_sw_interface_set_vpath_reply_t *a = malloc(l);
    // processing sw_interface_set_vpath_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_bvi_create_t *vl_api_bvi_create_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bvi_create_t);
    vl_api_bvi_create_t *a = malloc(l);
    // processing bvi_create: vl_api_mac_address_t mac
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    // start field mac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac);
    if (!a) return 0;
    // end field mac

    // processing bvi_create: u32 user_instance
    item = cJSON_GetObjectItem(o, "user_instance");
    if (!item) return 0;
    // start field user_instance
    vl_api_u32_fromjson(item, &a->user_instance);
    // end field user_instance


    *len = l;
    return a;
}
static inline vl_api_bvi_create_reply_t *vl_api_bvi_create_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bvi_create_reply_t);
    vl_api_bvi_create_reply_t *a = malloc(l);
    // processing bvi_create_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing bvi_create_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_bvi_delete_t *vl_api_bvi_delete_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bvi_delete_t);
    vl_api_bvi_delete_t *a = malloc(l);
    // processing bvi_delete: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_bvi_delete_reply_t *vl_api_bvi_delete_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_bvi_delete_reply_t);
    vl_api_bvi_delete_reply_t *a = malloc(l);
    // processing bvi_delete_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_want_l2_arp_term_events_t *vl_api_want_l2_arp_term_events_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_l2_arp_term_events_t);
    vl_api_want_l2_arp_term_events_t *a = malloc(l);
    // processing want_l2_arp_term_events: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing want_l2_arp_term_events: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid


    *len = l;
    return a;
}
static inline vl_api_want_l2_arp_term_events_reply_t *vl_api_want_l2_arp_term_events_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_want_l2_arp_term_events_reply_t);
    vl_api_want_l2_arp_term_events_reply_t *a = malloc(l);
    // processing want_l2_arp_term_events_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_l2_arp_term_event_t *vl_api_l2_arp_term_event_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_l2_arp_term_event_t);
    vl_api_l2_arp_term_event_t *a = malloc(l);
    // processing l2_arp_term_event: u32 pid
    item = cJSON_GetObjectItem(o, "pid");
    if (!item) return 0;
    // start field pid
    vl_api_u32_fromjson(item, &a->pid);
    // end field pid

    // processing l2_arp_term_event: vl_api_address_t ip
    item = cJSON_GetObjectItem(o, "ip");
    if (!item) return 0;
    // start field ip
    a = vl_api_address_t_fromjson(a, &l, item, &a->ip);
    if (!a) return 0;
    // end field ip

    // processing l2_arp_term_event: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing l2_arp_term_event: vl_api_mac_address_t mac
    item = cJSON_GetObjectItem(o, "mac");
    if (!item) return 0;
    // start field mac
    a = vl_api_mac_address_t_fromjson(a, &l, item, &a->mac);
    if (!a) return 0;
    // end field mac


    *len = l;
    return a;
}
#endif
