/* Imported API files */
#include <vnet/fib/fib_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_mfib_types_api_fromjson_h
#define included_mfib_types_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_mfib_entry_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mfib_entry_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "MFIB_API_ENTRY_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "MFIB_API_ENTRY_FLAG_SIGNAL") == 0) {*a = 1; return mp;}
    if (strcmp(p, "MFIB_API_ENTRY_FLAG_DROP") == 0) {*a = 2; return mp;}
    if (strcmp(p, "MFIB_API_ENTRY_FLAG_CONNECTED") == 0) {*a = 4; return mp;}
    if (strcmp(p, "MFIB_API_ENTRY_FLAG_ACCEPT_ALL_ITF") == 0) {*a = 8; return mp;}
   return 0;
}
static inline void *vl_api_mfib_itf_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mfib_itf_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "MFIB_API_ITF_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "MFIB_API_ITF_FLAG_NEGATE_SIGNAL") == 0) {*a = 1; return mp;}
    if (strcmp(p, "MFIB_API_ITF_FLAG_ACCEPT") == 0) {*a = 2; return mp;}
    if (strcmp(p, "MFIB_API_ITF_FLAG_FORWARD") == 0) {*a = 4; return mp;}
    if (strcmp(p, "MFIB_API_ITF_FLAG_SIGNAL_PRESENT") == 0) {*a = 8; return mp;}
    if (strcmp(p, "MFIB_API_ITF_FLAG_DONT_PRESERVE") == 0) {*a = 16; return mp;}
   return 0;
}
static inline void *vl_api_mfib_path_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mfib_path_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "itf_flags");
    if (!item) return 0;
    // start field itf_flags
    mp = vl_api_mfib_itf_flags_t_fromjson(mp, len, item, &a->itf_flags);
    if (!mp) return 0;
    // end field itf_flags
    item = cJSON_GetObjectItem(o, "path");
    if (!item) return 0;
    // start field path
    mp = vl_api_fib_path_t_fromjson(mp, len, item, &a->path);
    if (!mp) return 0;
    // end field path
    return mp;
}
#endif
