/* Imported API files */
#include <vnet/fib/fib_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_mpls_api_fromjson_h
#define included_mpls_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_mpls_tunnel_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mpls_tunnel_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "mt_sw_if_index");
    if (!item) return 0;
    // start field mt_sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->mt_sw_if_index);
    if (!mp) return 0;
    // end field mt_sw_if_index
    item = cJSON_GetObjectItem(o, "mt_tunnel_index");
    if (!item) return 0;
    // start field mt_tunnel_index
    vl_api_u32_fromjson(item, &a->mt_tunnel_index);
    // end field mt_tunnel_index
    item = cJSON_GetObjectItem(o, "mt_l2_only");
    if (!item) return 0;
    // start field mt_l2_only
    vl_api_bool_fromjson(item, &a->mt_l2_only);
    // end field mt_l2_only
    item = cJSON_GetObjectItem(o, "mt_is_multicast");
    if (!item) return 0;
    // start field mt_is_multicast
    vl_api_bool_fromjson(item, &a->mt_is_multicast);
    // end field mt_is_multicast
    item = cJSON_GetObjectItem(o, "mt_tag");
    if (!item) return 0;
    strncpy_s((char *)a->mt_tag, sizeof(a->mt_tag), cJSON_GetStringValue(item), sizeof(a->mt_tag) - 1);
    item = cJSON_GetObjectItem(o, "mt_paths");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "mt_paths");
        int size = cJSON_GetArraySize(array);
        a->mt_n_paths = size;
        mp = realloc(mp, *len + sizeof(vl_api_fib_path_t) * size);
        vl_api_fib_path_t *d = (void *)mp + *len;
        *len += sizeof(vl_api_fib_path_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_fib_path_t_fromjson(mp, len, e, &d[i]); 
        }
    }
    return mp;
}
static inline void *vl_api_mpls_table_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mpls_table_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "mt_table_id");
    if (!item) return 0;
    // start field mt_table_id
    vl_api_u32_fromjson(item, &a->mt_table_id);
    // end field mt_table_id
    item = cJSON_GetObjectItem(o, "mt_name");
    if (!item) return 0;
    strncpy_s((char *)a->mt_name, sizeof(a->mt_name), cJSON_GetStringValue(item), sizeof(a->mt_name) - 1);
    return mp;
}
static inline void *vl_api_mpls_route_t_fromjson (void *mp, int *len, cJSON *o, vl_api_mpls_route_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "mr_table_id");
    if (!item) return 0;
    // start field mr_table_id
    vl_api_u32_fromjson(item, &a->mr_table_id);
    // end field mr_table_id
    item = cJSON_GetObjectItem(o, "mr_label");
    if (!item) return 0;
    // start field mr_label
    vl_api_u32_fromjson(item, &a->mr_label);
    // end field mr_label
    item = cJSON_GetObjectItem(o, "mr_eos");
    if (!item) return 0;
    // start field mr_eos
    vl_api_u8_fromjson(item, &a->mr_eos);
    // end field mr_eos
    item = cJSON_GetObjectItem(o, "mr_eos_proto");
    if (!item) return 0;
    // start field mr_eos_proto
    vl_api_u8_fromjson(item, &a->mr_eos_proto);
    // end field mr_eos_proto
    item = cJSON_GetObjectItem(o, "mr_is_multicast");
    if (!item) return 0;
    // start field mr_is_multicast
    vl_api_bool_fromjson(item, &a->mr_is_multicast);
    // end field mr_is_multicast
    item = cJSON_GetObjectItem(o, "mr_paths");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "mr_paths");
        int size = cJSON_GetArraySize(array);
        a->mr_n_paths = size;
        mp = realloc(mp, *len + sizeof(vl_api_fib_path_t) * size);
        vl_api_fib_path_t *d = (void *)mp + *len;
        *len += sizeof(vl_api_fib_path_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_fib_path_t_fromjson(mp, len, e, &d[i]); 
        }
    }
    return mp;
}
static inline vl_api_mpls_ip_bind_unbind_t *vl_api_mpls_ip_bind_unbind_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_ip_bind_unbind_t);
    vl_api_mpls_ip_bind_unbind_t *a = malloc(l);
    // processing mpls_ip_bind_unbind: u32 mb_mpls_table_id
    item = cJSON_GetObjectItem(o, "mb_mpls_table_id");
    if (!item) return 0;
    // start field mb_mpls_table_id
    vl_api_u32_fromjson(item, &a->mb_mpls_table_id);
    // end field mb_mpls_table_id

    // processing mpls_ip_bind_unbind: u32 mb_label
    item = cJSON_GetObjectItem(o, "mb_label");
    if (!item) return 0;
    // start field mb_label
    vl_api_u32_fromjson(item, &a->mb_label);
    // end field mb_label

    // processing mpls_ip_bind_unbind: u32 mb_ip_table_id
    item = cJSON_GetObjectItem(o, "mb_ip_table_id");
    if (!item) return 0;
    // start field mb_ip_table_id
    vl_api_u32_fromjson(item, &a->mb_ip_table_id);
    // end field mb_ip_table_id

    // processing mpls_ip_bind_unbind: bool mb_is_bind
    item = cJSON_GetObjectItem(o, "mb_is_bind");
    if (!item) return 0;
    // start field mb_is_bind
    vl_api_bool_fromjson(item, &a->mb_is_bind);
    // end field mb_is_bind

    // processing mpls_ip_bind_unbind: vl_api_prefix_t mb_prefix
    item = cJSON_GetObjectItem(o, "mb_prefix");
    if (!item) return 0;
    // start field mb_prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->mb_prefix);
    if (!a) return 0;
    // end field mb_prefix


    *len = l;
    return a;
}
static inline vl_api_mpls_ip_bind_unbind_reply_t *vl_api_mpls_ip_bind_unbind_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_ip_bind_unbind_reply_t);
    vl_api_mpls_ip_bind_unbind_reply_t *a = malloc(l);
    // processing mpls_ip_bind_unbind_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_mpls_tunnel_add_del_t *vl_api_mpls_tunnel_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_tunnel_add_del_t);
    vl_api_mpls_tunnel_add_del_t *a = malloc(l);
    // processing mpls_tunnel_add_del: bool mt_is_add
    item = cJSON_GetObjectItem(o, "mt_is_add");
    if (!item) return 0;
    // start field mt_is_add
    vl_api_bool_fromjson(item, &a->mt_is_add);
    // end field mt_is_add

    // processing mpls_tunnel_add_del: vl_api_mpls_tunnel_t mt_tunnel
    item = cJSON_GetObjectItem(o, "mt_tunnel");
    if (!item) return 0;
    // start field mt_tunnel
    a = vl_api_mpls_tunnel_t_fromjson(a, &l, item, &a->mt_tunnel);
    if (!a) return 0;
    // end field mt_tunnel


    *len = l;
    return a;
}
static inline vl_api_mpls_tunnel_add_del_reply_t *vl_api_mpls_tunnel_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_tunnel_add_del_reply_t);
    vl_api_mpls_tunnel_add_del_reply_t *a = malloc(l);
    // processing mpls_tunnel_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing mpls_tunnel_add_del_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing mpls_tunnel_add_del_reply: u32 tunnel_index
    item = cJSON_GetObjectItem(o, "tunnel_index");
    if (!item) return 0;
    // start field tunnel_index
    vl_api_u32_fromjson(item, &a->tunnel_index);
    // end field tunnel_index


    *len = l;
    return a;
}
static inline vl_api_mpls_tunnel_dump_t *vl_api_mpls_tunnel_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_tunnel_dump_t);
    vl_api_mpls_tunnel_dump_t *a = malloc(l);
    // processing mpls_tunnel_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_mpls_tunnel_details_t *vl_api_mpls_tunnel_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_tunnel_details_t);
    vl_api_mpls_tunnel_details_t *a = malloc(l);
    // processing mpls_tunnel_details: vl_api_mpls_tunnel_t mt_tunnel
    item = cJSON_GetObjectItem(o, "mt_tunnel");
    if (!item) return 0;
    // start field mt_tunnel
    a = vl_api_mpls_tunnel_t_fromjson(a, &l, item, &a->mt_tunnel);
    if (!a) return 0;
    // end field mt_tunnel


    *len = l;
    return a;
}
static inline vl_api_mpls_table_add_del_t *vl_api_mpls_table_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_table_add_del_t);
    vl_api_mpls_table_add_del_t *a = malloc(l);
    // processing mpls_table_add_del: bool mt_is_add
    item = cJSON_GetObjectItem(o, "mt_is_add");
    if (!item) return 0;
    // start field mt_is_add
    vl_api_bool_fromjson(item, &a->mt_is_add);
    // end field mt_is_add

    // processing mpls_table_add_del: vl_api_mpls_table_t mt_table
    item = cJSON_GetObjectItem(o, "mt_table");
    if (!item) return 0;
    // start field mt_table
    a = vl_api_mpls_table_t_fromjson(a, &l, item, &a->mt_table);
    if (!a) return 0;
    // end field mt_table


    *len = l;
    return a;
}
static inline vl_api_mpls_table_add_del_reply_t *vl_api_mpls_table_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_table_add_del_reply_t);
    vl_api_mpls_table_add_del_reply_t *a = malloc(l);
    // processing mpls_table_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_mpls_table_dump_t *vl_api_mpls_table_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_table_dump_t);
    vl_api_mpls_table_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_mpls_table_details_t *vl_api_mpls_table_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_table_details_t);
    vl_api_mpls_table_details_t *a = malloc(l);
    // processing mpls_table_details: vl_api_mpls_table_t mt_table
    item = cJSON_GetObjectItem(o, "mt_table");
    if (!item) return 0;
    // start field mt_table
    a = vl_api_mpls_table_t_fromjson(a, &l, item, &a->mt_table);
    if (!a) return 0;
    // end field mt_table


    *len = l;
    return a;
}
static inline vl_api_mpls_route_add_del_t *vl_api_mpls_route_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_route_add_del_t);
    vl_api_mpls_route_add_del_t *a = malloc(l);
    // processing mpls_route_add_del: bool mr_is_add
    item = cJSON_GetObjectItem(o, "mr_is_add");
    if (!item) return 0;
    // start field mr_is_add
    vl_api_bool_fromjson(item, &a->mr_is_add);
    // end field mr_is_add

    // processing mpls_route_add_del: bool mr_is_multipath
    item = cJSON_GetObjectItem(o, "mr_is_multipath");
    if (!item) return 0;
    // start field mr_is_multipath
    vl_api_bool_fromjson(item, &a->mr_is_multipath);
    // end field mr_is_multipath

    // processing mpls_route_add_del: vl_api_mpls_route_t mr_route
    item = cJSON_GetObjectItem(o, "mr_route");
    if (!item) return 0;
    // start field mr_route
    a = vl_api_mpls_route_t_fromjson(a, &l, item, &a->mr_route);
    if (!a) return 0;
    // end field mr_route


    *len = l;
    return a;
}
static inline vl_api_mpls_route_add_del_reply_t *vl_api_mpls_route_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_route_add_del_reply_t);
    vl_api_mpls_route_add_del_reply_t *a = malloc(l);
    // processing mpls_route_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing mpls_route_add_del_reply: u32 stats_index
    item = cJSON_GetObjectItem(o, "stats_index");
    if (!item) return 0;
    // start field stats_index
    vl_api_u32_fromjson(item, &a->stats_index);
    // end field stats_index


    *len = l;
    return a;
}
static inline vl_api_mpls_route_dump_t *vl_api_mpls_route_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_route_dump_t);
    vl_api_mpls_route_dump_t *a = malloc(l);
    // processing mpls_route_dump: vl_api_mpls_table_t table
    item = cJSON_GetObjectItem(o, "table");
    if (!item) return 0;
    // start field table
    a = vl_api_mpls_table_t_fromjson(a, &l, item, &a->table);
    if (!a) return 0;
    // end field table


    *len = l;
    return a;
}
static inline vl_api_mpls_route_details_t *vl_api_mpls_route_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_mpls_route_details_t);
    vl_api_mpls_route_details_t *a = malloc(l);
    // processing mpls_route_details: vl_api_mpls_route_t mr_route
    item = cJSON_GetObjectItem(o, "mr_route");
    if (!item) return 0;
    // start field mr_route
    a = vl_api_mpls_route_t_fromjson(a, &l, item, &a->mr_route);
    if (!a) return 0;
    // end field mr_route


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mpls_enable_t *vl_api_sw_interface_set_mpls_enable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mpls_enable_t);
    vl_api_sw_interface_set_mpls_enable_t *a = malloc(l);
    // processing sw_interface_set_mpls_enable: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_mpls_enable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_mpls_enable_reply_t *vl_api_sw_interface_set_mpls_enable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_mpls_enable_reply_t);
    vl_api_sw_interface_set_mpls_enable_reply_t *a = malloc(l);
    // processing sw_interface_set_mpls_enable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
