/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_pg_api_fromjson_h
#define included_pg_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_pg_create_interface_t *vl_api_pg_create_interface_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_create_interface_t);
    vl_api_pg_create_interface_t *a = malloc(l);
    // processing pg_create_interface: vl_api_interface_index_t interface_id
    item = cJSON_GetObjectItem(o, "interface_id");
    if (!item) return 0;
    // start field interface_id
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->interface_id);
    if (!a) return 0;
    // end field interface_id

    // processing pg_create_interface: bool gso_enabled
    item = cJSON_GetObjectItem(o, "gso_enabled");
    if (!item) return 0;
    // start field gso_enabled
    vl_api_bool_fromjson(item, &a->gso_enabled);
    // end field gso_enabled

    // processing pg_create_interface: u32 gso_size
    item = cJSON_GetObjectItem(o, "gso_size");
    if (!item) return 0;
    // start field gso_size
    vl_api_u32_fromjson(item, &a->gso_size);
    // end field gso_size


    *len = l;
    return a;
}
static inline vl_api_pg_create_interface_reply_t *vl_api_pg_create_interface_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_create_interface_reply_t);
    vl_api_pg_create_interface_reply_t *a = malloc(l);
    // processing pg_create_interface_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing pg_create_interface_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_pg_interface_enable_disable_coalesce_t *vl_api_pg_interface_enable_disable_coalesce_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_interface_enable_disable_coalesce_t);
    vl_api_pg_interface_enable_disable_coalesce_t *a = malloc(l);
    // processing pg_interface_enable_disable_coalesce: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing pg_interface_enable_disable_coalesce: bool coalesce_enabled
    item = cJSON_GetObjectItem(o, "coalesce_enabled");
    if (!item) return 0;
    // start field coalesce_enabled
    vl_api_bool_fromjson(item, &a->coalesce_enabled);
    // end field coalesce_enabled


    *len = l;
    return a;
}
static inline vl_api_pg_interface_enable_disable_coalesce_reply_t *vl_api_pg_interface_enable_disable_coalesce_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_interface_enable_disable_coalesce_reply_t);
    vl_api_pg_interface_enable_disable_coalesce_reply_t *a = malloc(l);
    // processing pg_interface_enable_disable_coalesce_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_pg_capture_t *vl_api_pg_capture_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_capture_t);
    vl_api_pg_capture_t *a = malloc(l);
    // processing pg_capture: vl_api_interface_index_t interface_id
    item = cJSON_GetObjectItem(o, "interface_id");
    if (!item) return 0;
    // start field interface_id
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->interface_id);
    if (!a) return 0;
    // end field interface_id

    // processing pg_capture: bool is_enabled
    item = cJSON_GetObjectItem(o, "is_enabled");
    if (!item) return 0;
    // start field is_enabled
    vl_api_bool_fromjson(item, &a->is_enabled);
    // end field is_enabled

    // processing pg_capture: u32 count
    item = cJSON_GetObjectItem(o, "count");
    if (!item) return 0;
    // start field count
    vl_api_u32_fromjson(item, &a->count);
    // end field count

    // processing pg_capture: string pcap_file_name
    item = cJSON_GetObjectItem(o, "pcap_file_name");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_pg_capture_reply_t *vl_api_pg_capture_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_capture_reply_t);
    vl_api_pg_capture_reply_t *a = malloc(l);
    // processing pg_capture_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_pg_enable_disable_t *vl_api_pg_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_enable_disable_t);
    vl_api_pg_enable_disable_t *a = malloc(l);
    // processing pg_enable_disable: bool is_enabled
    item = cJSON_GetObjectItem(o, "is_enabled");
    if (!item) return 0;
    // start field is_enabled
    vl_api_bool_fromjson(item, &a->is_enabled);
    // end field is_enabled

    // processing pg_enable_disable: string stream_name
    item = cJSON_GetObjectItem(o, "stream_name");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_pg_enable_disable_reply_t *vl_api_pg_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_pg_enable_disable_reply_t);
    vl_api_pg_enable_disable_reply_t *a = malloc(l);
    // processing pg_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
