/* Imported API files */
#include <vnet/policer/policer_types.api_fromjson.h>
#ifndef included_policer_api_fromjson_h
#define included_policer_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_policer_add_del_t *vl_api_policer_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_add_del_t);
    vl_api_policer_add_del_t *a = malloc(l);
    // processing policer_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing policer_add_del: string name
    item = cJSON_GetObjectItem(o, "name");
    if (!item) return 0;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    // processing policer_add_del: u32 cir
    item = cJSON_GetObjectItem(o, "cir");
    if (!item) return 0;
    // start field cir
    vl_api_u32_fromjson(item, &a->cir);
    // end field cir

    // processing policer_add_del: u32 eir
    item = cJSON_GetObjectItem(o, "eir");
    if (!item) return 0;
    // start field eir
    vl_api_u32_fromjson(item, &a->eir);
    // end field eir

    // processing policer_add_del: u64 cb
    item = cJSON_GetObjectItem(o, "cb");
    if (!item) return 0;
    // start field cb
    vl_api_u64_fromjson(item, &a->cb);
    // end field cb

    // processing policer_add_del: u64 eb
    item = cJSON_GetObjectItem(o, "eb");
    if (!item) return 0;
    // start field eb
    vl_api_u64_fromjson(item, &a->eb);
    // end field eb

    // processing policer_add_del: vl_api_sse2_qos_rate_type_t rate_type
    item = cJSON_GetObjectItem(o, "rate_type");
    if (!item) return 0;
    // start field rate_type
    a = vl_api_sse2_qos_rate_type_t_fromjson(a, &l, item, &a->rate_type);
    if (!a) return 0;
    // end field rate_type

    // processing policer_add_del: vl_api_sse2_qos_round_type_t round_type
    item = cJSON_GetObjectItem(o, "round_type");
    if (!item) return 0;
    // start field round_type
    a = vl_api_sse2_qos_round_type_t_fromjson(a, &l, item, &a->round_type);
    if (!a) return 0;
    // end field round_type

    // processing policer_add_del: vl_api_sse2_qos_policer_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_sse2_qos_policer_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type

    // processing policer_add_del: bool color_aware
    item = cJSON_GetObjectItem(o, "color_aware");
    if (!item) return 0;
    // start field color_aware
    vl_api_bool_fromjson(item, &a->color_aware);
    // end field color_aware

    // processing policer_add_del: vl_api_sse2_qos_action_t conform_action
    item = cJSON_GetObjectItem(o, "conform_action");
    if (!item) return 0;
    // start field conform_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->conform_action);
    if (!a) return 0;
    // end field conform_action

    // processing policer_add_del: vl_api_sse2_qos_action_t exceed_action
    item = cJSON_GetObjectItem(o, "exceed_action");
    if (!item) return 0;
    // start field exceed_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->exceed_action);
    if (!a) return 0;
    // end field exceed_action

    // processing policer_add_del: vl_api_sse2_qos_action_t violate_action
    item = cJSON_GetObjectItem(o, "violate_action");
    if (!item) return 0;
    // start field violate_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->violate_action);
    if (!a) return 0;
    // end field violate_action


    *len = l;
    return a;
}
static inline vl_api_policer_add_del_reply_t *vl_api_policer_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_add_del_reply_t);
    vl_api_policer_add_del_reply_t *a = malloc(l);
    // processing policer_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing policer_add_del_reply: u32 policer_index
    item = cJSON_GetObjectItem(o, "policer_index");
    if (!item) return 0;
    // start field policer_index
    vl_api_u32_fromjson(item, &a->policer_index);
    // end field policer_index


    *len = l;
    return a;
}
static inline vl_api_policer_dump_t *vl_api_policer_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_dump_t);
    vl_api_policer_dump_t *a = malloc(l);
    // processing policer_dump: bool match_name_valid
    item = cJSON_GetObjectItem(o, "match_name_valid");
    if (!item) return 0;
    // start field match_name_valid
    vl_api_bool_fromjson(item, &a->match_name_valid);
    // end field match_name_valid

    // processing policer_dump: string match_name
    item = cJSON_GetObjectItem(o, "match_name");
    if (!item) return 0;
    strncpy_s((char *)a->match_name, sizeof(a->match_name), cJSON_GetStringValue(item), sizeof(a->match_name) - 1);


    *len = l;
    return a;
}
static inline vl_api_policer_details_t *vl_api_policer_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_policer_details_t);
    vl_api_policer_details_t *a = malloc(l);
    // processing policer_details: string name
    item = cJSON_GetObjectItem(o, "name");
    if (!item) return 0;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    // processing policer_details: u32 cir
    item = cJSON_GetObjectItem(o, "cir");
    if (!item) return 0;
    // start field cir
    vl_api_u32_fromjson(item, &a->cir);
    // end field cir

    // processing policer_details: u32 eir
    item = cJSON_GetObjectItem(o, "eir");
    if (!item) return 0;
    // start field eir
    vl_api_u32_fromjson(item, &a->eir);
    // end field eir

    // processing policer_details: u64 cb
    item = cJSON_GetObjectItem(o, "cb");
    if (!item) return 0;
    // start field cb
    vl_api_u64_fromjson(item, &a->cb);
    // end field cb

    // processing policer_details: u64 eb
    item = cJSON_GetObjectItem(o, "eb");
    if (!item) return 0;
    // start field eb
    vl_api_u64_fromjson(item, &a->eb);
    // end field eb

    // processing policer_details: vl_api_sse2_qos_rate_type_t rate_type
    item = cJSON_GetObjectItem(o, "rate_type");
    if (!item) return 0;
    // start field rate_type
    a = vl_api_sse2_qos_rate_type_t_fromjson(a, &l, item, &a->rate_type);
    if (!a) return 0;
    // end field rate_type

    // processing policer_details: vl_api_sse2_qos_round_type_t round_type
    item = cJSON_GetObjectItem(o, "round_type");
    if (!item) return 0;
    // start field round_type
    a = vl_api_sse2_qos_round_type_t_fromjson(a, &l, item, &a->round_type);
    if (!a) return 0;
    // end field round_type

    // processing policer_details: vl_api_sse2_qos_policer_type_t type
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    a = vl_api_sse2_qos_policer_type_t_fromjson(a, &l, item, &a->type);
    if (!a) return 0;
    // end field type

    // processing policer_details: vl_api_sse2_qos_action_t conform_action
    item = cJSON_GetObjectItem(o, "conform_action");
    if (!item) return 0;
    // start field conform_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->conform_action);
    if (!a) return 0;
    // end field conform_action

    // processing policer_details: vl_api_sse2_qos_action_t exceed_action
    item = cJSON_GetObjectItem(o, "exceed_action");
    if (!item) return 0;
    // start field exceed_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->exceed_action);
    if (!a) return 0;
    // end field exceed_action

    // processing policer_details: vl_api_sse2_qos_action_t violate_action
    item = cJSON_GetObjectItem(o, "violate_action");
    if (!item) return 0;
    // start field violate_action
    a = vl_api_sse2_qos_action_t_fromjson(a, &l, item, &a->violate_action);
    if (!a) return 0;
    // end field violate_action

    // processing policer_details: bool single_rate
    item = cJSON_GetObjectItem(o, "single_rate");
    if (!item) return 0;
    // start field single_rate
    vl_api_bool_fromjson(item, &a->single_rate);
    // end field single_rate

    // processing policer_details: bool color_aware
    item = cJSON_GetObjectItem(o, "color_aware");
    if (!item) return 0;
    // start field color_aware
    vl_api_bool_fromjson(item, &a->color_aware);
    // end field color_aware

    // processing policer_details: u32 scale
    item = cJSON_GetObjectItem(o, "scale");
    if (!item) return 0;
    // start field scale
    vl_api_u32_fromjson(item, &a->scale);
    // end field scale

    // processing policer_details: u32 cir_tokens_per_period
    item = cJSON_GetObjectItem(o, "cir_tokens_per_period");
    if (!item) return 0;
    // start field cir_tokens_per_period
    vl_api_u32_fromjson(item, &a->cir_tokens_per_period);
    // end field cir_tokens_per_period

    // processing policer_details: u32 pir_tokens_per_period
    item = cJSON_GetObjectItem(o, "pir_tokens_per_period");
    if (!item) return 0;
    // start field pir_tokens_per_period
    vl_api_u32_fromjson(item, &a->pir_tokens_per_period);
    // end field pir_tokens_per_period

    // processing policer_details: u32 current_limit
    item = cJSON_GetObjectItem(o, "current_limit");
    if (!item) return 0;
    // start field current_limit
    vl_api_u32_fromjson(item, &a->current_limit);
    // end field current_limit

    // processing policer_details: u32 current_bucket
    item = cJSON_GetObjectItem(o, "current_bucket");
    if (!item) return 0;
    // start field current_bucket
    vl_api_u32_fromjson(item, &a->current_bucket);
    // end field current_bucket

    // processing policer_details: u32 extended_limit
    item = cJSON_GetObjectItem(o, "extended_limit");
    if (!item) return 0;
    // start field extended_limit
    vl_api_u32_fromjson(item, &a->extended_limit);
    // end field extended_limit

    // processing policer_details: u32 extended_bucket
    item = cJSON_GetObjectItem(o, "extended_bucket");
    if (!item) return 0;
    // start field extended_bucket
    vl_api_u32_fromjson(item, &a->extended_bucket);
    // end field extended_bucket

    // processing policer_details: u64 last_update_time
    item = cJSON_GetObjectItem(o, "last_update_time");
    if (!item) return 0;
    // start field last_update_time
    vl_api_u64_fromjson(item, &a->last_update_time);
    // end field last_update_time


    *len = l;
    return a;
}
#endif
