/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_qos_api_fromjson_h
#define included_qos_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_qos_source_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_source_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "QOS_API_SOURCE_EXT") == 0) {*a = 0; return mp;}
    if (strcmp(p, "QOS_API_SOURCE_VLAN") == 0) {*a = 1; return mp;}
    if (strcmp(p, "QOS_API_SOURCE_MPLS") == 0) {*a = 2; return mp;}
    if (strcmp(p, "QOS_API_SOURCE_IP") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_qos_store_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_store_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "input_source");
    if (!item) return 0;
    // start field input_source
    mp = vl_api_qos_source_t_fromjson(mp, len, item, &a->input_source);
    if (!mp) return 0;
    // end field input_source
    item = cJSON_GetObjectItem(o, "value");
    if (!item) return 0;
    // start field value
    vl_api_u8_fromjson(item, &a->value);
    // end field value
    return mp;
}
static inline void *vl_api_qos_record_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_record_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "input_source");
    if (!item) return 0;
    // start field input_source
    mp = vl_api_qos_source_t_fromjson(mp, len, item, &a->input_source);
    if (!mp) return 0;
    // end field input_source
    return mp;
}
static inline void *vl_api_qos_egress_map_row_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_egress_map_row_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "outputs");
    if (!item) return 0;
    u8string_fromjson2(o, "outputs", a->outputs);
    return mp;
}
static inline void *vl_api_qos_egress_map_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_egress_map_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id
    item = cJSON_GetObjectItem(o, "rows");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "rows");
        int size = cJSON_GetArraySize(array);
        if (size != 4) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            a = vl_api_qos_egress_map_row_t_fromjson(mp, len, e, &a->rows[i]);
        }
    }
    return mp;
}
static inline void *vl_api_qos_mark_t_fromjson (void *mp, int *len, cJSON *o, vl_api_qos_mark_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    vl_api_u32_fromjson(item, &a->sw_if_index);
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "map_id");
    if (!item) return 0;
    // start field map_id
    vl_api_u32_fromjson(item, &a->map_id);
    // end field map_id
    item = cJSON_GetObjectItem(o, "output_source");
    if (!item) return 0;
    // start field output_source
    mp = vl_api_qos_source_t_fromjson(mp, len, item, &a->output_source);
    if (!mp) return 0;
    // end field output_source
    return mp;
}
static inline vl_api_qos_store_enable_disable_t *vl_api_qos_store_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_store_enable_disable_t);
    vl_api_qos_store_enable_disable_t *a = malloc(l);
    // processing qos_store_enable_disable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing qos_store_enable_disable: vl_api_qos_store_t store
    item = cJSON_GetObjectItem(o, "store");
    if (!item) return 0;
    // start field store
    a = vl_api_qos_store_t_fromjson(a, &l, item, &a->store);
    if (!a) return 0;
    // end field store


    *len = l;
    return a;
}
static inline vl_api_qos_store_enable_disable_reply_t *vl_api_qos_store_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_store_enable_disable_reply_t);
    vl_api_qos_store_enable_disable_reply_t *a = malloc(l);
    // processing qos_store_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_qos_store_dump_t *vl_api_qos_store_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_store_dump_t);
    vl_api_qos_store_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_qos_store_details_t *vl_api_qos_store_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_store_details_t);
    vl_api_qos_store_details_t *a = malloc(l);
    // processing qos_store_details: vl_api_qos_store_t store
    item = cJSON_GetObjectItem(o, "store");
    if (!item) return 0;
    // start field store
    a = vl_api_qos_store_t_fromjson(a, &l, item, &a->store);
    if (!a) return 0;
    // end field store


    *len = l;
    return a;
}
static inline vl_api_qos_record_enable_disable_t *vl_api_qos_record_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_record_enable_disable_t);
    vl_api_qos_record_enable_disable_t *a = malloc(l);
    // processing qos_record_enable_disable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing qos_record_enable_disable: vl_api_qos_record_t record
    item = cJSON_GetObjectItem(o, "record");
    if (!item) return 0;
    // start field record
    a = vl_api_qos_record_t_fromjson(a, &l, item, &a->record);
    if (!a) return 0;
    // end field record


    *len = l;
    return a;
}
static inline vl_api_qos_record_enable_disable_reply_t *vl_api_qos_record_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_record_enable_disable_reply_t);
    vl_api_qos_record_enable_disable_reply_t *a = malloc(l);
    // processing qos_record_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_qos_record_dump_t *vl_api_qos_record_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_record_dump_t);
    vl_api_qos_record_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_qos_record_details_t *vl_api_qos_record_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_record_details_t);
    vl_api_qos_record_details_t *a = malloc(l);
    // processing qos_record_details: vl_api_qos_record_t record
    item = cJSON_GetObjectItem(o, "record");
    if (!item) return 0;
    // start field record
    a = vl_api_qos_record_t_fromjson(a, &l, item, &a->record);
    if (!a) return 0;
    // end field record


    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_update_t *vl_api_qos_egress_map_update_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_update_t);
    vl_api_qos_egress_map_update_t *a = malloc(l);
    // processing qos_egress_map_update: vl_api_qos_egress_map_t map
    item = cJSON_GetObjectItem(o, "map");
    if (!item) return 0;
    // start field map
    a = vl_api_qos_egress_map_t_fromjson(a, &l, item, &a->map);
    if (!a) return 0;
    // end field map


    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_update_reply_t *vl_api_qos_egress_map_update_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_update_reply_t);
    vl_api_qos_egress_map_update_reply_t *a = malloc(l);
    // processing qos_egress_map_update_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_delete_t *vl_api_qos_egress_map_delete_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_delete_t);
    vl_api_qos_egress_map_delete_t *a = malloc(l);
    // processing qos_egress_map_delete: u32 id
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id


    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_delete_reply_t *vl_api_qos_egress_map_delete_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_delete_reply_t);
    vl_api_qos_egress_map_delete_reply_t *a = malloc(l);
    // processing qos_egress_map_delete_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_dump_t *vl_api_qos_egress_map_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_dump_t);
    vl_api_qos_egress_map_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_qos_egress_map_details_t *vl_api_qos_egress_map_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_egress_map_details_t);
    vl_api_qos_egress_map_details_t *a = malloc(l);
    // processing qos_egress_map_details: vl_api_qos_egress_map_t map
    item = cJSON_GetObjectItem(o, "map");
    if (!item) return 0;
    // start field map
    a = vl_api_qos_egress_map_t_fromjson(a, &l, item, &a->map);
    if (!a) return 0;
    // end field map


    *len = l;
    return a;
}
static inline vl_api_qos_mark_enable_disable_t *vl_api_qos_mark_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_mark_enable_disable_t);
    vl_api_qos_mark_enable_disable_t *a = malloc(l);
    // processing qos_mark_enable_disable: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing qos_mark_enable_disable: vl_api_qos_mark_t mark
    item = cJSON_GetObjectItem(o, "mark");
    if (!item) return 0;
    // start field mark
    a = vl_api_qos_mark_t_fromjson(a, &l, item, &a->mark);
    if (!a) return 0;
    // end field mark


    *len = l;
    return a;
}
static inline vl_api_qos_mark_enable_disable_reply_t *vl_api_qos_mark_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_mark_enable_disable_reply_t);
    vl_api_qos_mark_enable_disable_reply_t *a = malloc(l);
    // processing qos_mark_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_qos_mark_dump_t *vl_api_qos_mark_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_mark_dump_t);
    vl_api_qos_mark_dump_t *a = malloc(l);
    // processing qos_mark_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_qos_mark_details_t *vl_api_qos_mark_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_mark_details_t);
    vl_api_qos_mark_details_t *a = malloc(l);
    // processing qos_mark_details: vl_api_qos_mark_t mark
    item = cJSON_GetObjectItem(o, "mark");
    if (!item) return 0;
    // start field mark
    a = vl_api_qos_mark_t_fromjson(a, &l, item, &a->mark);
    if (!a) return 0;
    // end field mark


    *len = l;
    return a;
}
static inline vl_api_qos_mark_details_reply_t *vl_api_qos_mark_details_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_qos_mark_details_reply_t);
    vl_api_qos_mark_details_reply_t *a = malloc(l);
    // processing qos_mark_details_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
