/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_session_api_fromjson_h
#define included_session_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_transport_proto_t_fromjson (void *mp, int *len, cJSON *o, vl_api_transport_proto_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "TRANSPORT_PROTO_API_TCP") == 0) {*a = 1; return mp;}
    if (strcmp(p, "TRANSPORT_PROTO_API_UDP") == 0) {*a = 2; return mp;}
    if (strcmp(p, "TRANSPORT_PROTO_API_NONE") == 0) {*a = 3; return mp;}
    if (strcmp(p, "TRANSPORT_PROTO_API_TLS") == 0) {*a = 4; return mp;}
    if (strcmp(p, "TRANSPORT_PROTO_API_QUIC") == 0) {*a = 5; return mp;}
   return 0;
}
static inline void *vl_api_session_rule_scope_t_fromjson (void *mp, int *len, cJSON *o, vl_api_session_rule_scope_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SESSION_RULE_SCOPE_API_GLOBAL") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SESSION_RULE_SCOPE_API_LOCAL") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SESSION_RULE_SCOPE_API_BOTH") == 0) {*a = 2; return mp;}
   return 0;
}
static inline vl_api_app_attach_t *vl_api_app_attach_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_attach_t);
    vl_api_app_attach_t *a = malloc(l);
    // processing app_attach: u64 options
    item = cJSON_GetObjectItem(o, "options");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "options");
        int size = cJSON_GetArraySize(array);
        if (size != 18) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u64_fromjson(e, &a->options[i]);
        }
    }

    // processing app_attach: string namespace_id
    item = cJSON_GetObjectItem(o, "namespace_id");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_app_attach_reply_t *vl_api_app_attach_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_attach_reply_t);
    vl_api_app_attach_reply_t *a = malloc(l);
    // processing app_attach_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing app_attach_reply: u64 app_mq
    item = cJSON_GetObjectItem(o, "app_mq");
    if (!item) return 0;
    // start field app_mq
    vl_api_u64_fromjson(item, &a->app_mq);
    // end field app_mq

    // processing app_attach_reply: u64 vpp_ctrl_mq
    item = cJSON_GetObjectItem(o, "vpp_ctrl_mq");
    if (!item) return 0;
    // start field vpp_ctrl_mq
    vl_api_u64_fromjson(item, &a->vpp_ctrl_mq);
    // end field vpp_ctrl_mq

    // processing app_attach_reply: u8 vpp_ctrl_mq_thread
    item = cJSON_GetObjectItem(o, "vpp_ctrl_mq_thread");
    if (!item) return 0;
    // start field vpp_ctrl_mq_thread
    vl_api_u8_fromjson(item, &a->vpp_ctrl_mq_thread);
    // end field vpp_ctrl_mq_thread

    // processing app_attach_reply: u32 app_index
    item = cJSON_GetObjectItem(o, "app_index");
    if (!item) return 0;
    // start field app_index
    vl_api_u32_fromjson(item, &a->app_index);
    // end field app_index

    // processing app_attach_reply: u8 n_fds
    item = cJSON_GetObjectItem(o, "n_fds");
    if (!item) return 0;
    // start field n_fds
    vl_api_u8_fromjson(item, &a->n_fds);
    // end field n_fds

    // processing app_attach_reply: u8 fd_flags
    item = cJSON_GetObjectItem(o, "fd_flags");
    if (!item) return 0;
    // start field fd_flags
    vl_api_u8_fromjson(item, &a->fd_flags);
    // end field fd_flags

    // processing app_attach_reply: u32 segment_size
    item = cJSON_GetObjectItem(o, "segment_size");
    if (!item) return 0;
    // start field segment_size
    vl_api_u32_fromjson(item, &a->segment_size);
    // end field segment_size

    // processing app_attach_reply: u64 segment_handle
    item = cJSON_GetObjectItem(o, "segment_handle");
    if (!item) return 0;
    // start field segment_handle
    vl_api_u64_fromjson(item, &a->segment_handle);
    // end field segment_handle

    // processing app_attach_reply: string segment_name
    item = cJSON_GetObjectItem(o, "segment_name");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_application_detach_t *vl_api_application_detach_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_detach_t);
    vl_api_application_detach_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_application_detach_reply_t *vl_api_application_detach_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_detach_reply_t);
    vl_api_application_detach_reply_t *a = malloc(l);
    // processing application_detach_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_app_add_cert_key_pair_t *vl_api_app_add_cert_key_pair_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_add_cert_key_pair_t);
    vl_api_app_add_cert_key_pair_t *a = malloc(l);
    // processing app_add_cert_key_pair: u16 cert_len
    item = cJSON_GetObjectItem(o, "cert_len");
    if (!item) return 0;
    // start field cert_len
    vl_api_u16_fromjson(item, &a->cert_len);
    // end field cert_len

    // processing app_add_cert_key_pair: u8 certkey
    item = cJSON_GetObjectItem(o, "certkey");
    if (!item) return 0;
    s = u8string_fromjson(o, "certkey");
    if (!s) return 0;
    a->certkey_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_app_add_cert_key_pair_reply_t *vl_api_app_add_cert_key_pair_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_add_cert_key_pair_reply_t);
    vl_api_app_add_cert_key_pair_reply_t *a = malloc(l);
    // processing app_add_cert_key_pair_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing app_add_cert_key_pair_reply: u32 index
    item = cJSON_GetObjectItem(o, "index");
    if (!item) return 0;
    // start field index
    vl_api_u32_fromjson(item, &a->index);
    // end field index


    *len = l;
    return a;
}
static inline vl_api_app_del_cert_key_pair_t *vl_api_app_del_cert_key_pair_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_del_cert_key_pair_t);
    vl_api_app_del_cert_key_pair_t *a = malloc(l);
    // processing app_del_cert_key_pair: u32 index
    item = cJSON_GetObjectItem(o, "index");
    if (!item) return 0;
    // start field index
    vl_api_u32_fromjson(item, &a->index);
    // end field index


    *len = l;
    return a;
}
static inline vl_api_app_del_cert_key_pair_reply_t *vl_api_app_del_cert_key_pair_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_del_cert_key_pair_reply_t);
    vl_api_app_del_cert_key_pair_reply_t *a = malloc(l);
    // processing app_del_cert_key_pair_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_application_tls_cert_add_t *vl_api_application_tls_cert_add_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_tls_cert_add_t);
    vl_api_application_tls_cert_add_t *a = malloc(l);
    // processing application_tls_cert_add: u32 app_index
    item = cJSON_GetObjectItem(o, "app_index");
    if (!item) return 0;
    // start field app_index
    vl_api_u32_fromjson(item, &a->app_index);
    // end field app_index

    // processing application_tls_cert_add: u8 cert
    item = cJSON_GetObjectItem(o, "cert");
    if (!item) return 0;
    s = u8string_fromjson(o, "cert");
    if (!s) return 0;
    a->cert_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_application_tls_cert_add_reply_t *vl_api_application_tls_cert_add_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_tls_cert_add_reply_t);
    vl_api_application_tls_cert_add_reply_t *a = malloc(l);
    // processing application_tls_cert_add_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_application_tls_key_add_t *vl_api_application_tls_key_add_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_tls_key_add_t);
    vl_api_application_tls_key_add_t *a = malloc(l);
    // processing application_tls_key_add: u32 app_index
    item = cJSON_GetObjectItem(o, "app_index");
    if (!item) return 0;
    // start field app_index
    vl_api_u32_fromjson(item, &a->app_index);
    // end field app_index

    // processing application_tls_key_add: u8 key
    item = cJSON_GetObjectItem(o, "key");
    if (!item) return 0;
    s = u8string_fromjson(o, "key");
    if (!s) return 0;
    a->key_len = vec_len(s);
    a = realloc(a, l + vec_len(s));
    memcpy((void *)a + l, s, vec_len(s));
    l += vec_len(s);
    vec_free(s);


    *len = l;
    return a;
}
static inline vl_api_application_tls_key_add_reply_t *vl_api_application_tls_key_add_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_application_tls_key_add_reply_t);
    vl_api_application_tls_key_add_reply_t *a = malloc(l);
    // processing application_tls_key_add_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_app_worker_add_del_t *vl_api_app_worker_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_worker_add_del_t);
    vl_api_app_worker_add_del_t *a = malloc(l);
    // processing app_worker_add_del: u32 app_index
    item = cJSON_GetObjectItem(o, "app_index");
    if (!item) return 0;
    // start field app_index
    vl_api_u32_fromjson(item, &a->app_index);
    // end field app_index

    // processing app_worker_add_del: u32 wrk_index
    item = cJSON_GetObjectItem(o, "wrk_index");
    if (!item) return 0;
    // start field wrk_index
    vl_api_u32_fromjson(item, &a->wrk_index);
    // end field wrk_index

    // processing app_worker_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_app_worker_add_del_reply_t *vl_api_app_worker_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_worker_add_del_reply_t);
    vl_api_app_worker_add_del_reply_t *a = malloc(l);
    // processing app_worker_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing app_worker_add_del_reply: u32 wrk_index
    item = cJSON_GetObjectItem(o, "wrk_index");
    if (!item) return 0;
    // start field wrk_index
    vl_api_u32_fromjson(item, &a->wrk_index);
    // end field wrk_index

    // processing app_worker_add_del_reply: u64 app_event_queue_address
    item = cJSON_GetObjectItem(o, "app_event_queue_address");
    if (!item) return 0;
    // start field app_event_queue_address
    vl_api_u64_fromjson(item, &a->app_event_queue_address);
    // end field app_event_queue_address

    // processing app_worker_add_del_reply: u8 n_fds
    item = cJSON_GetObjectItem(o, "n_fds");
    if (!item) return 0;
    // start field n_fds
    vl_api_u8_fromjson(item, &a->n_fds);
    // end field n_fds

    // processing app_worker_add_del_reply: u8 fd_flags
    item = cJSON_GetObjectItem(o, "fd_flags");
    if (!item) return 0;
    // start field fd_flags
    vl_api_u8_fromjson(item, &a->fd_flags);
    // end field fd_flags

    // processing app_worker_add_del_reply: u64 segment_handle
    item = cJSON_GetObjectItem(o, "segment_handle");
    if (!item) return 0;
    // start field segment_handle
    vl_api_u64_fromjson(item, &a->segment_handle);
    // end field segment_handle

    // processing app_worker_add_del_reply: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing app_worker_add_del_reply: string segment_name
    item = cJSON_GetObjectItem(o, "segment_name");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_session_enable_disable_t *vl_api_session_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_enable_disable_t);
    vl_api_session_enable_disable_t *a = malloc(l);
    // processing session_enable_disable: bool is_enable
    item = cJSON_GetObjectItem(o, "is_enable");
    if (!item) return 0;
    // start field is_enable
    vl_api_bool_fromjson(item, &a->is_enable);
    // end field is_enable


    *len = l;
    return a;
}
static inline vl_api_session_enable_disable_reply_t *vl_api_session_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_enable_disable_reply_t);
    vl_api_session_enable_disable_reply_t *a = malloc(l);
    // processing session_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_app_namespace_add_del_t *vl_api_app_namespace_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_namespace_add_del_t);
    vl_api_app_namespace_add_del_t *a = malloc(l);
    // processing app_namespace_add_del: u64 secret
    item = cJSON_GetObjectItem(o, "secret");
    if (!item) return 0;
    // start field secret
    vl_api_u64_fromjson(item, &a->secret);
    // end field secret

    // processing app_namespace_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing app_namespace_add_del: u32 ip4_fib_id
    item = cJSON_GetObjectItem(o, "ip4_fib_id");
    if (!item) return 0;
    // start field ip4_fib_id
    vl_api_u32_fromjson(item, &a->ip4_fib_id);
    // end field ip4_fib_id

    // processing app_namespace_add_del: u32 ip6_fib_id
    item = cJSON_GetObjectItem(o, "ip6_fib_id");
    if (!item) return 0;
    // start field ip6_fib_id
    vl_api_u32_fromjson(item, &a->ip6_fib_id);
    // end field ip6_fib_id

    // processing app_namespace_add_del: string namespace_id
    item = cJSON_GetObjectItem(o, "namespace_id");
    if (!item) return 0;
    char *p = cJSON_GetStringValue(item);
    size_t plen = strlen(p);
    a = realloc(a, l + plen);
    vl_api_c_string_to_api_string(p, (void *)a + l - sizeof(vl_api_string_t));
    l += plen;


    *len = l;
    return a;
}
static inline vl_api_app_namespace_add_del_reply_t *vl_api_app_namespace_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_app_namespace_add_del_reply_t);
    vl_api_app_namespace_add_del_reply_t *a = malloc(l);
    // processing app_namespace_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing app_namespace_add_del_reply: u32 appns_index
    item = cJSON_GetObjectItem(o, "appns_index");
    if (!item) return 0;
    // start field appns_index
    vl_api_u32_fromjson(item, &a->appns_index);
    // end field appns_index


    *len = l;
    return a;
}
static inline vl_api_session_rule_add_del_t *vl_api_session_rule_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_rule_add_del_t);
    vl_api_session_rule_add_del_t *a = malloc(l);
    // processing session_rule_add_del: vl_api_transport_proto_t transport_proto
    item = cJSON_GetObjectItem(o, "transport_proto");
    if (!item) return 0;
    // start field transport_proto
    a = vl_api_transport_proto_t_fromjson(a, &l, item, &a->transport_proto);
    if (!a) return 0;
    // end field transport_proto

    // processing session_rule_add_del: vl_api_prefix_t lcl
    item = cJSON_GetObjectItem(o, "lcl");
    if (!item) return 0;
    // start field lcl
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->lcl);
    if (!a) return 0;
    // end field lcl

    // processing session_rule_add_del: vl_api_prefix_t rmt
    item = cJSON_GetObjectItem(o, "rmt");
    if (!item) return 0;
    // start field rmt
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->rmt);
    if (!a) return 0;
    // end field rmt

    // processing session_rule_add_del: u16 lcl_port
    item = cJSON_GetObjectItem(o, "lcl_port");
    if (!item) return 0;
    // start field lcl_port
    vl_api_u16_fromjson(item, &a->lcl_port);
    // end field lcl_port

    // processing session_rule_add_del: u16 rmt_port
    item = cJSON_GetObjectItem(o, "rmt_port");
    if (!item) return 0;
    // start field rmt_port
    vl_api_u16_fromjson(item, &a->rmt_port);
    // end field rmt_port

    // processing session_rule_add_del: u32 action_index
    item = cJSON_GetObjectItem(o, "action_index");
    if (!item) return 0;
    // start field action_index
    vl_api_u32_fromjson(item, &a->action_index);
    // end field action_index

    // processing session_rule_add_del: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing session_rule_add_del: u32 appns_index
    item = cJSON_GetObjectItem(o, "appns_index");
    if (!item) return 0;
    // start field appns_index
    vl_api_u32_fromjson(item, &a->appns_index);
    // end field appns_index

    // processing session_rule_add_del: vl_api_session_rule_scope_t scope
    item = cJSON_GetObjectItem(o, "scope");
    if (!item) return 0;
    // start field scope
    a = vl_api_session_rule_scope_t_fromjson(a, &l, item, &a->scope);
    if (!a) return 0;
    // end field scope

    // processing session_rule_add_del: string tag
    item = cJSON_GetObjectItem(o, "tag");
    if (!item) return 0;
    strncpy_s((char *)a->tag, sizeof(a->tag), cJSON_GetStringValue(item), sizeof(a->tag) - 1);


    *len = l;
    return a;
}
static inline vl_api_session_rule_add_del_reply_t *vl_api_session_rule_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_rule_add_del_reply_t);
    vl_api_session_rule_add_del_reply_t *a = malloc(l);
    // processing session_rule_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_session_rules_dump_t *vl_api_session_rules_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_rules_dump_t);
    vl_api_session_rules_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_session_rules_details_t *vl_api_session_rules_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_session_rules_details_t);
    vl_api_session_rules_details_t *a = malloc(l);
    // processing session_rules_details: vl_api_transport_proto_t transport_proto
    item = cJSON_GetObjectItem(o, "transport_proto");
    if (!item) return 0;
    // start field transport_proto
    a = vl_api_transport_proto_t_fromjson(a, &l, item, &a->transport_proto);
    if (!a) return 0;
    // end field transport_proto

    // processing session_rules_details: vl_api_prefix_t lcl
    item = cJSON_GetObjectItem(o, "lcl");
    if (!item) return 0;
    // start field lcl
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->lcl);
    if (!a) return 0;
    // end field lcl

    // processing session_rules_details: vl_api_prefix_t rmt
    item = cJSON_GetObjectItem(o, "rmt");
    if (!item) return 0;
    // start field rmt
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->rmt);
    if (!a) return 0;
    // end field rmt

    // processing session_rules_details: u16 lcl_port
    item = cJSON_GetObjectItem(o, "lcl_port");
    if (!item) return 0;
    // start field lcl_port
    vl_api_u16_fromjson(item, &a->lcl_port);
    // end field lcl_port

    // processing session_rules_details: u16 rmt_port
    item = cJSON_GetObjectItem(o, "rmt_port");
    if (!item) return 0;
    // start field rmt_port
    vl_api_u16_fromjson(item, &a->rmt_port);
    // end field rmt_port

    // processing session_rules_details: u32 action_index
    item = cJSON_GetObjectItem(o, "action_index");
    if (!item) return 0;
    // start field action_index
    vl_api_u32_fromjson(item, &a->action_index);
    // end field action_index

    // processing session_rules_details: u32 appns_index
    item = cJSON_GetObjectItem(o, "appns_index");
    if (!item) return 0;
    // start field appns_index
    vl_api_u32_fromjson(item, &a->appns_index);
    // end field appns_index

    // processing session_rules_details: vl_api_session_rule_scope_t scope
    item = cJSON_GetObjectItem(o, "scope");
    if (!item) return 0;
    // start field scope
    a = vl_api_session_rule_scope_t_fromjson(a, &l, item, &a->scope);
    if (!a) return 0;
    // end field scope

    // processing session_rules_details: string tag
    item = cJSON_GetObjectItem(o, "tag");
    if (!item) return 0;
    strncpy_s((char *)a->tag, sizeof(a->tag), cJSON_GetStringValue(item), sizeof(a->tag) - 1);


    *len = l;
    return a;
}
#endif
