/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/srv6/sr_types.api_fromjson.h>
#ifndef included_sr_mpls_api_fromjson_h
#define included_sr_mpls_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_sr_mpls_policy_add_t *vl_api_sr_mpls_policy_add_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_add_t);
    vl_api_sr_mpls_policy_add_t *a = malloc(l);
    // processing sr_mpls_policy_add: u32 bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    vl_api_u32_fromjson(item, &a->bsid);
    // end field bsid

    // processing sr_mpls_policy_add: u32 weight
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight

    // processing sr_mpls_policy_add: bool is_spray
    item = cJSON_GetObjectItem(o, "is_spray");
    if (!item) return 0;
    // start field is_spray
    vl_api_bool_fromjson(item, &a->is_spray);
    // end field is_spray

    // processing sr_mpls_policy_add: u32 segments
    item = cJSON_GetObjectItem(o, "segments");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "segments");
        int size = cJSON_GetArraySize(array);
        a->n_segments = size;
        a = realloc(a, l + sizeof(u32) * size);
        u32 *d = (void *)a + l;
        l += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_add_reply_t *vl_api_sr_mpls_policy_add_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_add_reply_t);
    vl_api_sr_mpls_policy_add_reply_t *a = malloc(l);
    // processing sr_mpls_policy_add_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_mod_t *vl_api_sr_mpls_policy_mod_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_mod_t);
    vl_api_sr_mpls_policy_mod_t *a = malloc(l);
    // processing sr_mpls_policy_mod: u32 bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    vl_api_u32_fromjson(item, &a->bsid);
    // end field bsid

    // processing sr_mpls_policy_mod: vl_api_sr_policy_op_t operation
    item = cJSON_GetObjectItem(o, "operation");
    if (!item) return 0;
    // start field operation
    a = vl_api_sr_policy_op_t_fromjson(a, &l, item, &a->operation);
    if (!a) return 0;
    // end field operation

    // processing sr_mpls_policy_mod: u32 sl_index
    item = cJSON_GetObjectItem(o, "sl_index");
    if (!item) return 0;
    // start field sl_index
    vl_api_u32_fromjson(item, &a->sl_index);
    // end field sl_index

    // processing sr_mpls_policy_mod: u32 weight
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight

    // processing sr_mpls_policy_mod: u32 segments
    item = cJSON_GetObjectItem(o, "segments");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "segments");
        int size = cJSON_GetArraySize(array);
        a->n_segments = size;
        a = realloc(a, l + sizeof(u32) * size);
        u32 *d = (void *)a + l;
        l += sizeof(u32) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_u32_fromjson(e, &d[i]);
        }
    }


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_mod_reply_t *vl_api_sr_mpls_policy_mod_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_mod_reply_t);
    vl_api_sr_mpls_policy_mod_reply_t *a = malloc(l);
    // processing sr_mpls_policy_mod_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_del_t *vl_api_sr_mpls_policy_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_del_t);
    vl_api_sr_mpls_policy_del_t *a = malloc(l);
    // processing sr_mpls_policy_del: u32 bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    vl_api_u32_fromjson(item, &a->bsid);
    // end field bsid


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_del_reply_t *vl_api_sr_mpls_policy_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_del_reply_t);
    vl_api_sr_mpls_policy_del_reply_t *a = malloc(l);
    // processing sr_mpls_policy_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_steering_add_del_t *vl_api_sr_mpls_steering_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_steering_add_del_t);
    vl_api_sr_mpls_steering_add_del_t *a = malloc(l);
    // processing sr_mpls_steering_add_del: bool is_del
    item = cJSON_GetObjectItem(o, "is_del");
    if (!item) return 0;
    // start field is_del
    vl_api_bool_fromjson(item, &a->is_del);
    // end field is_del

    // processing sr_mpls_steering_add_del: u32 bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    vl_api_u32_fromjson(item, &a->bsid);
    // end field bsid

    // processing sr_mpls_steering_add_del: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing sr_mpls_steering_add_del: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing sr_mpls_steering_add_del: u32 mask_width
    item = cJSON_GetObjectItem(o, "mask_width");
    if (!item) return 0;
    // start field mask_width
    vl_api_u32_fromjson(item, &a->mask_width);
    // end field mask_width

    // processing sr_mpls_steering_add_del: vl_api_address_t next_hop
    item = cJSON_GetObjectItem(o, "next_hop");
    if (!item) return 0;
    // start field next_hop
    a = vl_api_address_t_fromjson(a, &l, item, &a->next_hop);
    if (!a) return 0;
    // end field next_hop

    // processing sr_mpls_steering_add_del: u32 color
    item = cJSON_GetObjectItem(o, "color");
    if (!item) return 0;
    // start field color
    vl_api_u32_fromjson(item, &a->color);
    // end field color

    // processing sr_mpls_steering_add_del: u8 co_bits
    item = cJSON_GetObjectItem(o, "co_bits");
    if (!item) return 0;
    // start field co_bits
    vl_api_u8_fromjson(item, &a->co_bits);
    // end field co_bits

    // processing sr_mpls_steering_add_del: u32 vpn_label
    item = cJSON_GetObjectItem(o, "vpn_label");
    if (!item) return 0;
    // start field vpn_label
    vl_api_u32_fromjson(item, &a->vpn_label);
    // end field vpn_label


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_steering_add_del_reply_t *vl_api_sr_mpls_steering_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_steering_add_del_reply_t);
    vl_api_sr_mpls_steering_add_del_reply_t *a = malloc(l);
    // processing sr_mpls_steering_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_assign_endpoint_color_t *vl_api_sr_mpls_policy_assign_endpoint_color_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_assign_endpoint_color_t);
    vl_api_sr_mpls_policy_assign_endpoint_color_t *a = malloc(l);
    // processing sr_mpls_policy_assign_endpoint_color: u32 bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    vl_api_u32_fromjson(item, &a->bsid);
    // end field bsid

    // processing sr_mpls_policy_assign_endpoint_color: vl_api_address_t endpoint
    item = cJSON_GetObjectItem(o, "endpoint");
    if (!item) return 0;
    // start field endpoint
    a = vl_api_address_t_fromjson(a, &l, item, &a->endpoint);
    if (!a) return 0;
    // end field endpoint

    // processing sr_mpls_policy_assign_endpoint_color: u32 color
    item = cJSON_GetObjectItem(o, "color");
    if (!item) return 0;
    // start field color
    vl_api_u32_fromjson(item, &a->color);
    // end field color


    *len = l;
    return a;
}
static inline vl_api_sr_mpls_policy_assign_endpoint_color_reply_t *vl_api_sr_mpls_policy_assign_endpoint_color_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_mpls_policy_assign_endpoint_color_reply_t);
    vl_api_sr_mpls_policy_assign_endpoint_color_reply_t *a = malloc(l);
    // processing sr_mpls_policy_assign_endpoint_color_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
