/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/srv6/sr_types.api_fromjson.h>
#ifndef included_sr_api_fromjson_h
#define included_sr_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_srv6_sid_list_t_fromjson (void *mp, int *len, cJSON *o, vl_api_srv6_sid_list_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "num_sids");
    if (!item) return 0;
    // start field num_sids
    vl_api_u8_fromjson(item, &a->num_sids);
    // end field num_sids
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight
    item = cJSON_GetObjectItem(o, "sids");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sids");
        int size = cJSON_GetArraySize(array);
        if (size != 16) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            a = vl_api_ip6_address_t_fromjson(mp, len, e, &a->sids[i]);
        }
    }
    return mp;
}
static inline void *vl_api_srv6_sid_list_with_sl_index_t_fromjson (void *mp, int *len, cJSON *o, vl_api_srv6_sid_list_with_sl_index_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "num_sids");
    if (!item) return 0;
    // start field num_sids
    vl_api_u8_fromjson(item, &a->num_sids);
    // end field num_sids
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight
    item = cJSON_GetObjectItem(o, "sl_index");
    if (!item) return 0;
    // start field sl_index
    vl_api_u32_fromjson(item, &a->sl_index);
    // end field sl_index
    item = cJSON_GetObjectItem(o, "sids");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sids");
        int size = cJSON_GetArraySize(array);
        if (size != 16) return 0;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            a = vl_api_ip6_address_t_fromjson(mp, len, e, &a->sids[i]);
        }
    }
    return mp;
}
static inline vl_api_sr_localsid_add_del_t *vl_api_sr_localsid_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_localsid_add_del_t);
    vl_api_sr_localsid_add_del_t *a = malloc(l);
    // processing sr_localsid_add_del: bool is_del
    item = cJSON_GetObjectItem(o, "is_del");
    if (!item) return 0;
    // start field is_del
    vl_api_bool_fromjson(item, &a->is_del);
    // end field is_del

    // processing sr_localsid_add_del: vl_api_ip6_address_t localsid
    item = cJSON_GetObjectItem(o, "localsid");
    if (!item) return 0;
    // start field localsid
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->localsid);
    if (!a) return 0;
    // end field localsid

    // processing sr_localsid_add_del: bool end_psp
    item = cJSON_GetObjectItem(o, "end_psp");
    if (!item) return 0;
    // start field end_psp
    vl_api_bool_fromjson(item, &a->end_psp);
    // end field end_psp

    // processing sr_localsid_add_del: vl_api_sr_behavior_t behavior
    item = cJSON_GetObjectItem(o, "behavior");
    if (!item) return 0;
    // start field behavior
    a = vl_api_sr_behavior_t_fromjson(a, &l, item, &a->behavior);
    if (!a) return 0;
    // end field behavior

    // processing sr_localsid_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sr_localsid_add_del: u32 vlan_index
    item = cJSON_GetObjectItem(o, "vlan_index");
    if (!item) return 0;
    // start field vlan_index
    vl_api_u32_fromjson(item, &a->vlan_index);
    // end field vlan_index

    // processing sr_localsid_add_del: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_localsid_add_del: vl_api_address_t nh_addr
    item = cJSON_GetObjectItem(o, "nh_addr");
    if (!item) return 0;
    // start field nh_addr
    a = vl_api_address_t_fromjson(a, &l, item, &a->nh_addr);
    if (!a) return 0;
    // end field nh_addr


    *len = l;
    return a;
}
static inline vl_api_sr_localsid_add_del_reply_t *vl_api_sr_localsid_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_localsid_add_del_reply_t);
    vl_api_sr_localsid_add_del_reply_t *a = malloc(l);
    // processing sr_localsid_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_policy_add_t *vl_api_sr_policy_add_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_add_t);
    vl_api_sr_policy_add_t *a = malloc(l);
    // processing sr_policy_add: vl_api_ip6_address_t bsid_addr
    item = cJSON_GetObjectItem(o, "bsid_addr");
    if (!item) return 0;
    // start field bsid_addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid_addr);
    if (!a) return 0;
    // end field bsid_addr

    // processing sr_policy_add: u32 weight
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight

    // processing sr_policy_add: bool is_encap
    item = cJSON_GetObjectItem(o, "is_encap");
    if (!item) return 0;
    // start field is_encap
    vl_api_bool_fromjson(item, &a->is_encap);
    // end field is_encap

    // processing sr_policy_add: bool is_spray
    item = cJSON_GetObjectItem(o, "is_spray");
    if (!item) return 0;
    // start field is_spray
    vl_api_bool_fromjson(item, &a->is_spray);
    // end field is_spray

    // processing sr_policy_add: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_policy_add: vl_api_srv6_sid_list_t sids
    item = cJSON_GetObjectItem(o, "sids");
    if (!item) return 0;
    // start field sids
    a = vl_api_srv6_sid_list_t_fromjson(a, &l, item, &a->sids);
    if (!a) return 0;
    // end field sids


    *len = l;
    return a;
}
static inline vl_api_sr_policy_add_reply_t *vl_api_sr_policy_add_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_add_reply_t);
    vl_api_sr_policy_add_reply_t *a = malloc(l);
    // processing sr_policy_add_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_policy_mod_t *vl_api_sr_policy_mod_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_mod_t);
    vl_api_sr_policy_mod_t *a = malloc(l);
    // processing sr_policy_mod: vl_api_ip6_address_t bsid_addr
    item = cJSON_GetObjectItem(o, "bsid_addr");
    if (!item) return 0;
    // start field bsid_addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid_addr);
    if (!a) return 0;
    // end field bsid_addr

    // processing sr_policy_mod: u32 sr_policy_index
    item = cJSON_GetObjectItem(o, "sr_policy_index");
    if (!item) return 0;
    // start field sr_policy_index
    vl_api_u32_fromjson(item, &a->sr_policy_index);
    // end field sr_policy_index

    // processing sr_policy_mod: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_policy_mod: vl_api_sr_policy_op_t operation
    item = cJSON_GetObjectItem(o, "operation");
    if (!item) return 0;
    // start field operation
    a = vl_api_sr_policy_op_t_fromjson(a, &l, item, &a->operation);
    if (!a) return 0;
    // end field operation

    // processing sr_policy_mod: u32 sl_index
    item = cJSON_GetObjectItem(o, "sl_index");
    if (!item) return 0;
    // start field sl_index
    vl_api_u32_fromjson(item, &a->sl_index);
    // end field sl_index

    // processing sr_policy_mod: u32 weight
    item = cJSON_GetObjectItem(o, "weight");
    if (!item) return 0;
    // start field weight
    vl_api_u32_fromjson(item, &a->weight);
    // end field weight

    // processing sr_policy_mod: vl_api_srv6_sid_list_t sids
    item = cJSON_GetObjectItem(o, "sids");
    if (!item) return 0;
    // start field sids
    a = vl_api_srv6_sid_list_t_fromjson(a, &l, item, &a->sids);
    if (!a) return 0;
    // end field sids


    *len = l;
    return a;
}
static inline vl_api_sr_policy_mod_reply_t *vl_api_sr_policy_mod_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_mod_reply_t);
    vl_api_sr_policy_mod_reply_t *a = malloc(l);
    // processing sr_policy_mod_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_policy_del_t *vl_api_sr_policy_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_del_t);
    vl_api_sr_policy_del_t *a = malloc(l);
    // processing sr_policy_del: vl_api_ip6_address_t bsid_addr
    item = cJSON_GetObjectItem(o, "bsid_addr");
    if (!item) return 0;
    // start field bsid_addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid_addr);
    if (!a) return 0;
    // end field bsid_addr

    // processing sr_policy_del: u32 sr_policy_index
    item = cJSON_GetObjectItem(o, "sr_policy_index");
    if (!item) return 0;
    // start field sr_policy_index
    vl_api_u32_fromjson(item, &a->sr_policy_index);
    // end field sr_policy_index


    *len = l;
    return a;
}
static inline vl_api_sr_policy_del_reply_t *vl_api_sr_policy_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policy_del_reply_t);
    vl_api_sr_policy_del_reply_t *a = malloc(l);
    // processing sr_policy_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_set_encap_source_t *vl_api_sr_set_encap_source_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_set_encap_source_t);
    vl_api_sr_set_encap_source_t *a = malloc(l);
    // processing sr_set_encap_source: vl_api_ip6_address_t encaps_source
    item = cJSON_GetObjectItem(o, "encaps_source");
    if (!item) return 0;
    // start field encaps_source
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->encaps_source);
    if (!a) return 0;
    // end field encaps_source


    *len = l;
    return a;
}
static inline vl_api_sr_set_encap_source_reply_t *vl_api_sr_set_encap_source_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_set_encap_source_reply_t);
    vl_api_sr_set_encap_source_reply_t *a = malloc(l);
    // processing sr_set_encap_source_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_set_encap_hop_limit_t *vl_api_sr_set_encap_hop_limit_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_set_encap_hop_limit_t);
    vl_api_sr_set_encap_hop_limit_t *a = malloc(l);
    // processing sr_set_encap_hop_limit: u8 hop_limit
    item = cJSON_GetObjectItem(o, "hop_limit");
    if (!item) return 0;
    // start field hop_limit
    vl_api_u8_fromjson(item, &a->hop_limit);
    // end field hop_limit


    *len = l;
    return a;
}
static inline vl_api_sr_set_encap_hop_limit_reply_t *vl_api_sr_set_encap_hop_limit_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_set_encap_hop_limit_reply_t);
    vl_api_sr_set_encap_hop_limit_reply_t *a = malloc(l);
    // processing sr_set_encap_hop_limit_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_steering_add_del_t *vl_api_sr_steering_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_steering_add_del_t);
    vl_api_sr_steering_add_del_t *a = malloc(l);
    // processing sr_steering_add_del: bool is_del
    item = cJSON_GetObjectItem(o, "is_del");
    if (!item) return 0;
    // start field is_del
    vl_api_bool_fromjson(item, &a->is_del);
    // end field is_del

    // processing sr_steering_add_del: vl_api_ip6_address_t bsid_addr
    item = cJSON_GetObjectItem(o, "bsid_addr");
    if (!item) return 0;
    // start field bsid_addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid_addr);
    if (!a) return 0;
    // end field bsid_addr

    // processing sr_steering_add_del: u32 sr_policy_index
    item = cJSON_GetObjectItem(o, "sr_policy_index");
    if (!item) return 0;
    // start field sr_policy_index
    vl_api_u32_fromjson(item, &a->sr_policy_index);
    // end field sr_policy_index

    // processing sr_steering_add_del: u32 table_id
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id

    // processing sr_steering_add_del: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing sr_steering_add_del: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sr_steering_add_del: vl_api_sr_steer_t traffic_type
    item = cJSON_GetObjectItem(o, "traffic_type");
    if (!item) return 0;
    // start field traffic_type
    a = vl_api_sr_steer_t_fromjson(a, &l, item, &a->traffic_type);
    if (!a) return 0;
    // end field traffic_type


    *len = l;
    return a;
}
static inline vl_api_sr_steering_add_del_reply_t *vl_api_sr_steering_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_steering_add_del_reply_t);
    vl_api_sr_steering_add_del_reply_t *a = malloc(l);
    // processing sr_steering_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sr_localsids_dump_t *vl_api_sr_localsids_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_localsids_dump_t);
    vl_api_sr_localsids_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sr_localsids_details_t *vl_api_sr_localsids_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_localsids_details_t);
    vl_api_sr_localsids_details_t *a = malloc(l);
    // processing sr_localsids_details: vl_api_ip6_address_t addr
    item = cJSON_GetObjectItem(o, "addr");
    if (!item) return 0;
    // start field addr
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->addr);
    if (!a) return 0;
    // end field addr

    // processing sr_localsids_details: bool end_psp
    item = cJSON_GetObjectItem(o, "end_psp");
    if (!item) return 0;
    // start field end_psp
    vl_api_bool_fromjson(item, &a->end_psp);
    // end field end_psp

    // processing sr_localsids_details: vl_api_sr_behavior_t behavior
    item = cJSON_GetObjectItem(o, "behavior");
    if (!item) return 0;
    // start field behavior
    a = vl_api_sr_behavior_t_fromjson(a, &l, item, &a->behavior);
    if (!a) return 0;
    // end field behavior

    // processing sr_localsids_details: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_localsids_details: u32 vlan_index
    item = cJSON_GetObjectItem(o, "vlan_index");
    if (!item) return 0;
    // start field vlan_index
    vl_api_u32_fromjson(item, &a->vlan_index);
    // end field vlan_index

    // processing sr_localsids_details: vl_api_address_t xconnect_nh_addr
    item = cJSON_GetObjectItem(o, "xconnect_nh_addr");
    if (!item) return 0;
    // start field xconnect_nh_addr
    a = vl_api_address_t_fromjson(a, &l, item, &a->xconnect_nh_addr);
    if (!a) return 0;
    // end field xconnect_nh_addr

    // processing sr_localsids_details: u32 xconnect_iface_or_vrf_table
    item = cJSON_GetObjectItem(o, "xconnect_iface_or_vrf_table");
    if (!item) return 0;
    // start field xconnect_iface_or_vrf_table
    vl_api_u32_fromjson(item, &a->xconnect_iface_or_vrf_table);
    // end field xconnect_iface_or_vrf_table


    *len = l;
    return a;
}
static inline vl_api_sr_policies_dump_t *vl_api_sr_policies_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policies_dump_t);
    vl_api_sr_policies_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sr_policies_details_t *vl_api_sr_policies_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policies_details_t);
    vl_api_sr_policies_details_t *a = malloc(l);
    // processing sr_policies_details: vl_api_ip6_address_t bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid);
    if (!a) return 0;
    // end field bsid

    // processing sr_policies_details: bool is_spray
    item = cJSON_GetObjectItem(o, "is_spray");
    if (!item) return 0;
    // start field is_spray
    vl_api_bool_fromjson(item, &a->is_spray);
    // end field is_spray

    // processing sr_policies_details: bool is_encap
    item = cJSON_GetObjectItem(o, "is_encap");
    if (!item) return 0;
    // start field is_encap
    vl_api_bool_fromjson(item, &a->is_encap);
    // end field is_encap

    // processing sr_policies_details: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_policies_details: vl_api_srv6_sid_list_t sid_lists
    item = cJSON_GetObjectItem(o, "sid_lists");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sid_lists");
        int size = cJSON_GetArraySize(array);
        a->num_sid_lists = size;
        a = realloc(a, l + sizeof(vl_api_srv6_sid_list_t) * size);
        vl_api_srv6_sid_list_t *d = (void *)a + l;
        l += sizeof(vl_api_srv6_sid_list_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_srv6_sid_list_t_fromjson(a, len, e, &d[i]); 
        }
    }


    *len = l;
    return a;
}
static inline vl_api_sr_policies_with_sl_index_dump_t *vl_api_sr_policies_with_sl_index_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policies_with_sl_index_dump_t);
    vl_api_sr_policies_with_sl_index_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sr_policies_with_sl_index_details_t *vl_api_sr_policies_with_sl_index_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_policies_with_sl_index_details_t);
    vl_api_sr_policies_with_sl_index_details_t *a = malloc(l);
    // processing sr_policies_with_sl_index_details: vl_api_ip6_address_t bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid);
    if (!a) return 0;
    // end field bsid

    // processing sr_policies_with_sl_index_details: bool is_spray
    item = cJSON_GetObjectItem(o, "is_spray");
    if (!item) return 0;
    // start field is_spray
    vl_api_bool_fromjson(item, &a->is_spray);
    // end field is_spray

    // processing sr_policies_with_sl_index_details: bool is_encap
    item = cJSON_GetObjectItem(o, "is_encap");
    if (!item) return 0;
    // start field is_encap
    vl_api_bool_fromjson(item, &a->is_encap);
    // end field is_encap

    // processing sr_policies_with_sl_index_details: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_policies_with_sl_index_details: vl_api_srv6_sid_list_with_sl_index_t sid_lists
    item = cJSON_GetObjectItem(o, "sid_lists");
    if (!item) return 0;
    {
        int i;
        cJSON *array = cJSON_GetObjectItem(o, "sid_lists");
        int size = cJSON_GetArraySize(array);
        a->num_sid_lists = size;
        a = realloc(a, l + sizeof(vl_api_srv6_sid_list_with_sl_index_t) * size);
        vl_api_srv6_sid_list_with_sl_index_t *d = (void *)a + l;
        l += sizeof(vl_api_srv6_sid_list_with_sl_index_t) * size;
        for (i = 0; i < size; i++) {
            cJSON *e = cJSON_GetArrayItem(array, i);
            vl_api_srv6_sid_list_with_sl_index_t_fromjson(a, len, e, &d[i]); 
        }
    }


    *len = l;
    return a;
}
static inline vl_api_sr_steering_pol_dump_t *vl_api_sr_steering_pol_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_steering_pol_dump_t);
    vl_api_sr_steering_pol_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_sr_steering_pol_details_t *vl_api_sr_steering_pol_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sr_steering_pol_details_t);
    vl_api_sr_steering_pol_details_t *a = malloc(l);
    // processing sr_steering_pol_details: vl_api_sr_steer_t traffic_type
    item = cJSON_GetObjectItem(o, "traffic_type");
    if (!item) return 0;
    // start field traffic_type
    a = vl_api_sr_steer_t_fromjson(a, &l, item, &a->traffic_type);
    if (!a) return 0;
    // end field traffic_type

    // processing sr_steering_pol_details: u32 fib_table
    item = cJSON_GetObjectItem(o, "fib_table");
    if (!item) return 0;
    // start field fib_table
    vl_api_u32_fromjson(item, &a->fib_table);
    // end field fib_table

    // processing sr_steering_pol_details: vl_api_prefix_t prefix
    item = cJSON_GetObjectItem(o, "prefix");
    if (!item) return 0;
    // start field prefix
    a = vl_api_prefix_t_fromjson(a, &l, item, &a->prefix);
    if (!a) return 0;
    // end field prefix

    // processing sr_steering_pol_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sr_steering_pol_details: vl_api_ip6_address_t bsid
    item = cJSON_GetObjectItem(o, "bsid");
    if (!item) return 0;
    // start field bsid
    a = vl_api_ip6_address_t_fromjson(a, &l, item, &a->bsid);
    if (!a) return 0;
    // end field bsid


    *len = l;
    return a;
}
#endif
