/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_syslog_api_fromjson_h
#define included_syslog_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_syslog_severity_t_fromjson (void *mp, int *len, cJSON *o, vl_api_syslog_severity_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SYSLOG_API_SEVERITY_EMERG") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_ALERT") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_CRIT") == 0) {*a = 2; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_ERR") == 0) {*a = 3; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_WARN") == 0) {*a = 4; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_NOTICE") == 0) {*a = 5; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_INFO") == 0) {*a = 6; return mp;}
    if (strcmp(p, "SYSLOG_API_SEVERITY_DBG") == 0) {*a = 7; return mp;}
   return 0;
}
static inline vl_api_syslog_set_sender_t *vl_api_syslog_set_sender_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_set_sender_t);
    vl_api_syslog_set_sender_t *a = malloc(l);
    // processing syslog_set_sender: vl_api_ip4_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_ip4_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing syslog_set_sender: vl_api_ip4_address_t collector_address
    item = cJSON_GetObjectItem(o, "collector_address");
    if (!item) return 0;
    // start field collector_address
    a = vl_api_ip4_address_t_fromjson(a, &l, item, &a->collector_address);
    if (!a) return 0;
    // end field collector_address

    // processing syslog_set_sender: u16 collector_port
    item = cJSON_GetObjectItem(o, "collector_port");
    if (!item) return 0;
    // start field collector_port
    vl_api_u16_fromjson(item, &a->collector_port);
    // end field collector_port

    // processing syslog_set_sender: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing syslog_set_sender: u32 max_msg_size
    item = cJSON_GetObjectItem(o, "max_msg_size");
    if (!item) return 0;
    // start field max_msg_size
    vl_api_u32_fromjson(item, &a->max_msg_size);
    // end field max_msg_size


    *len = l;
    return a;
}
static inline vl_api_syslog_set_sender_reply_t *vl_api_syslog_set_sender_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_set_sender_reply_t);
    vl_api_syslog_set_sender_reply_t *a = malloc(l);
    // processing syslog_set_sender_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_syslog_get_sender_t *vl_api_syslog_get_sender_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_get_sender_t);
    vl_api_syslog_get_sender_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_syslog_get_sender_reply_t *vl_api_syslog_get_sender_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_get_sender_reply_t);
    vl_api_syslog_get_sender_reply_t *a = malloc(l);
    // processing syslog_get_sender_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing syslog_get_sender_reply: vl_api_ip4_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_ip4_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing syslog_get_sender_reply: vl_api_ip4_address_t collector_address
    item = cJSON_GetObjectItem(o, "collector_address");
    if (!item) return 0;
    // start field collector_address
    a = vl_api_ip4_address_t_fromjson(a, &l, item, &a->collector_address);
    if (!a) return 0;
    // end field collector_address

    // processing syslog_get_sender_reply: u16 collector_port
    item = cJSON_GetObjectItem(o, "collector_port");
    if (!item) return 0;
    // start field collector_port
    vl_api_u16_fromjson(item, &a->collector_port);
    // end field collector_port

    // processing syslog_get_sender_reply: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing syslog_get_sender_reply: u32 max_msg_size
    item = cJSON_GetObjectItem(o, "max_msg_size");
    if (!item) return 0;
    // start field max_msg_size
    vl_api_u32_fromjson(item, &a->max_msg_size);
    // end field max_msg_size


    *len = l;
    return a;
}
static inline vl_api_syslog_set_filter_t *vl_api_syslog_set_filter_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_set_filter_t);
    vl_api_syslog_set_filter_t *a = malloc(l);
    // processing syslog_set_filter: vl_api_syslog_severity_t severity
    item = cJSON_GetObjectItem(o, "severity");
    if (!item) return 0;
    // start field severity
    a = vl_api_syslog_severity_t_fromjson(a, &l, item, &a->severity);
    if (!a) return 0;
    // end field severity


    *len = l;
    return a;
}
static inline vl_api_syslog_set_filter_reply_t *vl_api_syslog_set_filter_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_set_filter_reply_t);
    vl_api_syslog_set_filter_reply_t *a = malloc(l);
    // processing syslog_set_filter_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_syslog_get_filter_t *vl_api_syslog_get_filter_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_get_filter_t);
    vl_api_syslog_get_filter_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_syslog_get_filter_reply_t *vl_api_syslog_get_filter_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_syslog_get_filter_reply_t);
    vl_api_syslog_get_filter_reply_t *a = malloc(l);
    // processing syslog_get_filter_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing syslog_get_filter_reply: vl_api_syslog_severity_t severity
    item = cJSON_GetObjectItem(o, "severity");
    if (!item) return 0;
    // start field severity
    a = vl_api_syslog_severity_t_fromjson(a, &l, item, &a->severity);
    if (!a) return 0;
    // end field severity


    *len = l;
    return a;
}
#endif
