/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_tcp_api_fromjson_h
#define included_tcp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_tcp_configure_src_addresses_t *vl_api_tcp_configure_src_addresses_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_tcp_configure_src_addresses_t);
    vl_api_tcp_configure_src_addresses_t *a = malloc(l);
    // processing tcp_configure_src_addresses: u32 vrf_id
    item = cJSON_GetObjectItem(o, "vrf_id");
    if (!item) return 0;
    // start field vrf_id
    vl_api_u32_fromjson(item, &a->vrf_id);
    // end field vrf_id

    // processing tcp_configure_src_addresses: vl_api_address_t first_address
    item = cJSON_GetObjectItem(o, "first_address");
    if (!item) return 0;
    // start field first_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->first_address);
    if (!a) return 0;
    // end field first_address

    // processing tcp_configure_src_addresses: vl_api_address_t last_address
    item = cJSON_GetObjectItem(o, "last_address");
    if (!item) return 0;
    // start field last_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->last_address);
    if (!a) return 0;
    // end field last_address


    *len = l;
    return a;
}
static inline vl_api_tcp_configure_src_addresses_reply_t *vl_api_tcp_configure_src_addresses_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_tcp_configure_src_addresses_reply_t);
    vl_api_tcp_configure_src_addresses_reply_t *a = malloc(l);
    // processing tcp_configure_src_addresses_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
