/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_teib_api_fromjson_h
#define included_teib_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_teib_entry_t_fromjson (void *mp, int *len, cJSON *o, vl_api_teib_entry_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    mp = vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index);
    if (!mp) return 0;
    // end field sw_if_index
    item = cJSON_GetObjectItem(o, "peer");
    if (!item) return 0;
    // start field peer
    mp = vl_api_address_t_fromjson(mp, len, item, &a->peer);
    if (!mp) return 0;
    // end field peer
    item = cJSON_GetObjectItem(o, "nh");
    if (!item) return 0;
    // start field nh
    mp = vl_api_address_t_fromjson(mp, len, item, &a->nh);
    if (!mp) return 0;
    // end field nh
    item = cJSON_GetObjectItem(o, "nh_table_id");
    if (!item) return 0;
    // start field nh_table_id
    vl_api_u32_fromjson(item, &a->nh_table_id);
    // end field nh_table_id
    return mp;
}
static inline vl_api_teib_entry_add_del_t *vl_api_teib_entry_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_teib_entry_add_del_t);
    vl_api_teib_entry_add_del_t *a = malloc(l);
    // processing teib_entry_add_del: u8 is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_u8_fromjson(item, &a->is_add);
    // end field is_add

    // processing teib_entry_add_del: vl_api_teib_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_teib_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
static inline vl_api_teib_entry_add_del_reply_t *vl_api_teib_entry_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_teib_entry_add_del_reply_t);
    vl_api_teib_entry_add_del_reply_t *a = malloc(l);
    // processing teib_entry_add_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_teib_dump_t *vl_api_teib_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_teib_dump_t);
    vl_api_teib_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_teib_details_t *vl_api_teib_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_teib_details_t);
    vl_api_teib_details_t *a = malloc(l);
    // processing teib_details: vl_api_teib_entry_t entry
    item = cJSON_GetObjectItem(o, "entry");
    if (!item) return 0;
    // start field entry
    a = vl_api_teib_entry_t_fromjson(a, &l, item, &a->entry);
    if (!a) return 0;
    // end field entry


    *len = l;
    return a;
}
#endif
