/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_udp_api_fromjson_h
#define included_udp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_udp_encap_t_fromjson (void *mp, int *len, cJSON *o, vl_api_udp_encap_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "table_id");
    if (!item) return 0;
    // start field table_id
    vl_api_u32_fromjson(item, &a->table_id);
    // end field table_id
    item = cJSON_GetObjectItem(o, "src_port");
    if (!item) return 0;
    // start field src_port
    vl_api_u16_fromjson(item, &a->src_port);
    // end field src_port
    item = cJSON_GetObjectItem(o, "dst_port");
    if (!item) return 0;
    // start field dst_port
    vl_api_u16_fromjson(item, &a->dst_port);
    // end field dst_port
    item = cJSON_GetObjectItem(o, "src_ip");
    if (!item) return 0;
    // start field src_ip
    mp = vl_api_address_t_fromjson(mp, len, item, &a->src_ip);
    if (!mp) return 0;
    // end field src_ip
    item = cJSON_GetObjectItem(o, "dst_ip");
    if (!item) return 0;
    // start field dst_ip
    mp = vl_api_address_t_fromjson(mp, len, item, &a->dst_ip);
    if (!mp) return 0;
    // end field dst_ip
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id
    return mp;
}
static inline vl_api_udp_encap_add_t *vl_api_udp_encap_add_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_add_t);
    vl_api_udp_encap_add_t *a = malloc(l);
    // processing udp_encap_add: vl_api_udp_encap_t udp_encap
    item = cJSON_GetObjectItem(o, "udp_encap");
    if (!item) return 0;
    // start field udp_encap
    a = vl_api_udp_encap_t_fromjson(a, &l, item, &a->udp_encap);
    if (!a) return 0;
    // end field udp_encap


    *len = l;
    return a;
}
static inline vl_api_udp_encap_add_reply_t *vl_api_udp_encap_add_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_add_reply_t);
    vl_api_udp_encap_add_reply_t *a = malloc(l);
    // processing udp_encap_add_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing udp_encap_add_reply: u32 id
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id


    *len = l;
    return a;
}
static inline vl_api_udp_encap_del_t *vl_api_udp_encap_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_del_t);
    vl_api_udp_encap_del_t *a = malloc(l);
    // processing udp_encap_del: u32 id
    item = cJSON_GetObjectItem(o, "id");
    if (!item) return 0;
    // start field id
    vl_api_u32_fromjson(item, &a->id);
    // end field id


    *len = l;
    return a;
}
static inline vl_api_udp_encap_del_reply_t *vl_api_udp_encap_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_del_reply_t);
    vl_api_udp_encap_del_reply_t *a = malloc(l);
    // processing udp_encap_del_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_udp_encap_dump_t *vl_api_udp_encap_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_dump_t);
    vl_api_udp_encap_dump_t *a = malloc(l);

    *len = l;
    return a;
}
static inline vl_api_udp_encap_details_t *vl_api_udp_encap_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_udp_encap_details_t);
    vl_api_udp_encap_details_t *a = malloc(l);
    // processing udp_encap_details: vl_api_udp_encap_t udp_encap
    item = cJSON_GetObjectItem(o, "udp_encap");
    if (!item) return 0;
    // start field udp_encap
    a = vl_api_udp_encap_t_fromjson(a, &l, item, &a->udp_encap);
    if (!a) return 0;
    // end field udp_encap


    *len = l;
    return a;
}
#endif
