/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_vxlan_gpe_api_fromjson_h
#define included_vxlan_gpe_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_vxlan_gpe_add_del_tunnel_t *vl_api_vxlan_gpe_add_del_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gpe_add_del_tunnel_t);
    vl_api_vxlan_gpe_add_del_tunnel_t *a = malloc(l);
    // processing vxlan_gpe_add_del_tunnel: vl_api_address_t local
    item = cJSON_GetObjectItem(o, "local");
    if (!item) return 0;
    // start field local
    a = vl_api_address_t_fromjson(a, &l, item, &a->local);
    if (!a) return 0;
    // end field local

    // processing vxlan_gpe_add_del_tunnel: vl_api_address_t remote
    item = cJSON_GetObjectItem(o, "remote");
    if (!item) return 0;
    // start field remote
    a = vl_api_address_t_fromjson(a, &l, item, &a->remote);
    if (!a) return 0;
    // end field remote

    // processing vxlan_gpe_add_del_tunnel: vl_api_interface_index_t mcast_sw_if_index
    item = cJSON_GetObjectItem(o, "mcast_sw_if_index");
    if (!item) return 0;
    // start field mcast_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->mcast_sw_if_index);
    if (!a) return 0;
    // end field mcast_sw_if_index

    // processing vxlan_gpe_add_del_tunnel: u32 encap_vrf_id
    item = cJSON_GetObjectItem(o, "encap_vrf_id");
    if (!item) return 0;
    // start field encap_vrf_id
    vl_api_u32_fromjson(item, &a->encap_vrf_id);
    // end field encap_vrf_id

    // processing vxlan_gpe_add_del_tunnel: u32 decap_vrf_id
    item = cJSON_GetObjectItem(o, "decap_vrf_id");
    if (!item) return 0;
    // start field decap_vrf_id
    vl_api_u32_fromjson(item, &a->decap_vrf_id);
    // end field decap_vrf_id

    // processing vxlan_gpe_add_del_tunnel: vl_api_ip_proto_t protocol
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    a = vl_api_ip_proto_t_fromjson(a, &l, item, &a->protocol);
    if (!a) return 0;
    // end field protocol

    // processing vxlan_gpe_add_del_tunnel: u32 vni
    item = cJSON_GetObjectItem(o, "vni");
    if (!item) return 0;
    // start field vni
    vl_api_u32_fromjson(item, &a->vni);
    // end field vni

    // processing vxlan_gpe_add_del_tunnel: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add


    *len = l;
    return a;
}
static inline vl_api_vxlan_gpe_add_del_tunnel_reply_t *vl_api_vxlan_gpe_add_del_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gpe_add_del_tunnel_reply_t);
    vl_api_vxlan_gpe_add_del_tunnel_reply_t *a = malloc(l);
    // processing vxlan_gpe_add_del_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing vxlan_gpe_add_del_tunnel_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_vxlan_gpe_tunnel_dump_t *vl_api_vxlan_gpe_tunnel_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gpe_tunnel_dump_t);
    vl_api_vxlan_gpe_tunnel_dump_t *a = malloc(l);
    // processing vxlan_gpe_tunnel_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_vxlan_gpe_tunnel_details_t *vl_api_vxlan_gpe_tunnel_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gpe_tunnel_details_t);
    vl_api_vxlan_gpe_tunnel_details_t *a = malloc(l);
    // processing vxlan_gpe_tunnel_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing vxlan_gpe_tunnel_details: vl_api_address_t local
    item = cJSON_GetObjectItem(o, "local");
    if (!item) return 0;
    // start field local
    a = vl_api_address_t_fromjson(a, &l, item, &a->local);
    if (!a) return 0;
    // end field local

    // processing vxlan_gpe_tunnel_details: vl_api_address_t remote
    item = cJSON_GetObjectItem(o, "remote");
    if (!item) return 0;
    // start field remote
    a = vl_api_address_t_fromjson(a, &l, item, &a->remote);
    if (!a) return 0;
    // end field remote

    // processing vxlan_gpe_tunnel_details: u32 vni
    item = cJSON_GetObjectItem(o, "vni");
    if (!item) return 0;
    // start field vni
    vl_api_u32_fromjson(item, &a->vni);
    // end field vni

    // processing vxlan_gpe_tunnel_details: vl_api_ip_proto_t protocol
    item = cJSON_GetObjectItem(o, "protocol");
    if (!item) return 0;
    // start field protocol
    a = vl_api_ip_proto_t_fromjson(a, &l, item, &a->protocol);
    if (!a) return 0;
    // end field protocol

    // processing vxlan_gpe_tunnel_details: vl_api_interface_index_t mcast_sw_if_index
    item = cJSON_GetObjectItem(o, "mcast_sw_if_index");
    if (!item) return 0;
    // start field mcast_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->mcast_sw_if_index);
    if (!a) return 0;
    // end field mcast_sw_if_index

    // processing vxlan_gpe_tunnel_details: u32 encap_vrf_id
    item = cJSON_GetObjectItem(o, "encap_vrf_id");
    if (!item) return 0;
    // start field encap_vrf_id
    vl_api_u32_fromjson(item, &a->encap_vrf_id);
    // end field encap_vrf_id

    // processing vxlan_gpe_tunnel_details: u32 decap_vrf_id
    item = cJSON_GetObjectItem(o, "decap_vrf_id");
    if (!item) return 0;
    // start field decap_vrf_id
    vl_api_u32_fromjson(item, &a->decap_vrf_id);
    // end field decap_vrf_id

    // processing vxlan_gpe_tunnel_details: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vxlan_gpe_bypass_t *vl_api_sw_interface_set_vxlan_gpe_bypass_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_gpe_bypass_t);
    vl_api_sw_interface_set_vxlan_gpe_bypass_t *a = malloc(l);
    // processing sw_interface_set_vxlan_gpe_bypass: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_vxlan_gpe_bypass: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6

    // processing sw_interface_set_vxlan_gpe_bypass: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vxlan_gpe_bypass_reply_t *vl_api_sw_interface_set_vxlan_gpe_bypass_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_gpe_bypass_reply_t);
    vl_api_sw_interface_set_vxlan_gpe_bypass_reply_t *a = malloc(l);
    // processing sw_interface_set_vxlan_gpe_bypass_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
