/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#include <vnet/ip/ip_types.api_fromjson.h>
#ifndef included_vxlan_api_fromjson_h
#define included_vxlan_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_vxlan_add_del_tunnel_t *vl_api_vxlan_add_del_tunnel_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_add_del_tunnel_t);
    vl_api_vxlan_add_del_tunnel_t *a = malloc(l);
    // processing vxlan_add_del_tunnel: bool is_add
    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) return 0;
    // start field is_add
    vl_api_bool_fromjson(item, &a->is_add);
    // end field is_add

    // processing vxlan_add_del_tunnel: u32 instance
    item = cJSON_GetObjectItem(o, "instance");
    if (!item) return 0;
    // start field instance
    vl_api_u32_fromjson(item, &a->instance);
    // end field instance

    // processing vxlan_add_del_tunnel: vl_api_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing vxlan_add_del_tunnel: vl_api_address_t dst_address
    item = cJSON_GetObjectItem(o, "dst_address");
    if (!item) return 0;
    // start field dst_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->dst_address);
    if (!a) return 0;
    // end field dst_address

    // processing vxlan_add_del_tunnel: vl_api_interface_index_t mcast_sw_if_index
    item = cJSON_GetObjectItem(o, "mcast_sw_if_index");
    if (!item) return 0;
    // start field mcast_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->mcast_sw_if_index);
    if (!a) return 0;
    // end field mcast_sw_if_index

    // processing vxlan_add_del_tunnel: u32 encap_vrf_id
    item = cJSON_GetObjectItem(o, "encap_vrf_id");
    if (!item) return 0;
    // start field encap_vrf_id
    vl_api_u32_fromjson(item, &a->encap_vrf_id);
    // end field encap_vrf_id

    // processing vxlan_add_del_tunnel: u32 decap_next_index
    item = cJSON_GetObjectItem(o, "decap_next_index");
    if (!item) return 0;
    // start field decap_next_index
    vl_api_u32_fromjson(item, &a->decap_next_index);
    // end field decap_next_index

    // processing vxlan_add_del_tunnel: u32 vni
    item = cJSON_GetObjectItem(o, "vni");
    if (!item) return 0;
    // start field vni
    vl_api_u32_fromjson(item, &a->vni);
    // end field vni


    *len = l;
    return a;
}
static inline vl_api_vxlan_add_del_tunnel_reply_t *vl_api_vxlan_add_del_tunnel_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_add_del_tunnel_reply_t);
    vl_api_vxlan_add_del_tunnel_reply_t *a = malloc(l);
    // processing vxlan_add_del_tunnel_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval

    // processing vxlan_add_del_tunnel_reply: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_vxlan_tunnel_dump_t *vl_api_vxlan_tunnel_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_tunnel_dump_t);
    vl_api_vxlan_tunnel_dump_t *a = malloc(l);
    // processing vxlan_tunnel_dump: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index


    *len = l;
    return a;
}
static inline vl_api_vxlan_tunnel_details_t *vl_api_vxlan_tunnel_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_tunnel_details_t);
    vl_api_vxlan_tunnel_details_t *a = malloc(l);
    // processing vxlan_tunnel_details: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing vxlan_tunnel_details: u32 instance
    item = cJSON_GetObjectItem(o, "instance");
    if (!item) return 0;
    // start field instance
    vl_api_u32_fromjson(item, &a->instance);
    // end field instance

    // processing vxlan_tunnel_details: vl_api_address_t src_address
    item = cJSON_GetObjectItem(o, "src_address");
    if (!item) return 0;
    // start field src_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->src_address);
    if (!a) return 0;
    // end field src_address

    // processing vxlan_tunnel_details: vl_api_address_t dst_address
    item = cJSON_GetObjectItem(o, "dst_address");
    if (!item) return 0;
    // start field dst_address
    a = vl_api_address_t_fromjson(a, &l, item, &a->dst_address);
    if (!a) return 0;
    // end field dst_address

    // processing vxlan_tunnel_details: vl_api_interface_index_t mcast_sw_if_index
    item = cJSON_GetObjectItem(o, "mcast_sw_if_index");
    if (!item) return 0;
    // start field mcast_sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->mcast_sw_if_index);
    if (!a) return 0;
    // end field mcast_sw_if_index

    // processing vxlan_tunnel_details: u32 encap_vrf_id
    item = cJSON_GetObjectItem(o, "encap_vrf_id");
    if (!item) return 0;
    // start field encap_vrf_id
    vl_api_u32_fromjson(item, &a->encap_vrf_id);
    // end field encap_vrf_id

    // processing vxlan_tunnel_details: u32 decap_next_index
    item = cJSON_GetObjectItem(o, "decap_next_index");
    if (!item) return 0;
    // start field decap_next_index
    vl_api_u32_fromjson(item, &a->decap_next_index);
    // end field decap_next_index

    // processing vxlan_tunnel_details: u32 vni
    item = cJSON_GetObjectItem(o, "vni");
    if (!item) return 0;
    // start field vni
    vl_api_u32_fromjson(item, &a->vni);
    // end field vni


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vxlan_bypass_t *vl_api_sw_interface_set_vxlan_bypass_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_bypass_t);
    vl_api_sw_interface_set_vxlan_bypass_t *a = malloc(l);
    // processing sw_interface_set_vxlan_bypass: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing sw_interface_set_vxlan_bypass: bool is_ipv6
    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) return 0;
    // start field is_ipv6
    vl_api_bool_fromjson(item, &a->is_ipv6);
    // end field is_ipv6

    // processing sw_interface_set_vxlan_bypass: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_sw_interface_set_vxlan_bypass_reply_t *vl_api_sw_interface_set_vxlan_bypass_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_bypass_reply_t);
    vl_api_sw_interface_set_vxlan_bypass_reply_t *a = malloc(l);
    // processing sw_interface_set_vxlan_bypass_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_vxlan_offload_rx_t *vl_api_vxlan_offload_rx_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_offload_rx_t);
    vl_api_vxlan_offload_rx_t *a = malloc(l);
    // processing vxlan_offload_rx: vl_api_interface_index_t hw_if_index
    item = cJSON_GetObjectItem(o, "hw_if_index");
    if (!item) return 0;
    // start field hw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->hw_if_index);
    if (!a) return 0;
    // end field hw_if_index

    // processing vxlan_offload_rx: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing vxlan_offload_rx: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable


    *len = l;
    return a;
}
static inline vl_api_vxlan_offload_rx_reply_t *vl_api_vxlan_offload_rx_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_offload_rx_reply_t);
    vl_api_vxlan_offload_rx_reply_t *a = malloc(l);
    // processing vxlan_offload_rx_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
