#ifndef included_cnat_api_types_h
#define included_cnat_api_types_h
#define VL_API_CNAT_API_VERSION_MAJOR 0
#define VL_API_CNAT_API_VERSION_MINOR 1
#define VL_API_CNAT_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/ip/ip_types.api_types.h>
#include <vnet/fib/fib_types.api_types.h>
#include <vnet/interface_types.api_types.h>
typedef enum __attribute__((packed)) {
    CNAT_TRANSLATION_ALLOC_PORT = 1,
} vl_api_cnat_translation_flags_t;
STATIC_ASSERT(sizeof(vl_api_cnat_translation_flags_t) == sizeof(u8), "size of API enum cnat_translation_flags is wrong");
typedef struct __attribute__ ((packed)) _vl_api_cnat_endpoint {
    vl_api_address_t addr;
    vl_api_interface_index_t sw_if_index;
    vl_api_address_family_t if_af;
    u16 port;
} vl_api_cnat_endpoint_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_endpoint_tuple {
    vl_api_cnat_endpoint_t dst_ep;
    vl_api_cnat_endpoint_t src_ep;
} vl_api_cnat_endpoint_tuple_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation {
    vl_api_cnat_endpoint_t vip;
    u32 id;
    vl_api_ip_proto_t ip_proto;
    u8 is_real_ip;
    u8 flags;
    u32 n_paths;
    vl_api_cnat_endpoint_tuple_t paths[0];
} vl_api_cnat_translation_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_session {
    vl_api_cnat_endpoint_t src;
    vl_api_cnat_endpoint_t dst;
    vl_api_cnat_endpoint_t new;
    vl_api_ip_proto_t ip_proto;
    f64 timestamp;
} vl_api_cnat_session_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_update {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_cnat_translation_t translation;
} vl_api_cnat_translation_update_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_update_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 id;
} vl_api_cnat_translation_update_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_del {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 id;
} vl_api_cnat_translation_del_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_del_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_cnat_translation_del_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_cnat_translation_t translation;
} vl_api_cnat_translation_details_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_translation_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_cnat_translation_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_session_purge {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_cnat_session_purge_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_session_purge_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_cnat_session_purge_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_session_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_cnat_session_t session;
} vl_api_cnat_session_details_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_session_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_cnat_session_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_set_snat_addresses {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t snat_ip4;
    vl_api_ip6_address_t snat_ip6;
    vl_api_interface_index_t sw_if_index;
} vl_api_cnat_set_snat_addresses_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_set_snat_addresses_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_cnat_set_snat_addresses_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_get_snat_addresses {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_cnat_get_snat_addresses_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_get_snat_addresses_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 id;
    vl_api_ip4_address_t snat_ip4;
    vl_api_ip6_address_t snat_ip6;
    vl_api_interface_index_t sw_if_index;
} vl_api_cnat_get_snat_addresses_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_add_del_snat_prefix {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    vl_api_prefix_t prefix;
} vl_api_cnat_add_del_snat_prefix_t;
typedef struct __attribute__ ((packed)) _vl_api_cnat_add_del_snat_prefix_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_cnat_add_del_snat_prefix_reply_t;
#define VL_API_CNAT_TRANSLATION_UPDATE_CRC "cnat_translation_update_e35382b3"
#define VL_API_CNAT_TRANSLATION_UPDATE_REPLY_CRC "cnat_translation_update_reply_e2fc8294"
#define VL_API_CNAT_TRANSLATION_DEL_CRC "cnat_translation_del_3a91bde5"
#define VL_API_CNAT_TRANSLATION_DEL_REPLY_CRC "cnat_translation_del_reply_e8d4e804"
#define VL_API_CNAT_TRANSLATION_DETAILS_CRC "cnat_translation_details_4ca67cb9"
#define VL_API_CNAT_TRANSLATION_DUMP_CRC "cnat_translation_dump_51077d14"
#define VL_API_CNAT_SESSION_PURGE_CRC "cnat_session_purge_51077d14"
#define VL_API_CNAT_SESSION_PURGE_REPLY_CRC "cnat_session_purge_reply_e8d4e804"
#define VL_API_CNAT_SESSION_DETAILS_CRC "cnat_session_details_6cb91175"
#define VL_API_CNAT_SESSION_DUMP_CRC "cnat_session_dump_51077d14"
#define VL_API_CNAT_SET_SNAT_ADDRESSES_CRC "cnat_set_snat_addresses_d997e96c"
#define VL_API_CNAT_SET_SNAT_ADDRESSES_REPLY_CRC "cnat_set_snat_addresses_reply_e8d4e804"
#define VL_API_CNAT_GET_SNAT_ADDRESSES_CRC "cnat_get_snat_addresses_51077d14"
#define VL_API_CNAT_GET_SNAT_ADDRESSES_REPLY_CRC "cnat_get_snat_addresses_reply_879513c1"
#define VL_API_CNAT_ADD_DEL_SNAT_PREFIX_CRC "cnat_add_del_snat_prefix_e26dd79a"
#define VL_API_CNAT_ADD_DEL_SNAT_PREFIX_REPLY_CRC "cnat_add_del_snat_prefix_reply_e8d4e804"

#endif
